// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IAnchornav}.
 */
/*package*/ class IAnchornavUpdater implements SmartUpdater {
	private final IAnchornav.Builder builder = new IAnchornav.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IAnchornav#withId(java.lang.String)
	 */
	public IAnchornav.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IAnchornav#withVisible(boolean)
	 */
	public IAnchornav.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IAnchornav#withMold(java.lang.String)
	 */
	public IAnchornav.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IAnchornav#withLeft(java.lang.String)
	 */
	public IAnchornav.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IAnchornav#withTop(java.lang.String)
	 */
	public IAnchornav.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IAnchornav#withZIndex(int)
	 */
	public IAnchornav.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IAnchornav#withHeight(java.lang.String)
	 */
	public IAnchornav.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IAnchornav#withWidth(java.lang.String)
	 */
	public IAnchornav.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IAnchornav#withTooltiptext(java.lang.String)
	 */
	public IAnchornav.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IAnchornav#withZclass(java.lang.String)
	 */
	public IAnchornav.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IAnchornav#withSclass(java.lang.String)
	 */
	public IAnchornav.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IAnchornav#withStyle(java.lang.String)
	 */
	public IAnchornav.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IAnchornav#withDraggable(java.lang.String)
	 */
	public IAnchornav.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IAnchornav#withFocus(boolean)
	 */
	public IAnchornav.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IAnchornav#withDroppable(java.lang.String)
	 */
	public IAnchornav.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IAnchornav#withVflex(java.lang.String)
	 */
	public IAnchornav.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IAnchornav#withHflex(java.lang.String)
	 */
	public IAnchornav.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IAnchornav#withRenderdefer(int)
	 */
	public IAnchornav.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IAnchornav#withClientAction(java.lang.String)
	 */
	public IAnchornav.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IAnchornav#withTabindex(java.lang.Integer)
	 */
	public IAnchornav.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IAnchornav#withCtrlKeys(java.lang.String)
	 */
	public IAnchornav.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IAnchornav#withContext(java.lang.String)
	 */
	public IAnchornav.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IAnchornav#withPopup(java.lang.String)
	 */
	public IAnchornav.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IAnchornav#withTooltip(java.lang.String)
	 */
	public IAnchornav.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IAnchornav#withWidgetClass(java.lang.String)
	 */
	public IAnchornav.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code name} to update to client widget
	 *
	 * @param name The new value for {@code name}
	 * @see IAnchornav#withName(java.lang.String)
	 */
	public IAnchornav.Updater name(java.lang.String name) {
		keys.add("name");
		builder.setName(name);
		return (IAnchornav.Updater) this;
	}

	/**
	 * Sets the given value of {@code positionFixed} to update to client widget
	 *
	 * @param positionFixed The new value for {@code positionFixed}
	 * @see IAnchornav#withPositionFixed(boolean)
	 */
	public IAnchornav.Updater positionFixed(boolean positionFixed) {
		keys.add("positionFixed");
		builder.setPositionFixed(positionFixed);
		return (IAnchornav.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
