// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IArea}.
 */
/*package*/ class IAreaUpdater implements SmartUpdater {
	private final IArea.Builder builder = new IArea.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IArea#withId(java.lang.String)
	 */
	public IArea.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IArea.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IArea#withVisible(boolean)
	 */
	public IArea.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IArea.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IArea#withMold(java.lang.String)
	 */
	public IArea.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IArea.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IArea#withWidgetClass(java.lang.String)
	 */
	public IArea.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IArea.Updater) this;
	}

	/**
	 * Sets the given value of {@code coords} to update to client widget
	 *
	 * @param coords The new value for {@code coords}
	 * @see IArea#withCoords(java.lang.String)
	 */
	public IArea.Updater coords(java.lang.String coords) {
		keys.add("coords");
		builder.setCoords(coords);
		return (IArea.Updater) this;
	}

	/**
	 * Sets the given value of {@code shape} to update to client widget
	 *
	 * @param shape The new value for {@code shape}
	 * @see IArea#withShape(java.lang.String)
	 */
	public IArea.Updater shape(java.lang.String shape) {
		keys.add("shape");
		builder.setShape(shape);
		return (IArea.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IArea#withTooltiptext(java.lang.String)
	 */
	public IArea.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IArea.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IArea#withTabindex(java.lang.Integer)
	 */
	public IArea.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IArea.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
