// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.sound.Audio;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IAudio}.
 */
/*package*/ class IAudioUpdater implements SmartUpdater {
	private final IAudio.Builder builder = new IAudio.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IAudio#withId(java.lang.String)
	 */
	public IAudio.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IAudio#withVisible(boolean)
	 */
	public IAudio.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IAudio#withMold(java.lang.String)
	 */
	public IAudio.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IAudio#withLeft(java.lang.String)
	 */
	public IAudio.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IAudio#withTop(java.lang.String)
	 */
	public IAudio.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IAudio#withZIndex(int)
	 */
	public IAudio.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IAudio#withHeight(java.lang.String)
	 */
	public IAudio.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IAudio#withWidth(java.lang.String)
	 */
	public IAudio.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IAudio#withTooltiptext(java.lang.String)
	 */
	public IAudio.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IAudio#withZclass(java.lang.String)
	 */
	public IAudio.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IAudio#withSclass(java.lang.String)
	 */
	public IAudio.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IAudio#withStyle(java.lang.String)
	 */
	public IAudio.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IAudio#withDraggable(java.lang.String)
	 */
	public IAudio.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IAudio#withFocus(boolean)
	 */
	public IAudio.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IAudio#withDroppable(java.lang.String)
	 */
	public IAudio.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IAudio#withVflex(java.lang.String)
	 */
	public IAudio.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IAudio#withHflex(java.lang.String)
	 */
	public IAudio.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IAudio#withRenderdefer(int)
	 */
	public IAudio.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IAudio#withClientAction(java.lang.String)
	 */
	public IAudio.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IAudio#withTabindex(java.lang.Integer)
	 */
	public IAudio.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IAudio#withCtrlKeys(java.lang.String)
	 */
	public IAudio.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IAudio#withContext(java.lang.String)
	 */
	public IAudio.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IAudio#withPopup(java.lang.String)
	 */
	public IAudio.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IAudio#withTooltip(java.lang.String)
	 */
	public IAudio.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IAudio#withWidgetClass(java.lang.String)
	 */
	public IAudio.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code preload} to update to client widget
	 *
	 * @param preload The new value for {@code preload}
	 * @see IAudio#withPreload(java.lang.String)
	 */
	public IAudio.Updater preload(java.lang.String preload) {
		keys.add("preload");
		builder.setPreload(preload);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code content} to update to client widget
	 *
	 * @param content The new value for {@code content}
	 * @see IAudio#withContent(org.zkoss.sound.Audio)
	 */
	public IAudio.Updater content(Audio content) {
		keys.add("content");
		builder.setContent(content);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code autoplay} to update to client widget
	 *
	 * @param autoplay The new value for {@code autoplay}
	 * @see IAudio#withAutoplay(boolean)
	 */
	public IAudio.Updater autoplay(boolean autoplay) {
		keys.add("autoplay");
		builder.setAutoplay(autoplay);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code controls} to update to client widget
	 *
	 * @param controls The new value for {@code controls}
	 * @see IAudio#withControls(boolean)
	 */
	public IAudio.Updater controls(boolean controls) {
		keys.add("controls");
		builder.setControls(controls);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code loop} to update to client widget
	 *
	 * @param loop The new value for {@code loop}
	 * @see IAudio#withLoop(boolean)
	 */
	public IAudio.Updater loop(boolean loop) {
		keys.add("loop");
		builder.setLoop(loop);
		return (IAudio.Updater) this;
	}

	/**
	 * Sets the given value of {@code muted} to update to client widget
	 *
	 * @param muted The new value for {@code muted}
	 * @see IAudio#withMuted(boolean)
	 */
	public IAudio.Updater muted(boolean muted) {
		keys.add("muted");
		builder.setMuted(muted);
		return (IAudio.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
