// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IBandbox}.
 */
/*package*/ class IBandboxUpdater implements SmartUpdater {
	private final IBandbox.Builder builder = new IBandbox.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IBandbox#withId(java.lang.String)
	 */
	public IBandbox.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IBandbox#withVisible(boolean)
	 */
	public IBandbox.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IBandbox#withMold(java.lang.String)
	 */
	public IBandbox.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IBandbox#withLeft(java.lang.String)
	 */
	public IBandbox.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IBandbox#withTop(java.lang.String)
	 */
	public IBandbox.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IBandbox#withZIndex(int)
	 */
	public IBandbox.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IBandbox#withHeight(java.lang.String)
	 */
	public IBandbox.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IBandbox#withWidth(java.lang.String)
	 */
	public IBandbox.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IBandbox#withTooltiptext(java.lang.String)
	 */
	public IBandbox.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IBandbox#withZclass(java.lang.String)
	 */
	public IBandbox.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IBandbox#withSclass(java.lang.String)
	 */
	public IBandbox.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IBandbox#withStyle(java.lang.String)
	 */
	public IBandbox.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IBandbox#withDraggable(java.lang.String)
	 */
	public IBandbox.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IBandbox#withFocus(boolean)
	 */
	public IBandbox.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IBandbox#withDroppable(java.lang.String)
	 */
	public IBandbox.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IBandbox#withVflex(java.lang.String)
	 */
	public IBandbox.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IBandbox#withHflex(java.lang.String)
	 */
	public IBandbox.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IBandbox#withRenderdefer(int)
	 */
	public IBandbox.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IBandbox#withClientAction(java.lang.String)
	 */
	public IBandbox.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IBandbox#withTabindex(java.lang.Integer)
	 */
	public IBandbox.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IBandbox#withCtrlKeys(java.lang.String)
	 */
	public IBandbox.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IBandbox#withContext(java.lang.String)
	 */
	public IBandbox.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IBandbox#withPopup(java.lang.String)
	 */
	public IBandbox.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IBandbox#withTooltip(java.lang.String)
	 */
	public IBandbox.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code readonly} to update to client widget
	 *
	 * @param readonly The new value for {@code readonly}
	 * @see IBandbox#withReadonly(boolean)
	 */
	public IBandbox.Updater readonly(boolean readonly) {
		keys.add("readonly");
		builder.setReadonly(readonly);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code name} to update to client widget
	 *
	 * @param name The new value for {@code name}
	 * @see IBandbox#withName(java.lang.String)
	 */
	public IBandbox.Updater name(java.lang.String name) {
		keys.add("name");
		builder.setName(name);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code placeholder} to update to client widget
	 *
	 * @param placeholder The new value for {@code placeholder}
	 * @see IBandbox#withPlaceholder(java.lang.String)
	 */
	public IBandbox.Updater placeholder(java.lang.String placeholder) {
		keys.add("placeholder");
		builder.setPlaceholder(placeholder);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code value} to update to client widget
	 *
	 * @param value The new value for {@code value}
	 * @see IBandbox#withValue(java.lang.String)
	 */
	public IBandbox.Updater value(java.lang.String value) {
		keys.add("value");
		builder.setValue(value);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code constraint} to update to client widget
	 *
	 * @param constraint The new value for {@code constraint}
	 * @see IBandbox#withConstraint(java.lang.String)
	 */
	public IBandbox.Updater constraint(java.lang.String constraint) {
		keys.add("constraint");
		builder.setConstraint(constraint);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorboxSclass} to update to client widget
	 *
	 * @param errorboxSclass The new value for {@code errorboxSclass}
	 * @see IBandbox#withErrorboxSclass(java.lang.String)
	 */
	public IBandbox.Updater errorboxSclass(java.lang.String errorboxSclass) {
		keys.add("errorboxSclass");
		builder.setErrorboxSclass(errorboxSclass);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorboxIconSclass} to update to client widget
	 *
	 * @param errorboxIconSclass The new value for {@code errorboxIconSclass}
	 * @see IBandbox#withErrorboxIconSclass(java.lang.String)
	 */
	public IBandbox.Updater errorboxIconSclass(java.lang.String errorboxIconSclass) {
		keys.add("errorboxIconSclass");
		builder.setErrorboxIconSclass(errorboxIconSclass);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see IBandbox#withDisabled(boolean)
	 */
	public IBandbox.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code inplace} to update to client widget
	 *
	 * @param inplace The new value for {@code inplace}
	 * @see IBandbox#withInplace(boolean)
	 */
	public IBandbox.Updater inplace(boolean inplace) {
		keys.add("inplace");
		builder.setInplace(inplace);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code maxlength} to update to client widget
	 *
	 * @param maxlength The new value for {@code maxlength}
	 * @see IBandbox#withMaxlength(int)
	 */
	public IBandbox.Updater maxlength(int maxlength) {
		keys.add("maxlength");
		builder.setMaxlength(maxlength);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code cols} to update to client widget
	 *
	 * @param cols The new value for {@code cols}
	 * @see IBandbox#withCols(int)
	 */
	public IBandbox.Updater cols(int cols) {
		keys.add("cols");
		builder.setCols(cols);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code instant} to update to client widget
	 *
	 * @param instant The new value for {@code instant}
	 * @see IBandbox#withInstant(boolean)
	 */
	public IBandbox.Updater instant(boolean instant) {
		keys.add("instant");
		builder.setInstant(instant);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorMessage} to update to client widget
	 *
	 * @param errorMessage The new value for {@code errorMessage}
	 * @see IBandbox#withErrorMessage(java.lang.String)
	 */
	public IBandbox.Updater errorMessage(java.lang.String errorMessage) {
		keys.add("errorMessage");
		builder.setErrorMessage(errorMessage);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code multiline} to update to client widget
	 *
	 * @param multiline The new value for {@code multiline}
	 * @see IBandbox#withMultiline(boolean)
	 */
	public IBandbox.Updater multiline(boolean multiline) {
		keys.add("multiline");
		builder.setMultiline(multiline);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code rows} to update to client widget
	 *
	 * @param rows The new value for {@code rows}
	 * @see IBandbox#withRows(int)
	 */
	public IBandbox.Updater rows(int rows) {
		keys.add("rows");
		builder.setRows(rows);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabbable} to update to client widget
	 *
	 * @param tabbable The new value for {@code tabbable}
	 * @see IBandbox#withTabbable(boolean)
	 */
	public IBandbox.Updater tabbable(boolean tabbable) {
		keys.add("tabbable");
		builder.setTabbable(tabbable);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code type} to update to client widget
	 *
	 * @param type The new value for {@code type}
	 * @see IBandbox#withType(java.lang.String)
	 */
	public IBandbox.Updater type(java.lang.String type) {
		keys.add("type");
		builder.setType(type);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code submitByEnter} to update to client widget
	 *
	 * @param submitByEnter The new value for {@code submitByEnter}
	 * @see IBandbox#withSubmitByEnter(boolean)
	 */
	public IBandbox.Updater submitByEnter(boolean submitByEnter) {
		keys.add("submitByEnter");
		builder.setSubmitByEnter(submitByEnter);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IBandbox#withWidgetClass(java.lang.String)
	 */
	public IBandbox.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code popupWidth} to update to client widget
	 *
	 * @param popupWidth The new value for {@code popupWidth}
	 * @see IBandbox#withPopupWidth(java.lang.String)
	 */
	public IBandbox.Updater popupWidth(java.lang.String popupWidth) {
		keys.add("popupWidth");
		builder.setPopupWidth(popupWidth);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code autodrop} to update to client widget
	 *
	 * @param autodrop The new value for {@code autodrop}
	 * @see IBandbox#withAutodrop(boolean)
	 */
	public IBandbox.Updater autodrop(boolean autodrop) {
		keys.add("autodrop");
		builder.setAutodrop(autodrop);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code buttonVisible} to update to client widget
	 *
	 * @param buttonVisible The new value for {@code buttonVisible}
	 * @see IBandbox#withButtonVisible(boolean)
	 */
	public IBandbox.Updater buttonVisible(boolean buttonVisible) {
		keys.add("buttonVisible");
		builder.setButtonVisible(buttonVisible);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconSclass} to update to client widget
	 *
	 * @param iconSclass The new value for {@code iconSclass}
	 * @see IBandbox#withIconSclass(java.lang.String)
	 */
	public IBandbox.Updater iconSclass(java.lang.String iconSclass) {
		keys.add("iconSclass");
		builder.setIconSclass(iconSclass);
		return (IBandbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code open} to update to client widget
	 *
	 * @param open The new value for {@code open}
	 * @see IBandbox#withOpen(boolean)
	 */
	public IBandbox.Updater open(boolean open) {
		keys.add("open");
		builder.setOpen(open);
		return (IBandbox.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
