// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IBarcode}.
 */
/*package*/ class IBarcodeUpdater implements SmartUpdater {
	private final IBarcode.Builder builder = new IBarcode.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IBarcode#withId(java.lang.String)
	 */
	public IBarcode.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IBarcode#withVisible(boolean)
	 */
	public IBarcode.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IBarcode#withMold(java.lang.String)
	 */
	public IBarcode.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IBarcode#withLeft(java.lang.String)
	 */
	public IBarcode.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IBarcode#withTop(java.lang.String)
	 */
	public IBarcode.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IBarcode#withZIndex(int)
	 */
	public IBarcode.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IBarcode#withHeight(java.lang.String)
	 */
	public IBarcode.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IBarcode#withWidth(java.lang.String)
	 */
	public IBarcode.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IBarcode#withTooltiptext(java.lang.String)
	 */
	public IBarcode.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IBarcode#withZclass(java.lang.String)
	 */
	public IBarcode.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IBarcode#withSclass(java.lang.String)
	 */
	public IBarcode.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IBarcode#withStyle(java.lang.String)
	 */
	public IBarcode.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IBarcode#withDraggable(java.lang.String)
	 */
	public IBarcode.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IBarcode#withFocus(boolean)
	 */
	public IBarcode.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IBarcode#withDroppable(java.lang.String)
	 */
	public IBarcode.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IBarcode#withVflex(java.lang.String)
	 */
	public IBarcode.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IBarcode#withHflex(java.lang.String)
	 */
	public IBarcode.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IBarcode#withRenderdefer(int)
	 */
	public IBarcode.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IBarcode#withClientAction(java.lang.String)
	 */
	public IBarcode.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IBarcode#withTabindex(java.lang.Integer)
	 */
	public IBarcode.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IBarcode#withCtrlKeys(java.lang.String)
	 */
	public IBarcode.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IBarcode#withContext(java.lang.String)
	 */
	public IBarcode.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IBarcode#withPopup(java.lang.String)
	 */
	public IBarcode.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IBarcode#withTooltip(java.lang.String)
	 */
	public IBarcode.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IBarcode#withWidgetClass(java.lang.String)
	 */
	public IBarcode.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code type} to update to client widget
	 *
	 * @param type The new value for {@code type}
	 * @see IBarcode#withType(java.lang.String)
	 */
	public IBarcode.Updater type(java.lang.String type) {
		keys.add("type");
		builder.setType(type);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code displayValue} to update to client widget
	 *
	 * @param displayValue The new value for {@code displayValue}
	 * @see IBarcode#withDisplayValue(boolean)
	 */
	public IBarcode.Updater displayValue(boolean displayValue) {
		keys.add("displayValue");
		builder.setDisplayValue(displayValue);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code value} to update to client widget
	 *
	 * @param value The new value for {@code value}
	 * @see IBarcode#withValue(java.lang.String)
	 */
	public IBarcode.Updater value(java.lang.String value) {
		keys.add("value");
		builder.setValue(value);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code fontSize} to update to client widget
	 *
	 * @param fontSize The new value for {@code fontSize}
	 * @see IBarcode#withFontSize(int)
	 */
	public IBarcode.Updater fontSize(int fontSize) {
		keys.add("fontSize");
		builder.setFontSize(fontSize);
		return (IBarcode.Updater) this;
	}

	/**
	 * Sets the given value of {@code barWidth} to update to client widget
	 *
	 * @param barWidth The new value for {@code barWidth}
	 * @see IBarcode#withBarWidth(int)
	 */
	public IBarcode.Updater barWidth(int barWidth) {
		keys.add("barWidth");
		builder.setBarWidth(barWidth);
		return (IBarcode.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
