// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IBarcodescanner}.
 */
/*package*/ class IBarcodescannerUpdater implements SmartUpdater {
	private final IBarcodescanner.Builder builder = new IBarcodescanner.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IBarcodescanner#withId(java.lang.String)
	 */
	public IBarcodescanner.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IBarcodescanner#withVisible(boolean)
	 */
	public IBarcodescanner.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IBarcodescanner#withMold(java.lang.String)
	 */
	public IBarcodescanner.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IBarcodescanner#withLeft(java.lang.String)
	 */
	public IBarcodescanner.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IBarcodescanner#withTop(java.lang.String)
	 */
	public IBarcodescanner.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IBarcodescanner#withZIndex(int)
	 */
	public IBarcodescanner.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IBarcodescanner#withHeight(java.lang.String)
	 */
	public IBarcodescanner.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IBarcodescanner#withWidth(java.lang.String)
	 */
	public IBarcodescanner.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IBarcodescanner#withTooltiptext(java.lang.String)
	 */
	public IBarcodescanner.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IBarcodescanner#withZclass(java.lang.String)
	 */
	public IBarcodescanner.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IBarcodescanner#withSclass(java.lang.String)
	 */
	public IBarcodescanner.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IBarcodescanner#withStyle(java.lang.String)
	 */
	public IBarcodescanner.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IBarcodescanner#withDraggable(java.lang.String)
	 */
	public IBarcodescanner.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IBarcodescanner#withFocus(boolean)
	 */
	public IBarcodescanner.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IBarcodescanner#withDroppable(java.lang.String)
	 */
	public IBarcodescanner.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IBarcodescanner#withVflex(java.lang.String)
	 */
	public IBarcodescanner.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IBarcodescanner#withHflex(java.lang.String)
	 */
	public IBarcodescanner.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IBarcodescanner#withRenderdefer(int)
	 */
	public IBarcodescanner.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IBarcodescanner#withClientAction(java.lang.String)
	 */
	public IBarcodescanner.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IBarcodescanner#withTabindex(java.lang.Integer)
	 */
	public IBarcodescanner.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IBarcodescanner#withCtrlKeys(java.lang.String)
	 */
	public IBarcodescanner.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IBarcodescanner#withContext(java.lang.String)
	 */
	public IBarcodescanner.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IBarcodescanner#withPopup(java.lang.String)
	 */
	public IBarcodescanner.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IBarcodescanner#withTooltip(java.lang.String)
	 */
	public IBarcodescanner.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IBarcodescanner#withWidgetClass(java.lang.String)
	 */
	public IBarcodescanner.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code type} to update to client widget
	 *
	 * @param type The new value for {@code type}
	 * @see IBarcodescanner#withType(java.lang.String)
	 */
	public IBarcodescanner.Updater type(java.lang.String type) {
		keys.add("type");
		builder.setType(type);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code interval} to update to client widget
	 *
	 * @param interval The new value for {@code interval}
	 * @see IBarcodescanner#withInterval(double)
	 */
	public IBarcodescanner.Updater interval(double interval) {
		keys.add("interval");
		builder.setInterval(interval);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code consistencyBufferSize} to update to client widget
	 *
	 * @param consistencyBufferSize The new value for {@code consistencyBufferSize}
	 * @see IBarcodescanner#withConsistencyBufferSize(int)
	 */
	public IBarcodescanner.Updater consistencyBufferSize(int consistencyBufferSize) {
		keys.add("consistencyBufferSize");
		builder.setConsistencyBufferSize(consistencyBufferSize);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code consistencyThreshold} to update to client widget
	 *
	 * @param consistencyThreshold The new value for {@code consistencyThreshold}
	 * @see IBarcodescanner#withConsistencyThreshold(int)
	 */
	public IBarcodescanner.Updater consistencyThreshold(int consistencyThreshold) {
		keys.add("consistencyThreshold");
		builder.setConsistencyThreshold(consistencyThreshold);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorAcceptance} to update to client widget
	 *
	 * @param errorAcceptance The new value for {@code errorAcceptance}
	 * @see IBarcodescanner#withErrorAcceptance(double)
	 */
	public IBarcodescanner.Updater errorAcceptance(double errorAcceptance) {
		keys.add("errorAcceptance");
		builder.setErrorAcceptance(errorAcceptance);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code continuous} to update to client widget
	 *
	 * @param continuous The new value for {@code continuous}
	 * @see IBarcodescanner#withContinuous(boolean)
	 */
	public IBarcodescanner.Updater continuous(boolean continuous) {
		keys.add("continuous");
		builder.setContinuous(continuous);
		return (IBarcodescanner.Updater) this;
	}

	/**
	 * Sets the given value of {@code enable} to update to client widget
	 *
	 * @param enable The new value for {@code enable}
	 * @see IBarcodescanner#withEnable(boolean)
	 */
	public IBarcodescanner.Updater enable(boolean enable) {
		keys.add("enable");
		builder.setEnable(enable);
		return (IBarcodescanner.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
