// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IBiglistbox}.
 */
/*package*/ class IBiglistboxUpdater implements SmartUpdater {
	private final IBiglistbox.Builder builder = new IBiglistbox.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IBiglistbox#withId(java.lang.String)
	 */
	public IBiglistbox.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IBiglistbox#withVisible(boolean)
	 */
	public IBiglistbox.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IBiglistbox#withMold(java.lang.String)
	 */
	public IBiglistbox.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IBiglistbox#withLeft(java.lang.String)
	 */
	public IBiglistbox.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IBiglistbox#withTop(java.lang.String)
	 */
	public IBiglistbox.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IBiglistbox#withZIndex(int)
	 */
	public IBiglistbox.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IBiglistbox#withHeight(java.lang.String)
	 */
	public IBiglistbox.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IBiglistbox#withWidth(java.lang.String)
	 */
	public IBiglistbox.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IBiglistbox#withTooltiptext(java.lang.String)
	 */
	public IBiglistbox.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IBiglistbox#withZclass(java.lang.String)
	 */
	public IBiglistbox.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IBiglistbox#withSclass(java.lang.String)
	 */
	public IBiglistbox.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IBiglistbox#withStyle(java.lang.String)
	 */
	public IBiglistbox.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IBiglistbox#withDraggable(java.lang.String)
	 */
	public IBiglistbox.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IBiglistbox#withFocus(boolean)
	 */
	public IBiglistbox.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IBiglistbox#withDroppable(java.lang.String)
	 */
	public IBiglistbox.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IBiglistbox#withVflex(java.lang.String)
	 */
	public IBiglistbox.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IBiglistbox#withHflex(java.lang.String)
	 */
	public IBiglistbox.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IBiglistbox#withRenderdefer(int)
	 */
	public IBiglistbox.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IBiglistbox#withClientAction(java.lang.String)
	 */
	public IBiglistbox.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IBiglistbox#withTabindex(java.lang.Integer)
	 */
	public IBiglistbox.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IBiglistbox#withCtrlKeys(java.lang.String)
	 */
	public IBiglistbox.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IBiglistbox#withContext(java.lang.String)
	 */
	public IBiglistbox.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IBiglistbox#withPopup(java.lang.String)
	 */
	public IBiglistbox.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IBiglistbox#withTooltip(java.lang.String)
	 */
	public IBiglistbox.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IBiglistbox#withWidgetClass(java.lang.String)
	 */
	public IBiglistbox.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code autoCols} to update to client widget
	 *
	 * @param autoCols The new value for {@code autoCols}
	 * @see IBiglistbox#withAutoCols(boolean)
	 */
	public IBiglistbox.Updater autoCols(boolean autoCols) {
		keys.add("autoCols");
		builder.setAutoCols(autoCols);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code autoRows} to update to client widget
	 *
	 * @param autoRows The new value for {@code autoRows}
	 * @see IBiglistbox#withAutoRows(boolean)
	 */
	public IBiglistbox.Updater autoRows(boolean autoRows) {
		keys.add("autoRows");
		builder.setAutoRows(autoRows);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code frozenCols} to update to client widget
	 *
	 * @param frozenCols The new value for {@code frozenCols}
	 * @see IBiglistbox#withFrozenCols(int)
	 */
	public IBiglistbox.Updater frozenCols(int frozenCols) {
		keys.add("frozenCols");
		builder.setFrozenCols(frozenCols);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code fixFrozenCols} to update to client widget
	 *
	 * @param fixFrozenCols The new value for {@code fixFrozenCols}
	 * @see IBiglistbox#withFixFrozenCols(boolean)
	 */
	public IBiglistbox.Updater fixFrozenCols(boolean fixFrozenCols) {
		keys.add("fixFrozenCols");
		builder.setFixFrozenCols(fixFrozenCols);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code oddRowSclass} to update to client widget
	 *
	 * @param oddRowSclass The new value for {@code oddRowSclass}
	 * @see IBiglistbox#withOddRowSclass(java.lang.String)
	 */
	public IBiglistbox.Updater oddRowSclass(java.lang.String oddRowSclass) {
		keys.add("oddRowSclass");
		builder.setOddRowSclass(oddRowSclass);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code preloadSize} to update to client widget
	 *
	 * @param preloadSize The new value for {@code preloadSize}
	 * @see IBiglistbox#withPreloadSize(int)
	 */
	public IBiglistbox.Updater preloadSize(int preloadSize) {
		keys.add("preloadSize");
		builder.setPreloadSize(preloadSize);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code rows} to update to client widget
	 *
	 * @param rows The new value for {@code rows}
	 * @see IBiglistbox#withRows(int)
	 */
	public IBiglistbox.Updater rows(int rows) {
		keys.add("rows");
		builder.setRows(rows);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code cols} to update to client widget
	 *
	 * @param cols The new value for {@code cols}
	 * @see IBiglistbox#withCols(int)
	 */
	public IBiglistbox.Updater cols(int cols) {
		keys.add("cols");
		builder.setCols(cols);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code rowHeight} to update to client widget
	 *
	 * @param rowHeight The new value for {@code rowHeight}
	 * @see IBiglistbox#withRowHeight(java.lang.String)
	 */
	public IBiglistbox.Updater rowHeight(java.lang.String rowHeight) {
		keys.add("rowHeight");
		builder.setRowHeight(rowHeight);
		return (IBiglistbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code colWidth} to update to client widget
	 *
	 * @param colWidth The new value for {@code colWidth}
	 * @see IBiglistbox#withColWidth(java.lang.String)
	 */
	public IBiglistbox.Updater colWidth(java.lang.String colWidth) {
		keys.add("colWidth");
		builder.setColWidth(colWidth);
		return (IBiglistbox.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
