// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IButton}.
 */
/*package*/ class IButtonUpdater implements SmartUpdater {
	private final IButton.Builder builder = new IButton.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IButton#withId(java.lang.String)
	 */
	public IButton.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IButton#withVisible(boolean)
	 */
	public IButton.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IButton#withMold(java.lang.String)
	 */
	public IButton.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IButton#withLeft(java.lang.String)
	 */
	public IButton.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IButton#withTop(java.lang.String)
	 */
	public IButton.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IButton#withZIndex(int)
	 */
	public IButton.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IButton#withHeight(java.lang.String)
	 */
	public IButton.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IButton#withWidth(java.lang.String)
	 */
	public IButton.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IButton#withTooltiptext(java.lang.String)
	 */
	public IButton.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IButton#withZclass(java.lang.String)
	 */
	public IButton.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IButton#withSclass(java.lang.String)
	 */
	public IButton.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IButton#withStyle(java.lang.String)
	 */
	public IButton.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IButton#withDraggable(java.lang.String)
	 */
	public IButton.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IButton#withFocus(boolean)
	 */
	public IButton.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IButton#withDroppable(java.lang.String)
	 */
	public IButton.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IButton#withVflex(java.lang.String)
	 */
	public IButton.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IButton#withHflex(java.lang.String)
	 */
	public IButton.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IButton#withRenderdefer(int)
	 */
	public IButton.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IButton#withClientAction(java.lang.String)
	 */
	public IButton.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IButton#withTabindex(java.lang.Integer)
	 */
	public IButton.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IButton#withCtrlKeys(java.lang.String)
	 */
	public IButton.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IButton#withContext(java.lang.String)
	 */
	public IButton.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IButton#withPopup(java.lang.String)
	 */
	public IButton.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IButton#withTooltip(java.lang.String)
	 */
	public IButton.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code label} to update to client widget
	 *
	 * @param label The new value for {@code label}
	 * @see IButton#withLabel(java.lang.String)
	 */
	public IButton.Updater label(java.lang.String label) {
		keys.add("label");
		builder.setLabel(label);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconSclass} to update to client widget
	 *
	 * @param iconSclass The new value for {@code iconSclass}
	 * @see IButton#withIconSclass(java.lang.String)
	 */
	public IButton.Updater iconSclass(java.lang.String iconSclass) {
		keys.add("iconSclass");
		builder.setIconSclass(iconSclass);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconSclasses} to update to client widget
	 *
	 * @param iconSclasses The new value for {@code iconSclasses}
	 * @see IButton#withIconSclasses(java.lang.String[])
	 */
	public IButton.Updater iconSclasses(java.lang.String[] iconSclasses) {
		keys.add("iconSclasses");
		builder.setIconSclasses(iconSclasses);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconTooltip} to update to client widget
	 *
	 * @param iconTooltip The new value for {@code iconTooltip}
	 * @see IButton#withIconTooltip(java.lang.String)
	 */
	public IButton.Updater iconTooltip(java.lang.String iconTooltip) {
		keys.add("iconTooltip");
		builder.setIconTooltip(iconTooltip);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconTooltips} to update to client widget
	 *
	 * @param iconTooltips The new value for {@code iconTooltips}
	 * @see IButton#withIconTooltips(java.lang.String[])
	 */
	public IButton.Updater iconTooltips(java.lang.String[] iconTooltips) {
		keys.add("iconTooltips");
		builder.setIconTooltips(iconTooltips);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code image} to update to client widget
	 *
	 * @param image The new value for {@code image}
	 * @see IButton#withImage(java.lang.String)
	 */
	public IButton.Updater image(java.lang.String image) {
		keys.add("image");
		builder.setImage(image);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code hoverImage} to update to client widget
	 *
	 * @param hoverImage The new value for {@code hoverImage}
	 * @see IButton#withHoverImage(java.lang.String)
	 */
	public IButton.Updater hoverImage(java.lang.String hoverImage) {
		keys.add("hoverImage");
		builder.setHoverImage(hoverImage);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code preloadImage} to update to client widget
	 *
	 * @param preloadImage The new value for {@code preloadImage}
	 * @see IButton#withPreloadImage(boolean)
	 */
	public IButton.Updater preloadImage(boolean preloadImage) {
		keys.add("preloadImage");
		builder.setPreloadImage(preloadImage);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code dir} to update to client widget
	 *
	 * @param dir The new value for {@code dir}
	 * @see IButton#withDir(java.lang.String)
	 */
	public IButton.Updater dir(java.lang.String dir) {
		keys.add("dir");
		builder.setDir(dir);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code orient} to update to client widget
	 *
	 * @param orient The new value for {@code orient}
	 * @see IButton#withOrient(java.lang.String)
	 */
	public IButton.Updater orient(java.lang.String orient) {
		keys.add("orient");
		builder.setOrient(orient);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code type} to update to client widget
	 *
	 * @param type The new value for {@code type}
	 * @see IButton#withType(java.lang.String)
	 */
	public IButton.Updater type(java.lang.String type) {
		keys.add("type");
		builder.setType(type);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see IButton#withDisabled(boolean)
	 */
	public IButton.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code autodisable} to update to client widget
	 *
	 * @param autodisable The new value for {@code autodisable}
	 * @see IButton#withAutodisable(java.lang.String)
	 */
	public IButton.Updater autodisable(java.lang.String autodisable) {
		keys.add("autodisable");
		builder.setAutodisable(autodisable);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code target} to update to client widget
	 *
	 * @param target The new value for {@code target}
	 * @see IButton#withTarget(java.lang.String)
	 */
	public IButton.Updater target(java.lang.String target) {
		keys.add("target");
		builder.setTarget(target);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code upload} to update to client widget
	 *
	 * @param upload The new value for {@code upload}
	 * @see IButton#withUpload(java.lang.String)
	 */
	public IButton.Updater upload(java.lang.String upload) {
		keys.add("upload");
		builder.setUpload(upload);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code href} to update to client widget
	 *
	 * @param href The new value for {@code href}
	 * @see IButton#withHref(java.lang.String)
	 */
	public IButton.Updater href(java.lang.String href) {
		keys.add("href");
		builder.setHref(href);
		return (IButton.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IButton#withWidgetClass(java.lang.String)
	 */
	public IButton.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IButton.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
