// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.Date;
import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ICalendar}.
 */
/*package*/ class ICalendarUpdater implements SmartUpdater {
	private final ICalendar.Builder builder = new ICalendar.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ICalendar#withId(java.lang.String)
	 */
	public ICalendar.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ICalendar#withVisible(boolean)
	 */
	public ICalendar.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ICalendar#withMold(java.lang.String)
	 */
	public ICalendar.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ICalendar#withLeft(java.lang.String)
	 */
	public ICalendar.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ICalendar#withTop(java.lang.String)
	 */
	public ICalendar.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ICalendar#withZIndex(int)
	 */
	public ICalendar.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ICalendar#withHeight(java.lang.String)
	 */
	public ICalendar.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see ICalendar#withWidth(java.lang.String)
	 */
	public ICalendar.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ICalendar#withTooltiptext(java.lang.String)
	 */
	public ICalendar.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ICalendar#withZclass(java.lang.String)
	 */
	public ICalendar.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ICalendar#withSclass(java.lang.String)
	 */
	public ICalendar.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ICalendar#withStyle(java.lang.String)
	 */
	public ICalendar.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ICalendar#withDraggable(java.lang.String)
	 */
	public ICalendar.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ICalendar#withFocus(boolean)
	 */
	public ICalendar.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ICalendar#withDroppable(java.lang.String)
	 */
	public ICalendar.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ICalendar#withVflex(java.lang.String)
	 */
	public ICalendar.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see ICalendar#withHflex(java.lang.String)
	 */
	public ICalendar.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ICalendar#withRenderdefer(int)
	 */
	public ICalendar.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ICalendar#withClientAction(java.lang.String)
	 */
	public ICalendar.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ICalendar#withTabindex(java.lang.Integer)
	 */
	public ICalendar.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see ICalendar#withCtrlKeys(java.lang.String)
	 */
	public ICalendar.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see ICalendar#withContext(java.lang.String)
	 */
	public ICalendar.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see ICalendar#withPopup(java.lang.String)
	 */
	public ICalendar.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see ICalendar#withTooltip(java.lang.String)
	 */
	public ICalendar.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ICalendar#withWidgetClass(java.lang.String)
	 */
	public ICalendar.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code constraint} to update to client widget
	 *
	 * @param constraint The new value for {@code constraint}
	 * @see ICalendar#withConstraint(java.lang.String)
	 */
	public ICalendar.Updater constraint(java.lang.String constraint) {
		keys.add("constraint");
		builder.setConstraint(constraint);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code name} to update to client widget
	 *
	 * @param name The new value for {@code name}
	 * @see ICalendar#withName(java.lang.String)
	 */
	public ICalendar.Updater name(java.lang.String name) {
		keys.add("name");
		builder.setName(name);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code value} to update to client widget
	 *
	 * @param value The new value for {@code value}
	 * @see ICalendar#withValue(java.util.Date)
	 */
	public ICalendar.Updater value(Date value) {
		keys.add("value");
		builder.setValue(value);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code weekOfYear} to update to client widget
	 *
	 * @param weekOfYear The new value for {@code weekOfYear}
	 * @see ICalendar#withWeekOfYear(boolean)
	 */
	public ICalendar.Updater weekOfYear(boolean weekOfYear) {
		keys.add("weekOfYear");
		builder.setWeekOfYear(weekOfYear);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code showTodayLink} to update to client widget
	 *
	 * @param showTodayLink The new value for {@code showTodayLink}
	 * @see ICalendar#withShowTodayLink(boolean)
	 */
	public ICalendar.Updater showTodayLink(boolean showTodayLink) {
		keys.add("showTodayLink");
		builder.setShowTodayLink(showTodayLink);
		return (ICalendar.Updater) this;
	}

	/**
	 * Sets the given value of {@code todayLinkLabel} to update to client widget
	 *
	 * @param todayLinkLabel The new value for {@code todayLinkLabel}
	 * @see ICalendar#withTodayLinkLabel(java.lang.String)
	 */
	public ICalendar.Updater todayLinkLabel(java.lang.String todayLinkLabel) {
		keys.add("todayLinkLabel");
		builder.setTodayLinkLabel(todayLinkLabel);
		return (ICalendar.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
