// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ICamera}.
 */
/*package*/ class ICameraUpdater implements SmartUpdater {
	private final ICamera.Builder builder = new ICamera.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ICamera#withId(java.lang.String)
	 */
	public ICamera.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ICamera#withVisible(boolean)
	 */
	public ICamera.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ICamera#withMold(java.lang.String)
	 */
	public ICamera.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ICamera#withLeft(java.lang.String)
	 */
	public ICamera.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ICamera#withTop(java.lang.String)
	 */
	public ICamera.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ICamera#withZIndex(int)
	 */
	public ICamera.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ICamera#withHeight(java.lang.String)
	 */
	public ICamera.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see ICamera#withWidth(java.lang.String)
	 */
	public ICamera.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ICamera#withTooltiptext(java.lang.String)
	 */
	public ICamera.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ICamera#withZclass(java.lang.String)
	 */
	public ICamera.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ICamera#withSclass(java.lang.String)
	 */
	public ICamera.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ICamera#withStyle(java.lang.String)
	 */
	public ICamera.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ICamera#withDraggable(java.lang.String)
	 */
	public ICamera.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ICamera#withFocus(boolean)
	 */
	public ICamera.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ICamera#withDroppable(java.lang.String)
	 */
	public ICamera.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ICamera#withVflex(java.lang.String)
	 */
	public ICamera.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see ICamera#withHflex(java.lang.String)
	 */
	public ICamera.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ICamera#withRenderdefer(int)
	 */
	public ICamera.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ICamera#withClientAction(java.lang.String)
	 */
	public ICamera.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ICamera#withTabindex(java.lang.Integer)
	 */
	public ICamera.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see ICamera#withCtrlKeys(java.lang.String)
	 */
	public ICamera.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see ICamera#withContext(java.lang.String)
	 */
	public ICamera.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see ICamera#withPopup(java.lang.String)
	 */
	public ICamera.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see ICamera#withTooltip(java.lang.String)
	 */
	public ICamera.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ICamera#withWidgetClass(java.lang.String)
	 */
	public ICamera.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code snapshotFormat} to update to client widget
	 *
	 * @param snapshotFormat The new value for {@code snapshotFormat}
	 * @see ICamera#withSnapshotFormat(java.lang.String)
	 */
	public ICamera.Updater snapshotFormat(java.lang.String snapshotFormat) {
		keys.add("snapshotFormat");
		builder.setSnapshotFormat(snapshotFormat);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code recordFormat} to update to client widget
	 *
	 * @param recordFormat The new value for {@code recordFormat}
	 * @see ICamera#withRecordFormat(java.lang.String)
	 */
	public ICamera.Updater recordFormat(java.lang.String recordFormat) {
		keys.add("recordFormat");
		builder.setRecordFormat(recordFormat);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code maxsize} to update to client widget
	 *
	 * @param maxsize The new value for {@code maxsize}
	 * @see ICamera#withMaxsize(int)
	 */
	public ICamera.Updater maxsize(int maxsize) {
		keys.add("maxsize");
		builder.setMaxsize(maxsize);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code audio} to update to client widget
	 *
	 * @param audio The new value for {@code audio}
	 * @see ICamera#withAudio(boolean)
	 */
	public ICamera.Updater audio(boolean audio) {
		keys.add("audio");
		builder.setAudio(audio);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code previewRecord} to update to client widget
	 *
	 * @param previewRecord The new value for {@code previewRecord}
	 * @see ICamera#withPreviewRecord(boolean)
	 */
	public ICamera.Updater previewRecord(boolean previewRecord) {
		keys.add("previewRecord");
		builder.setPreviewRecord(previewRecord);
		return (ICamera.Updater) this;
	}

	/**
	 * Sets the given value of {@code lengthLimit} to update to client widget
	 *
	 * @param lengthLimit The new value for {@code lengthLimit}
	 * @see ICamera#withLengthLimit(int)
	 */
	public ICamera.Updater lengthLimit(int lengthLimit) {
		keys.add("lengthLimit");
		builder.setLengthLimit(lengthLimit);
		return (ICamera.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
