// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ICascader}.
 */
/*package*/ class ICascaderUpdater implements SmartUpdater {
	private final ICascader.Builder builder = new ICascader.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ICascader#withId(java.lang.String)
	 */
	public ICascader.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ICascader#withVisible(boolean)
	 */
	public ICascader.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ICascader#withMold(java.lang.String)
	 */
	public ICascader.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ICascader#withLeft(java.lang.String)
	 */
	public ICascader.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ICascader#withTop(java.lang.String)
	 */
	public ICascader.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ICascader#withZIndex(int)
	 */
	public ICascader.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ICascader#withHeight(java.lang.String)
	 */
	public ICascader.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see ICascader#withWidth(java.lang.String)
	 */
	public ICascader.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ICascader#withTooltiptext(java.lang.String)
	 */
	public ICascader.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ICascader#withZclass(java.lang.String)
	 */
	public ICascader.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ICascader#withSclass(java.lang.String)
	 */
	public ICascader.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ICascader#withStyle(java.lang.String)
	 */
	public ICascader.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ICascader#withDraggable(java.lang.String)
	 */
	public ICascader.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ICascader#withFocus(boolean)
	 */
	public ICascader.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ICascader#withDroppable(java.lang.String)
	 */
	public ICascader.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ICascader#withVflex(java.lang.String)
	 */
	public ICascader.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see ICascader#withHflex(java.lang.String)
	 */
	public ICascader.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ICascader#withRenderdefer(int)
	 */
	public ICascader.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ICascader#withClientAction(java.lang.String)
	 */
	public ICascader.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ICascader#withTabindex(java.lang.Integer)
	 */
	public ICascader.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see ICascader#withDisabled(boolean)
	 */
	public ICascader.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ICascader#withWidgetClass(java.lang.String)
	 */
	public ICascader.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code placeholder} to update to client widget
	 *
	 * @param placeholder The new value for {@code placeholder}
	 * @see ICascader#withPlaceholder(java.lang.String)
	 */
	public ICascader.Updater placeholder(java.lang.String placeholder) {
		keys.add("placeholder");
		builder.setPlaceholder(placeholder);
		return (ICascader.Updater) this;
	}

	/**
	 * Sets the given value of {@code open} to update to client widget
	 *
	 * @param open The new value for {@code open}
	 * @see ICascader#withOpen(boolean)
	 */
	public ICascader.Updater open(boolean open) {
		keys.add("open");
		builder.setOpen(open);
		return (ICascader.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
