// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ICell}.
 */
/*package*/ class ICellUpdater implements SmartUpdater {
	private final ICell.Builder builder = new ICell.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ICell#withId(java.lang.String)
	 */
	public ICell.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ICell#withVisible(boolean)
	 */
	public ICell.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ICell#withMold(java.lang.String)
	 */
	public ICell.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ICell#withLeft(java.lang.String)
	 */
	public ICell.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ICell#withTop(java.lang.String)
	 */
	public ICell.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ICell#withZIndex(int)
	 */
	public ICell.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ICell#withHeight(java.lang.String)
	 */
	public ICell.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see ICell#withWidth(java.lang.String)
	 */
	public ICell.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ICell#withTooltiptext(java.lang.String)
	 */
	public ICell.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ICell#withZclass(java.lang.String)
	 */
	public ICell.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ICell#withSclass(java.lang.String)
	 */
	public ICell.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ICell#withStyle(java.lang.String)
	 */
	public ICell.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ICell#withDraggable(java.lang.String)
	 */
	public ICell.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ICell#withFocus(boolean)
	 */
	public ICell.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ICell#withDroppable(java.lang.String)
	 */
	public ICell.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ICell#withVflex(java.lang.String)
	 */
	public ICell.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see ICell#withHflex(java.lang.String)
	 */
	public ICell.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ICell#withRenderdefer(int)
	 */
	public ICell.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ICell#withClientAction(java.lang.String)
	 */
	public ICell.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ICell#withTabindex(java.lang.Integer)
	 */
	public ICell.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see ICell#withCtrlKeys(java.lang.String)
	 */
	public ICell.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see ICell#withContext(java.lang.String)
	 */
	public ICell.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see ICell#withPopup(java.lang.String)
	 */
	public ICell.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see ICell#withTooltip(java.lang.String)
	 */
	public ICell.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ICell#withWidgetClass(java.lang.String)
	 */
	public ICell.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code align} to update to client widget
	 *
	 * @param align The new value for {@code align}
	 * @see ICell#withAlign(java.lang.String)
	 */
	public ICell.Updater align(java.lang.String align) {
		keys.add("align");
		builder.setAlign(align);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code valign} to update to client widget
	 *
	 * @param valign The new value for {@code valign}
	 * @see ICell#withValign(java.lang.String)
	 */
	public ICell.Updater valign(java.lang.String valign) {
		keys.add("valign");
		builder.setValign(valign);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code colspan} to update to client widget
	 *
	 * @param colspan The new value for {@code colspan}
	 * @see ICell#withColspan(int)
	 */
	public ICell.Updater colspan(int colspan) {
		keys.add("colspan");
		builder.setColspan(colspan);
		return (ICell.Updater) this;
	}

	/**
	 * Sets the given value of {@code rowspan} to update to client widget
	 *
	 * @param rowspan The new value for {@code rowspan}
	 * @see ICell#withRowspan(int)
	 */
	public ICell.Updater rowspan(int rowspan) {
		keys.add("rowspan");
		builder.setRowspan(rowspan);
		return (ICell.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
