// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IChosenbox}.
 */
/*package*/ class IChosenboxUpdater implements SmartUpdater {
	private final IChosenbox.Builder builder = new IChosenbox.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IChosenbox#withId(java.lang.String)
	 */
	public IChosenbox.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IChosenbox#withVisible(boolean)
	 */
	public IChosenbox.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IChosenbox#withMold(java.lang.String)
	 */
	public IChosenbox.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IChosenbox#withLeft(java.lang.String)
	 */
	public IChosenbox.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IChosenbox#withTop(java.lang.String)
	 */
	public IChosenbox.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IChosenbox#withZIndex(int)
	 */
	public IChosenbox.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IChosenbox#withHeight(java.lang.String)
	 */
	public IChosenbox.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IChosenbox#withWidth(java.lang.String)
	 */
	public IChosenbox.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IChosenbox#withTooltiptext(java.lang.String)
	 */
	public IChosenbox.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IChosenbox#withZclass(java.lang.String)
	 */
	public IChosenbox.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IChosenbox#withSclass(java.lang.String)
	 */
	public IChosenbox.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IChosenbox#withStyle(java.lang.String)
	 */
	public IChosenbox.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IChosenbox#withDraggable(java.lang.String)
	 */
	public IChosenbox.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IChosenbox#withFocus(boolean)
	 */
	public IChosenbox.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IChosenbox#withDroppable(java.lang.String)
	 */
	public IChosenbox.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IChosenbox#withVflex(java.lang.String)
	 */
	public IChosenbox.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IChosenbox#withHflex(java.lang.String)
	 */
	public IChosenbox.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IChosenbox#withRenderdefer(int)
	 */
	public IChosenbox.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IChosenbox#withClientAction(java.lang.String)
	 */
	public IChosenbox.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IChosenbox#withTabindex(java.lang.Integer)
	 */
	public IChosenbox.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IChosenbox#withWidgetClass(java.lang.String)
	 */
	public IChosenbox.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code name} to update to client widget
	 *
	 * @param name The new value for {@code name}
	 * @see IChosenbox#withName(java.lang.String)
	 */
	public IChosenbox.Updater name(java.lang.String name) {
		keys.add("name");
		builder.setName(name);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code emptyMessage} to update to client widget
	 *
	 * @param emptyMessage The new value for {@code emptyMessage}
	 * @see IChosenbox#withEmptyMessage(java.lang.String)
	 */
	public IChosenbox.Updater emptyMessage(java.lang.String emptyMessage) {
		keys.add("emptyMessage");
		builder.setEmptyMessage(emptyMessage);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code noResultsText} to update to client widget
	 *
	 * @param noResultsText The new value for {@code noResultsText}
	 * @see IChosenbox#withNoResultsText(java.lang.String)
	 */
	public IChosenbox.Updater noResultsText(java.lang.String noResultsText) {
		keys.add("noResultsText");
		builder.setNoResultsText(noResultsText);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code separator} to update to client widget
	 *
	 * @param separator The new value for {@code separator}
	 * @see IChosenbox#withSeparator(java.lang.String)
	 */
	public IChosenbox.Updater separator(java.lang.String separator) {
		keys.add("separator");
		builder.setSeparator(separator);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code createMessage} to update to client widget
	 *
	 * @param createMessage The new value for {@code createMessage}
	 * @see IChosenbox#withCreateMessage(java.lang.String)
	 */
	public IChosenbox.Updater createMessage(java.lang.String createMessage) {
		keys.add("createMessage");
		builder.setCreateMessage(createMessage);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code open} to update to client widget
	 *
	 * @param open The new value for {@code open}
	 * @see IChosenbox#withOpen(boolean)
	 */
	public IChosenbox.Updater open(boolean open) {
		keys.add("open");
		builder.setOpen(open);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see IChosenbox#withDisabled(boolean)
	 */
	public IChosenbox.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code creatable} to update to client widget
	 *
	 * @param creatable The new value for {@code creatable}
	 * @see IChosenbox#withCreatable(boolean)
	 */
	public IChosenbox.Updater creatable(boolean creatable) {
		keys.add("creatable");
		builder.setCreatable(creatable);
		return (IChosenbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code inplace} to update to client widget
	 *
	 * @param inplace The new value for {@code inplace}
	 * @see IChosenbox#withInplace(boolean)
	 */
	public IChosenbox.Updater inplace(boolean inplace) {
		keys.add("inplace");
		builder.setInplace(inplace);
		return (IChosenbox.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
