// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IColumns}.
 */
/*package*/ class IColumnsUpdater implements SmartUpdater {
	private final IColumns.Builder builder = new IColumns.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IColumns#withId(java.lang.String)
	 */
	public IColumns.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IColumns#withVisible(boolean)
	 */
	public IColumns.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IColumns#withMold(java.lang.String)
	 */
	public IColumns.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IColumns#withLeft(java.lang.String)
	 */
	public IColumns.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IColumns#withTop(java.lang.String)
	 */
	public IColumns.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IColumns#withZIndex(int)
	 */
	public IColumns.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IColumns#withHeight(java.lang.String)
	 */
	public IColumns.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IColumns#withTooltiptext(java.lang.String)
	 */
	public IColumns.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IColumns#withZclass(java.lang.String)
	 */
	public IColumns.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IColumns#withSclass(java.lang.String)
	 */
	public IColumns.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IColumns#withStyle(java.lang.String)
	 */
	public IColumns.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IColumns#withDraggable(java.lang.String)
	 */
	public IColumns.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IColumns#withFocus(boolean)
	 */
	public IColumns.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IColumns#withDroppable(java.lang.String)
	 */
	public IColumns.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IColumns#withVflex(java.lang.String)
	 */
	public IColumns.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IColumns#withRenderdefer(int)
	 */
	public IColumns.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IColumns#withClientAction(java.lang.String)
	 */
	public IColumns.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IColumns#withTabindex(java.lang.Integer)
	 */
	public IColumns.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IColumns#withCtrlKeys(java.lang.String)
	 */
	public IColumns.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IColumns#withContext(java.lang.String)
	 */
	public IColumns.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IColumns#withPopup(java.lang.String)
	 */
	public IColumns.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IColumns#withTooltip(java.lang.String)
	 */
	public IColumns.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code sizable} to update to client widget
	 *
	 * @param sizable The new value for {@code sizable}
	 * @see IColumns#withSizable(boolean)
	 */
	public IColumns.Updater sizable(boolean sizable) {
		keys.add("sizable");
		builder.setSizable(sizable);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IColumns#withWidgetClass(java.lang.String)
	 */
	public IColumns.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code columnshide} to update to client widget
	 *
	 * @param columnshide The new value for {@code columnshide}
	 * @see IColumns#withColumnshide(boolean)
	 */
	public IColumns.Updater columnshide(boolean columnshide) {
		keys.add("columnshide");
		builder.setColumnshide(columnshide);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code columnsgroup} to update to client widget
	 *
	 * @param columnsgroup The new value for {@code columnsgroup}
	 * @see IColumns#withColumnsgroup(boolean)
	 */
	public IColumns.Updater columnsgroup(boolean columnsgroup) {
		keys.add("columnsgroup");
		builder.setColumnsgroup(columnsgroup);
		return (IColumns.Updater) this;
	}

	/**
	 * Sets the given value of {@code menupopup} to update to client widget
	 *
	 * @param menupopup The new value for {@code menupopup}
	 * @see IColumns#withMenupopup(java.lang.String)
	 */
	public IColumns.Updater menupopup(java.lang.String menupopup) {
		keys.add("menupopup");
		builder.setMenupopup(menupopup);
		return (IColumns.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
