// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ICombobox}.
 */
/*package*/ class IComboboxUpdater implements SmartUpdater {
	private final ICombobox.Builder builder = new ICombobox.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ICombobox#withId(java.lang.String)
	 */
	public ICombobox.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ICombobox#withVisible(boolean)
	 */
	public ICombobox.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ICombobox#withMold(java.lang.String)
	 */
	public ICombobox.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ICombobox#withLeft(java.lang.String)
	 */
	public ICombobox.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ICombobox#withTop(java.lang.String)
	 */
	public ICombobox.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ICombobox#withZIndex(int)
	 */
	public ICombobox.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ICombobox#withHeight(java.lang.String)
	 */
	public ICombobox.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see ICombobox#withWidth(java.lang.String)
	 */
	public ICombobox.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ICombobox#withTooltiptext(java.lang.String)
	 */
	public ICombobox.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ICombobox#withZclass(java.lang.String)
	 */
	public ICombobox.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ICombobox#withSclass(java.lang.String)
	 */
	public ICombobox.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ICombobox#withStyle(java.lang.String)
	 */
	public ICombobox.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ICombobox#withDraggable(java.lang.String)
	 */
	public ICombobox.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ICombobox#withFocus(boolean)
	 */
	public ICombobox.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ICombobox#withDroppable(java.lang.String)
	 */
	public ICombobox.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ICombobox#withVflex(java.lang.String)
	 */
	public ICombobox.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see ICombobox#withHflex(java.lang.String)
	 */
	public ICombobox.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ICombobox#withRenderdefer(int)
	 */
	public ICombobox.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ICombobox#withClientAction(java.lang.String)
	 */
	public ICombobox.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ICombobox#withTabindex(java.lang.Integer)
	 */
	public ICombobox.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see ICombobox#withCtrlKeys(java.lang.String)
	 */
	public ICombobox.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see ICombobox#withContext(java.lang.String)
	 */
	public ICombobox.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see ICombobox#withPopup(java.lang.String)
	 */
	public ICombobox.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see ICombobox#withTooltip(java.lang.String)
	 */
	public ICombobox.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code readonly} to update to client widget
	 *
	 * @param readonly The new value for {@code readonly}
	 * @see ICombobox#withReadonly(boolean)
	 */
	public ICombobox.Updater readonly(boolean readonly) {
		keys.add("readonly");
		builder.setReadonly(readonly);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code name} to update to client widget
	 *
	 * @param name The new value for {@code name}
	 * @see ICombobox#withName(java.lang.String)
	 */
	public ICombobox.Updater name(java.lang.String name) {
		keys.add("name");
		builder.setName(name);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code placeholder} to update to client widget
	 *
	 * @param placeholder The new value for {@code placeholder}
	 * @see ICombobox#withPlaceholder(java.lang.String)
	 */
	public ICombobox.Updater placeholder(java.lang.String placeholder) {
		keys.add("placeholder");
		builder.setPlaceholder(placeholder);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code value} to update to client widget
	 *
	 * @param value The new value for {@code value}
	 * @see ICombobox#withValue(java.lang.String)
	 */
	public ICombobox.Updater value(java.lang.String value) {
		keys.add("value");
		builder.setValue(value);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code constraint} to update to client widget
	 *
	 * @param constraint The new value for {@code constraint}
	 * @see ICombobox#withConstraint(java.lang.String)
	 */
	public ICombobox.Updater constraint(java.lang.String constraint) {
		keys.add("constraint");
		builder.setConstraint(constraint);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorboxSclass} to update to client widget
	 *
	 * @param errorboxSclass The new value for {@code errorboxSclass}
	 * @see ICombobox#withErrorboxSclass(java.lang.String)
	 */
	public ICombobox.Updater errorboxSclass(java.lang.String errorboxSclass) {
		keys.add("errorboxSclass");
		builder.setErrorboxSclass(errorboxSclass);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorboxIconSclass} to update to client widget
	 *
	 * @param errorboxIconSclass The new value for {@code errorboxIconSclass}
	 * @see ICombobox#withErrorboxIconSclass(java.lang.String)
	 */
	public ICombobox.Updater errorboxIconSclass(java.lang.String errorboxIconSclass) {
		keys.add("errorboxIconSclass");
		builder.setErrorboxIconSclass(errorboxIconSclass);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see ICombobox#withDisabled(boolean)
	 */
	public ICombobox.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code inplace} to update to client widget
	 *
	 * @param inplace The new value for {@code inplace}
	 * @see ICombobox#withInplace(boolean)
	 */
	public ICombobox.Updater inplace(boolean inplace) {
		keys.add("inplace");
		builder.setInplace(inplace);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code maxlength} to update to client widget
	 *
	 * @param maxlength The new value for {@code maxlength}
	 * @see ICombobox#withMaxlength(int)
	 */
	public ICombobox.Updater maxlength(int maxlength) {
		keys.add("maxlength");
		builder.setMaxlength(maxlength);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code cols} to update to client widget
	 *
	 * @param cols The new value for {@code cols}
	 * @see ICombobox#withCols(int)
	 */
	public ICombobox.Updater cols(int cols) {
		keys.add("cols");
		builder.setCols(cols);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code instant} to update to client widget
	 *
	 * @param instant The new value for {@code instant}
	 * @see ICombobox#withInstant(boolean)
	 */
	public ICombobox.Updater instant(boolean instant) {
		keys.add("instant");
		builder.setInstant(instant);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorMessage} to update to client widget
	 *
	 * @param errorMessage The new value for {@code errorMessage}
	 * @see ICombobox#withErrorMessage(java.lang.String)
	 */
	public ICombobox.Updater errorMessage(java.lang.String errorMessage) {
		keys.add("errorMessage");
		builder.setErrorMessage(errorMessage);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code multiline} to update to client widget
	 *
	 * @param multiline The new value for {@code multiline}
	 * @see ICombobox#withMultiline(boolean)
	 */
	public ICombobox.Updater multiline(boolean multiline) {
		keys.add("multiline");
		builder.setMultiline(multiline);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code rows} to update to client widget
	 *
	 * @param rows The new value for {@code rows}
	 * @see ICombobox#withRows(int)
	 */
	public ICombobox.Updater rows(int rows) {
		keys.add("rows");
		builder.setRows(rows);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabbable} to update to client widget
	 *
	 * @param tabbable The new value for {@code tabbable}
	 * @see ICombobox#withTabbable(boolean)
	 */
	public ICombobox.Updater tabbable(boolean tabbable) {
		keys.add("tabbable");
		builder.setTabbable(tabbable);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code type} to update to client widget
	 *
	 * @param type The new value for {@code type}
	 * @see ICombobox#withType(java.lang.String)
	 */
	public ICombobox.Updater type(java.lang.String type) {
		keys.add("type");
		builder.setType(type);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code submitByEnter} to update to client widget
	 *
	 * @param submitByEnter The new value for {@code submitByEnter}
	 * @see ICombobox#withSubmitByEnter(boolean)
	 */
	public ICombobox.Updater submitByEnter(boolean submitByEnter) {
		keys.add("submitByEnter");
		builder.setSubmitByEnter(submitByEnter);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ICombobox#withWidgetClass(java.lang.String)
	 */
	public ICombobox.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code popupWidth} to update to client widget
	 *
	 * @param popupWidth The new value for {@code popupWidth}
	 * @see ICombobox#withPopupWidth(java.lang.String)
	 */
	public ICombobox.Updater popupWidth(java.lang.String popupWidth) {
		keys.add("popupWidth");
		builder.setPopupWidth(popupWidth);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code emptySearchMessage} to update to client widget
	 *
	 * @param emptySearchMessage The new value for {@code emptySearchMessage}
	 * @see ICombobox#withEmptySearchMessage(java.lang.String)
	 */
	public ICombobox.Updater emptySearchMessage(java.lang.String emptySearchMessage) {
		keys.add("emptySearchMessage");
		builder.setEmptySearchMessage(emptySearchMessage);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code selectedIndex} to update to client widget
	 *
	 * @param selectedIndex The new value for {@code selectedIndex}
	 * @see ICombobox#withSelectedIndex(int)
	 */
	public ICombobox.Updater selectedIndex(int selectedIndex) {
		keys.add("selectedIndex");
		builder.setSelectedIndex(selectedIndex);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code autodrop} to update to client widget
	 *
	 * @param autodrop The new value for {@code autodrop}
	 * @see ICombobox#withAutodrop(boolean)
	 */
	public ICombobox.Updater autodrop(boolean autodrop) {
		keys.add("autodrop");
		builder.setAutodrop(autodrop);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code autocomplete} to update to client widget
	 *
	 * @param autocomplete The new value for {@code autocomplete}
	 * @see ICombobox#withAutocomplete(boolean)
	 */
	public ICombobox.Updater autocomplete(boolean autocomplete) {
		keys.add("autocomplete");
		builder.setAutocomplete(autocomplete);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code buttonVisible} to update to client widget
	 *
	 * @param buttonVisible The new value for {@code buttonVisible}
	 * @see ICombobox#withButtonVisible(boolean)
	 */
	public ICombobox.Updater buttonVisible(boolean buttonVisible) {
		keys.add("buttonVisible");
		builder.setButtonVisible(buttonVisible);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code instantSelect} to update to client widget
	 *
	 * @param instantSelect The new value for {@code instantSelect}
	 * @see ICombobox#withInstantSelect(boolean)
	 */
	public ICombobox.Updater instantSelect(boolean instantSelect) {
		keys.add("instantSelect");
		builder.setInstantSelect(instantSelect);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconSclass} to update to client widget
	 *
	 * @param iconSclass The new value for {@code iconSclass}
	 * @see ICombobox#withIconSclass(java.lang.String)
	 */
	public ICombobox.Updater iconSclass(java.lang.String iconSclass) {
		keys.add("iconSclass");
		builder.setIconSclass(iconSclass);
		return (ICombobox.Updater) this;
	}

	/**
	 * Sets the given value of {@code open} to update to client widget
	 *
	 * @param open The new value for {@code open}
	 * @see ICombobox#withOpen(boolean)
	 */
	public ICombobox.Updater open(boolean open) {
		keys.add("open");
		builder.setOpen(open);
		return (ICombobox.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
