// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.image.Image;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ICropper}.
 */
/*package*/ class ICropperUpdater implements SmartUpdater {
	private final ICropper.Builder builder = new ICropper.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ICropper#withId(java.lang.String)
	 */
	public ICropper.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ICropper#withVisible(boolean)
	 */
	public ICropper.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ICropper#withMold(java.lang.String)
	 */
	public ICropper.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ICropper#withLeft(java.lang.String)
	 */
	public ICropper.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ICropper#withTop(java.lang.String)
	 */
	public ICropper.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ICropper#withZIndex(int)
	 */
	public ICropper.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ICropper#withHeight(java.lang.String)
	 */
	public ICropper.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see ICropper#withWidth(java.lang.String)
	 */
	public ICropper.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ICropper#withTooltiptext(java.lang.String)
	 */
	public ICropper.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ICropper#withZclass(java.lang.String)
	 */
	public ICropper.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ICropper#withSclass(java.lang.String)
	 */
	public ICropper.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ICropper#withStyle(java.lang.String)
	 */
	public ICropper.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ICropper#withDraggable(java.lang.String)
	 */
	public ICropper.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ICropper#withFocus(boolean)
	 */
	public ICropper.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ICropper#withDroppable(java.lang.String)
	 */
	public ICropper.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ICropper#withVflex(java.lang.String)
	 */
	public ICropper.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see ICropper#withHflex(java.lang.String)
	 */
	public ICropper.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ICropper#withRenderdefer(int)
	 */
	public ICropper.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ICropper#withClientAction(java.lang.String)
	 */
	public ICropper.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ICropper#withTabindex(java.lang.Integer)
	 */
	public ICropper.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ICropper#withWidgetClass(java.lang.String)
	 */
	public ICropper.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code crossorigin} to update to client widget
	 *
	 * @param crossorigin The new value for {@code crossorigin}
	 * @see ICropper#withCrossorigin(java.lang.String)
	 */
	public ICropper.Updater crossorigin(java.lang.String crossorigin) {
		keys.add("crossorigin");
		builder.setCrossorigin(crossorigin);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code content} to update to client widget
	 *
	 * @param content The new value for {@code content}
	 * @see ICropper#withContent(org.zkoss.image.Image)
	 */
	public ICropper.Updater content(Image content) {
		keys.add("content");
		builder.setContent(content);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code aspectRatio} to update to client widget
	 *
	 * @param aspectRatio The new value for {@code aspectRatio}
	 * @see ICropper#withAspectRatio(double)
	 */
	public ICropper.Updater aspectRatio(double aspectRatio) {
		keys.add("aspectRatio");
		builder.setAspectRatio(aspectRatio);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code minWidth} to update to client widget
	 *
	 * @param minWidth The new value for {@code minWidth}
	 * @see ICropper#withMinWidth(int)
	 */
	public ICropper.Updater minWidth(int minWidth) {
		keys.add("minWidth");
		builder.setMinWidth(minWidth);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code minHeight} to update to client widget
	 *
	 * @param minHeight The new value for {@code minHeight}
	 * @see ICropper#withMinHeight(int)
	 */
	public ICropper.Updater minHeight(int minHeight) {
		keys.add("minHeight");
		builder.setMinHeight(minHeight);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code maxWidth} to update to client widget
	 *
	 * @param maxWidth The new value for {@code maxWidth}
	 * @see ICropper#withMaxWidth(int)
	 */
	public ICropper.Updater maxWidth(int maxWidth) {
		keys.add("maxWidth");
		builder.setMaxWidth(maxWidth);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code maxHeight} to update to client widget
	 *
	 * @param maxHeight The new value for {@code maxHeight}
	 * @see ICropper#withMaxHeight(int)
	 */
	public ICropper.Updater maxHeight(int maxHeight) {
		keys.add("maxHeight");
		builder.setMaxHeight(maxHeight);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code x} to update to client widget
	 *
	 * @param x The new value for {@code x}
	 * @see ICropper#withX(int)
	 */
	public ICropper.Updater x(int x) {
		keys.add("x");
		builder.setX(x);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code y} to update to client widget
	 *
	 * @param y The new value for {@code y}
	 * @see ICropper#withY(int)
	 */
	public ICropper.Updater y(int y) {
		keys.add("y");
		builder.setY(y);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code w} to update to client widget
	 *
	 * @param w The new value for {@code w}
	 * @see ICropper#withW(int)
	 */
	public ICropper.Updater w(int w) {
		keys.add("w");
		builder.setW(w);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code h} to update to client widget
	 *
	 * @param h The new value for {@code h}
	 * @see ICropper#withH(int)
	 */
	public ICropper.Updater h(int h) {
		keys.add("h");
		builder.setH(h);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code toolbarVisible} to update to client widget
	 *
	 * @param toolbarVisible The new value for {@code toolbarVisible}
	 * @see ICropper#withToolbarVisible(boolean)
	 */
	public ICropper.Updater toolbarVisible(boolean toolbarVisible) {
		keys.add("toolbarVisible");
		builder.setToolbarVisible(toolbarVisible);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code croppedFormat} to update to client widget
	 *
	 * @param croppedFormat The new value for {@code croppedFormat}
	 * @see ICropper#withCroppedFormat(java.lang.String)
	 */
	public ICropper.Updater croppedFormat(java.lang.String croppedFormat) {
		keys.add("croppedFormat");
		builder.setCroppedFormat(croppedFormat);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code instant} to update to client widget
	 *
	 * @param instant The new value for {@code instant}
	 * @see ICropper#withInstant(boolean)
	 */
	public ICropper.Updater instant(boolean instant) {
		keys.add("instant");
		builder.setInstant(instant);
		return (ICropper.Updater) this;
	}

	/**
	 * Sets the given value of {@code src} to update to client widget
	 *
	 * @param src The new value for {@code src}
	 * @see ICropper#withSrc(java.lang.String)
	 */
	public ICropper.Updater src(java.lang.String src) {
		keys.add("src");
		builder.setSrc(src);
		return (ICropper.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
