// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.ZonedDateTime;
import java.util.Date;
import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Locale;
import java.util.Map;
import java.util.Set;
import java.util.TimeZone;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IDatebox}.
 */
/*package*/ class IDateboxUpdater implements SmartUpdater {
	private final IDatebox.Builder builder = new IDatebox.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IDatebox#withId(java.lang.String)
	 */
	public IDatebox.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IDatebox#withVisible(boolean)
	 */
	public IDatebox.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IDatebox#withMold(java.lang.String)
	 */
	public IDatebox.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IDatebox#withLeft(java.lang.String)
	 */
	public IDatebox.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IDatebox#withTop(java.lang.String)
	 */
	public IDatebox.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IDatebox#withZIndex(int)
	 */
	public IDatebox.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IDatebox#withHeight(java.lang.String)
	 */
	public IDatebox.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IDatebox#withWidth(java.lang.String)
	 */
	public IDatebox.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IDatebox#withTooltiptext(java.lang.String)
	 */
	public IDatebox.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IDatebox#withZclass(java.lang.String)
	 */
	public IDatebox.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IDatebox#withSclass(java.lang.String)
	 */
	public IDatebox.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IDatebox#withStyle(java.lang.String)
	 */
	public IDatebox.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IDatebox#withDraggable(java.lang.String)
	 */
	public IDatebox.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IDatebox#withFocus(boolean)
	 */
	public IDatebox.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IDatebox#withDroppable(java.lang.String)
	 */
	public IDatebox.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IDatebox#withVflex(java.lang.String)
	 */
	public IDatebox.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IDatebox#withHflex(java.lang.String)
	 */
	public IDatebox.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IDatebox#withRenderdefer(int)
	 */
	public IDatebox.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IDatebox#withClientAction(java.lang.String)
	 */
	public IDatebox.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IDatebox#withTabindex(java.lang.Integer)
	 */
	public IDatebox.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IDatebox#withCtrlKeys(java.lang.String)
	 */
	public IDatebox.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IDatebox#withContext(java.lang.String)
	 */
	public IDatebox.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IDatebox#withPopup(java.lang.String)
	 */
	public IDatebox.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IDatebox#withTooltip(java.lang.String)
	 */
	public IDatebox.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code readonly} to update to client widget
	 *
	 * @param readonly The new value for {@code readonly}
	 * @see IDatebox#withReadonly(boolean)
	 */
	public IDatebox.Updater readonly(boolean readonly) {
		keys.add("readonly");
		builder.setReadonly(readonly);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code name} to update to client widget
	 *
	 * @param name The new value for {@code name}
	 * @see IDatebox#withName(java.lang.String)
	 */
	public IDatebox.Updater name(java.lang.String name) {
		keys.add("name");
		builder.setName(name);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code placeholder} to update to client widget
	 *
	 * @param placeholder The new value for {@code placeholder}
	 * @see IDatebox#withPlaceholder(java.lang.String)
	 */
	public IDatebox.Updater placeholder(java.lang.String placeholder) {
		keys.add("placeholder");
		builder.setPlaceholder(placeholder);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code value} to update to client widget
	 *
	 * @param value The new value for {@code value}
	 * @see IDatebox#withValue(java.util.Date)
	 */
	public IDatebox.Updater value(Date value) {
		keys.add("value");
		builder.setValue(value);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code constraint} to update to client widget
	 *
	 * @param constraint The new value for {@code constraint}
	 * @see IDatebox#withConstraint(java.lang.String)
	 */
	public IDatebox.Updater constraint(java.lang.String constraint) {
		keys.add("constraint");
		builder.setConstraint(constraint);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorboxSclass} to update to client widget
	 *
	 * @param errorboxSclass The new value for {@code errorboxSclass}
	 * @see IDatebox#withErrorboxSclass(java.lang.String)
	 */
	public IDatebox.Updater errorboxSclass(java.lang.String errorboxSclass) {
		keys.add("errorboxSclass");
		builder.setErrorboxSclass(errorboxSclass);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorboxIconSclass} to update to client widget
	 *
	 * @param errorboxIconSclass The new value for {@code errorboxIconSclass}
	 * @see IDatebox#withErrorboxIconSclass(java.lang.String)
	 */
	public IDatebox.Updater errorboxIconSclass(java.lang.String errorboxIconSclass) {
		keys.add("errorboxIconSclass");
		builder.setErrorboxIconSclass(errorboxIconSclass);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see IDatebox#withDisabled(boolean)
	 */
	public IDatebox.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code inplace} to update to client widget
	 *
	 * @param inplace The new value for {@code inplace}
	 * @see IDatebox#withInplace(boolean)
	 */
	public IDatebox.Updater inplace(boolean inplace) {
		keys.add("inplace");
		builder.setInplace(inplace);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code maxlength} to update to client widget
	 *
	 * @param maxlength The new value for {@code maxlength}
	 * @see IDatebox#withMaxlength(int)
	 */
	public IDatebox.Updater maxlength(int maxlength) {
		keys.add("maxlength");
		builder.setMaxlength(maxlength);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code instant} to update to client widget
	 *
	 * @param instant The new value for {@code instant}
	 * @see IDatebox#withInstant(boolean)
	 */
	public IDatebox.Updater instant(boolean instant) {
		keys.add("instant");
		builder.setInstant(instant);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorMessage} to update to client widget
	 *
	 * @param errorMessage The new value for {@code errorMessage}
	 * @see IDatebox#withErrorMessage(java.lang.String)
	 */
	public IDatebox.Updater errorMessage(java.lang.String errorMessage) {
		keys.add("errorMessage");
		builder.setErrorMessage(errorMessage);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code format} to update to client widget
	 *
	 * @param format The new value for {@code format}
	 * @see IDatebox#withFormat(java.lang.String)
	 */
	public IDatebox.Updater format(java.lang.String format) {
		keys.add("format");
		builder.setFormat(format);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code locale} to update to client widget
	 *
	 * @param locale The new value for {@code locale}
	 * @see IDatebox#withLocale(java.util.Locale)
	 */
	public IDatebox.Updater locale(Locale locale) {
		keys.add("locale");
		builder.setLocale(locale);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code timeZone} to update to client widget
	 *
	 * @param timeZone The new value for {@code timeZone}
	 * @see IDatebox#withTimeZone(java.util.TimeZone)
	 */
	public IDatebox.Updater timeZone(TimeZone timeZone) {
		keys.add("timeZone");
		builder.setTimeZone(timeZone);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code valueInZonedDateTime} to update to client widget
	 *
	 * @param valueInZonedDateTime The new value for {@code valueInZonedDateTime}
	 * @see IDatebox#withValueInZonedDateTime(java.time.ZonedDateTime)
	 */
	public IDatebox.Updater valueInZonedDateTime(ZonedDateTime valueInZonedDateTime) {
		keys.add("valueInZonedDateTime");
		builder.setValueInZonedDateTime(valueInZonedDateTime);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code valueInLocalDateTime} to update to client widget
	 *
	 * @param valueInLocalDateTime The new value for {@code valueInLocalDateTime}
	 * @see IDatebox#withValueInLocalDateTime(java.time.LocalDateTime)
	 */
	public IDatebox.Updater valueInLocalDateTime(LocalDateTime valueInLocalDateTime) {
		keys.add("valueInLocalDateTime");
		builder.setValueInLocalDateTime(valueInLocalDateTime);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code valueInLocalDate} to update to client widget
	 *
	 * @param valueInLocalDate The new value for {@code valueInLocalDate}
	 * @see IDatebox#withValueInLocalDate(java.time.LocalDate)
	 */
	public IDatebox.Updater valueInLocalDate(LocalDate valueInLocalDate) {
		keys.add("valueInLocalDate");
		builder.setValueInLocalDate(valueInLocalDate);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code valueInLocalTime} to update to client widget
	 *
	 * @param valueInLocalTime The new value for {@code valueInLocalTime}
	 * @see IDatebox#withValueInLocalTime(java.time.LocalTime)
	 */
	public IDatebox.Updater valueInLocalTime(LocalTime valueInLocalTime) {
		keys.add("valueInLocalTime");
		builder.setValueInLocalTime(valueInLocalTime);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IDatebox#withWidgetClass(java.lang.String)
	 */
	public IDatebox.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code defaultDateTime} to update to client widget
	 *
	 * @param defaultDateTime The new value for {@code defaultDateTime}
	 * @see IDatebox#withDefaultDateTime(java.time.LocalDateTime)
	 */
	public IDatebox.Updater defaultDateTime(LocalDateTime defaultDateTime) {
		keys.add("defaultDateTime");
		builder.setDefaultDateTime(defaultDateTime);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code buttonVisible} to update to client widget
	 *
	 * @param buttonVisible The new value for {@code buttonVisible}
	 * @see IDatebox#withButtonVisible(boolean)
	 */
	public IDatebox.Updater buttonVisible(boolean buttonVisible) {
		keys.add("buttonVisible");
		builder.setButtonVisible(buttonVisible);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code lenient} to update to client widget
	 *
	 * @param lenient The new value for {@code lenient}
	 * @see IDatebox#withLenient(boolean)
	 */
	public IDatebox.Updater lenient(boolean lenient) {
		keys.add("lenient");
		builder.setLenient(lenient);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code timeZonesReadonly} to update to client widget
	 *
	 * @param timeZonesReadonly The new value for {@code timeZonesReadonly}
	 * @see IDatebox#withTimeZonesReadonly(boolean)
	 */
	public IDatebox.Updater timeZonesReadonly(boolean timeZonesReadonly) {
		keys.add("timeZonesReadonly");
		builder.setTimeZonesReadonly(timeZonesReadonly);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code weekOfYear} to update to client widget
	 *
	 * @param weekOfYear The new value for {@code weekOfYear}
	 * @see IDatebox#withWeekOfYear(boolean)
	 */
	public IDatebox.Updater weekOfYear(boolean weekOfYear) {
		keys.add("weekOfYear");
		builder.setWeekOfYear(weekOfYear);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code position} to update to client widget
	 *
	 * @param position The new value for {@code position}
	 * @see IDatebox#withPosition(java.lang.String)
	 */
	public IDatebox.Updater position(java.lang.String position) {
		keys.add("position");
		builder.setPosition(position);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code strictDate} to update to client widget
	 *
	 * @param strictDate The new value for {@code strictDate}
	 * @see IDatebox#withStrictDate(boolean)
	 */
	public IDatebox.Updater strictDate(boolean strictDate) {
		keys.add("strictDate");
		builder.setStrictDate(strictDate);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code showTodayLink} to update to client widget
	 *
	 * @param showTodayLink The new value for {@code showTodayLink}
	 * @see IDatebox#withShowTodayLink(boolean)
	 */
	public IDatebox.Updater showTodayLink(boolean showTodayLink) {
		keys.add("showTodayLink");
		builder.setShowTodayLink(showTodayLink);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code todayLinkLabel} to update to client widget
	 *
	 * @param todayLinkLabel The new value for {@code todayLinkLabel}
	 * @see IDatebox#withTodayLinkLabel(java.lang.String)
	 */
	public IDatebox.Updater todayLinkLabel(java.lang.String todayLinkLabel) {
		keys.add("todayLinkLabel");
		builder.setTodayLinkLabel(todayLinkLabel);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code selectLevel} to update to client widget
	 *
	 * @param selectLevel The new value for {@code selectLevel}
	 * @see IDatebox#withSelectLevel(java.lang.String)
	 */
	public IDatebox.Updater selectLevel(java.lang.String selectLevel) {
		keys.add("selectLevel");
		builder.setSelectLevel(selectLevel);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code closePopupOnTimezoneChange} to update to client widget
	 *
	 * @param closePopupOnTimezoneChange The new value for {@code closePopupOnTimezoneChange}
	 * @see IDatebox#withClosePopupOnTimezoneChange(boolean)
	 */
	public IDatebox.Updater closePopupOnTimezoneChange(boolean closePopupOnTimezoneChange) {
		keys.add("closePopupOnTimezoneChange");
		builder.setClosePopupOnTimezoneChange(closePopupOnTimezoneChange);
		return (IDatebox.Updater) this;
	}

	/**
	 * Sets the given value of {@code cols} to update to client widget
	 *
	 * @param cols The new value for {@code cols}
	 * @see IDatebox#withCols(int)
	 */
	public IDatebox.Updater cols(int cols) {
		keys.add("cols");
		builder.setCols(cols);
		return (IDatebox.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
