// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IDetail}.
 */
/*package*/ class IDetailUpdater implements SmartUpdater {
	private final IDetail.Builder builder = new IDetail.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IDetail#withId(java.lang.String)
	 */
	public IDetail.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IDetail#withVisible(boolean)
	 */
	public IDetail.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IDetail#withMold(java.lang.String)
	 */
	public IDetail.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IDetail#withLeft(java.lang.String)
	 */
	public IDetail.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IDetail#withTop(java.lang.String)
	 */
	public IDetail.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IDetail#withZIndex(int)
	 */
	public IDetail.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IDetail#withHeight(java.lang.String)
	 */
	public IDetail.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IDetail#withWidth(java.lang.String)
	 */
	public IDetail.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IDetail#withTooltiptext(java.lang.String)
	 */
	public IDetail.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IDetail#withZclass(java.lang.String)
	 */
	public IDetail.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IDetail#withSclass(java.lang.String)
	 */
	public IDetail.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IDetail#withStyle(java.lang.String)
	 */
	public IDetail.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IDetail#withDraggable(java.lang.String)
	 */
	public IDetail.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IDetail#withFocus(boolean)
	 */
	public IDetail.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IDetail#withDroppable(java.lang.String)
	 */
	public IDetail.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IDetail#withVflex(java.lang.String)
	 */
	public IDetail.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IDetail#withHflex(java.lang.String)
	 */
	public IDetail.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IDetail#withRenderdefer(int)
	 */
	public IDetail.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IDetail#withClientAction(java.lang.String)
	 */
	public IDetail.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IDetail#withTabindex(java.lang.Integer)
	 */
	public IDetail.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IDetail#withCtrlKeys(java.lang.String)
	 */
	public IDetail.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IDetail#withContext(java.lang.String)
	 */
	public IDetail.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IDetail#withPopup(java.lang.String)
	 */
	public IDetail.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IDetail#withTooltip(java.lang.String)
	 */
	public IDetail.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IDetail#withWidgetClass(java.lang.String)
	 */
	public IDetail.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code contentSclass} to update to client widget
	 *
	 * @param contentSclass The new value for {@code contentSclass}
	 * @see IDetail#withContentSclass(java.lang.String)
	 */
	public IDetail.Updater contentSclass(java.lang.String contentSclass) {
		keys.add("contentSclass");
		builder.setContentSclass(contentSclass);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code contentStyle} to update to client widget
	 *
	 * @param contentStyle The new value for {@code contentStyle}
	 * @see IDetail#withContentStyle(java.lang.String)
	 */
	public IDetail.Updater contentStyle(java.lang.String contentStyle) {
		keys.add("contentStyle");
		builder.setContentStyle(contentStyle);
		return (IDetail.Updater) this;
	}

	/**
	 * Sets the given value of {@code open} to update to client widget
	 *
	 * @param open The new value for {@code open}
	 * @see IDetail#withOpen(boolean)
	 */
	public IDetail.Updater open(boolean open) {
		keys.add("open");
		builder.setOpen(open);
		return (IDetail.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
