// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Locale;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IDoublespinner}.
 */
/*package*/ class IDoublespinnerUpdater implements SmartUpdater {
	private final IDoublespinner.Builder builder = new IDoublespinner.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IDoublespinner#withId(java.lang.String)
	 */
	public IDoublespinner.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IDoublespinner#withVisible(boolean)
	 */
	public IDoublespinner.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IDoublespinner#withMold(java.lang.String)
	 */
	public IDoublespinner.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IDoublespinner#withLeft(java.lang.String)
	 */
	public IDoublespinner.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IDoublespinner#withTop(java.lang.String)
	 */
	public IDoublespinner.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IDoublespinner#withZIndex(int)
	 */
	public IDoublespinner.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IDoublespinner#withHeight(java.lang.String)
	 */
	public IDoublespinner.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IDoublespinner#withWidth(java.lang.String)
	 */
	public IDoublespinner.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IDoublespinner#withTooltiptext(java.lang.String)
	 */
	public IDoublespinner.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IDoublespinner#withZclass(java.lang.String)
	 */
	public IDoublespinner.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IDoublespinner#withSclass(java.lang.String)
	 */
	public IDoublespinner.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IDoublespinner#withStyle(java.lang.String)
	 */
	public IDoublespinner.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IDoublespinner#withDraggable(java.lang.String)
	 */
	public IDoublespinner.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IDoublespinner#withFocus(boolean)
	 */
	public IDoublespinner.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IDoublespinner#withDroppable(java.lang.String)
	 */
	public IDoublespinner.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IDoublespinner#withVflex(java.lang.String)
	 */
	public IDoublespinner.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IDoublespinner#withHflex(java.lang.String)
	 */
	public IDoublespinner.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IDoublespinner#withRenderdefer(int)
	 */
	public IDoublespinner.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IDoublespinner#withClientAction(java.lang.String)
	 */
	public IDoublespinner.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IDoublespinner#withTabindex(java.lang.Integer)
	 */
	public IDoublespinner.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IDoublespinner#withCtrlKeys(java.lang.String)
	 */
	public IDoublespinner.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IDoublespinner#withContext(java.lang.String)
	 */
	public IDoublespinner.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IDoublespinner#withPopup(java.lang.String)
	 */
	public IDoublespinner.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IDoublespinner#withTooltip(java.lang.String)
	 */
	public IDoublespinner.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code readonly} to update to client widget
	 *
	 * @param readonly The new value for {@code readonly}
	 * @see IDoublespinner#withReadonly(boolean)
	 */
	public IDoublespinner.Updater readonly(boolean readonly) {
		keys.add("readonly");
		builder.setReadonly(readonly);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code name} to update to client widget
	 *
	 * @param name The new value for {@code name}
	 * @see IDoublespinner#withName(java.lang.String)
	 */
	public IDoublespinner.Updater name(java.lang.String name) {
		keys.add("name");
		builder.setName(name);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code placeholder} to update to client widget
	 *
	 * @param placeholder The new value for {@code placeholder}
	 * @see IDoublespinner#withPlaceholder(java.lang.String)
	 */
	public IDoublespinner.Updater placeholder(java.lang.String placeholder) {
		keys.add("placeholder");
		builder.setPlaceholder(placeholder);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code value} to update to client widget
	 *
	 * @param value The new value for {@code value}
	 * @see IDoublespinner#withValue(java.lang.Double)
	 */
	public IDoublespinner.Updater value(Double value) {
		keys.add("value");
		builder.setValue(value);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code constraint} to update to client widget
	 *
	 * @param constraint The new value for {@code constraint}
	 * @see IDoublespinner#withConstraint(java.lang.String)
	 */
	public IDoublespinner.Updater constraint(java.lang.String constraint) {
		keys.add("constraint");
		builder.setConstraint(constraint);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorboxSclass} to update to client widget
	 *
	 * @param errorboxSclass The new value for {@code errorboxSclass}
	 * @see IDoublespinner#withErrorboxSclass(java.lang.String)
	 */
	public IDoublespinner.Updater errorboxSclass(java.lang.String errorboxSclass) {
		keys.add("errorboxSclass");
		builder.setErrorboxSclass(errorboxSclass);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorboxIconSclass} to update to client widget
	 *
	 * @param errorboxIconSclass The new value for {@code errorboxIconSclass}
	 * @see IDoublespinner#withErrorboxIconSclass(java.lang.String)
	 */
	public IDoublespinner.Updater errorboxIconSclass(java.lang.String errorboxIconSclass) {
		keys.add("errorboxIconSclass");
		builder.setErrorboxIconSclass(errorboxIconSclass);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see IDoublespinner#withDisabled(boolean)
	 */
	public IDoublespinner.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code inplace} to update to client widget
	 *
	 * @param inplace The new value for {@code inplace}
	 * @see IDoublespinner#withInplace(boolean)
	 */
	public IDoublespinner.Updater inplace(boolean inplace) {
		keys.add("inplace");
		builder.setInplace(inplace);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code maxlength} to update to client widget
	 *
	 * @param maxlength The new value for {@code maxlength}
	 * @see IDoublespinner#withMaxlength(int)
	 */
	public IDoublespinner.Updater maxlength(int maxlength) {
		keys.add("maxlength");
		builder.setMaxlength(maxlength);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code instant} to update to client widget
	 *
	 * @param instant The new value for {@code instant}
	 * @see IDoublespinner#withInstant(boolean)
	 */
	public IDoublespinner.Updater instant(boolean instant) {
		keys.add("instant");
		builder.setInstant(instant);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorMessage} to update to client widget
	 *
	 * @param errorMessage The new value for {@code errorMessage}
	 * @see IDoublespinner#withErrorMessage(java.lang.String)
	 */
	public IDoublespinner.Updater errorMessage(java.lang.String errorMessage) {
		keys.add("errorMessage");
		builder.setErrorMessage(errorMessage);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code format} to update to client widget
	 *
	 * @param format The new value for {@code format}
	 * @see IDoublespinner#withFormat(java.lang.String)
	 */
	public IDoublespinner.Updater format(java.lang.String format) {
		keys.add("format");
		builder.setFormat(format);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code locale} to update to client widget
	 *
	 * @param locale The new value for {@code locale}
	 * @see IDoublespinner#withLocale(java.util.Locale)
	 */
	public IDoublespinner.Updater locale(Locale locale) {
		keys.add("locale");
		builder.setLocale(locale);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code cols} to update to client widget
	 *
	 * @param cols The new value for {@code cols}
	 * @see IDoublespinner#withCols(int)
	 */
	public IDoublespinner.Updater cols(int cols) {
		keys.add("cols");
		builder.setCols(cols);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code roundingMode} to update to client widget
	 *
	 * @param roundingMode The new value for {@code roundingMode}
	 * @see IDoublespinner#withRoundingMode(int)
	 */
	public IDoublespinner.Updater roundingMode(int roundingMode) {
		keys.add("roundingMode");
		builder.setRoundingMode(roundingMode);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IDoublespinner#withWidgetClass(java.lang.String)
	 */
	public IDoublespinner.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code step} to update to client widget
	 *
	 * @param step The new value for {@code step}
	 * @see IDoublespinner#withStep(double)
	 */
	public IDoublespinner.Updater step(double step) {
		keys.add("step");
		builder.setStep(step);
		return (IDoublespinner.Updater) this;
	}

	/**
	 * Sets the given value of {@code buttonVisible} to update to client widget
	 *
	 * @param buttonVisible The new value for {@code buttonVisible}
	 * @see IDoublespinner#withButtonVisible(boolean)
	 */
	public IDoublespinner.Updater buttonVisible(boolean buttonVisible) {
		keys.add("buttonVisible");
		builder.setButtonVisible(buttonVisible);
		return (IDoublespinner.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
