// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IDrawer}.
 */
/*package*/ class IDrawerUpdater implements SmartUpdater {
	private final IDrawer.Builder builder = new IDrawer.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IDrawer#withId(java.lang.String)
	 */
	public IDrawer.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IDrawer#withMold(java.lang.String)
	 */
	public IDrawer.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IDrawer#withLeft(java.lang.String)
	 */
	public IDrawer.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IDrawer#withTop(java.lang.String)
	 */
	public IDrawer.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IDrawer#withZIndex(int)
	 */
	public IDrawer.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IDrawer#withHeight(java.lang.String)
	 */
	public IDrawer.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IDrawer#withWidth(java.lang.String)
	 */
	public IDrawer.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IDrawer#withTooltiptext(java.lang.String)
	 */
	public IDrawer.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IDrawer#withZclass(java.lang.String)
	 */
	public IDrawer.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IDrawer#withSclass(java.lang.String)
	 */
	public IDrawer.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IDrawer#withStyle(java.lang.String)
	 */
	public IDrawer.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IDrawer#withDraggable(java.lang.String)
	 */
	public IDrawer.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IDrawer#withFocus(boolean)
	 */
	public IDrawer.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IDrawer#withDroppable(java.lang.String)
	 */
	public IDrawer.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IDrawer#withVflex(java.lang.String)
	 */
	public IDrawer.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IDrawer#withHflex(java.lang.String)
	 */
	public IDrawer.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IDrawer#withRenderdefer(int)
	 */
	public IDrawer.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IDrawer#withClientAction(java.lang.String)
	 */
	public IDrawer.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IDrawer#withTabindex(java.lang.Integer)
	 */
	public IDrawer.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IDrawer#withCtrlKeys(java.lang.String)
	 */
	public IDrawer.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IDrawer#withContext(java.lang.String)
	 */
	public IDrawer.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IDrawer#withPopup(java.lang.String)
	 */
	public IDrawer.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IDrawer#withTooltip(java.lang.String)
	 */
	public IDrawer.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IDrawer#withWidgetClass(java.lang.String)
	 */
	public IDrawer.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code title} to update to client widget
	 *
	 * @param title The new value for {@code title}
	 * @see IDrawer#withTitle(java.lang.String)
	 */
	public IDrawer.Updater title(java.lang.String title) {
		keys.add("title");
		builder.setTitle(title);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code position} to update to client widget
	 *
	 * @param position The new value for {@code position}
	 * @see IDrawer#withPosition(java.lang.String)
	 */
	public IDrawer.Updater position(java.lang.String position) {
		keys.add("position");
		builder.setPosition(position);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code mask} to update to client widget
	 *
	 * @param mask The new value for {@code mask}
	 * @see IDrawer#withMask(boolean)
	 */
	public IDrawer.Updater mask(boolean mask) {
		keys.add("mask");
		builder.setMask(mask);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code closable} to update to client widget
	 *
	 * @param closable The new value for {@code closable}
	 * @see IDrawer#withClosable(boolean)
	 */
	public IDrawer.Updater closable(boolean closable) {
		keys.add("closable");
		builder.setClosable(closable);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code autodrop} to update to client widget
	 *
	 * @param autodrop The new value for {@code autodrop}
	 * @see IDrawer#withAutodrop(boolean)
	 */
	public IDrawer.Updater autodrop(boolean autodrop) {
		keys.add("autodrop");
		builder.setAutodrop(autodrop);
		return (IDrawer.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IDrawer#withVisible(boolean)
	 */
	public IDrawer.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IDrawer.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
