// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IEast}.
 */
/*package*/ class IEastUpdater implements SmartUpdater {
	private final IEast.Builder builder = new IEast.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IEast#withId(java.lang.String)
	 */
	public IEast.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IEast#withVisible(boolean)
	 */
	public IEast.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IEast#withMold(java.lang.String)
	 */
	public IEast.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IEast#withLeft(java.lang.String)
	 */
	public IEast.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IEast#withTop(java.lang.String)
	 */
	public IEast.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IEast#withZIndex(int)
	 */
	public IEast.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IEast#withHeight(java.lang.String)
	 */
	public IEast.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IEast#withWidth(java.lang.String)
	 */
	public IEast.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IEast#withTooltiptext(java.lang.String)
	 */
	public IEast.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IEast#withZclass(java.lang.String)
	 */
	public IEast.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IEast#withSclass(java.lang.String)
	 */
	public IEast.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IEast#withStyle(java.lang.String)
	 */
	public IEast.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IEast#withDraggable(java.lang.String)
	 */
	public IEast.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IEast#withFocus(boolean)
	 */
	public IEast.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IEast#withDroppable(java.lang.String)
	 */
	public IEast.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IEast#withVflex(java.lang.String)
	 */
	public IEast.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IEast#withHflex(java.lang.String)
	 */
	public IEast.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IEast#withRenderdefer(int)
	 */
	public IEast.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IEast#withClientAction(java.lang.String)
	 */
	public IEast.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IEast#withTabindex(java.lang.Integer)
	 */
	public IEast.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IEast#withCtrlKeys(java.lang.String)
	 */
	public IEast.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IEast#withContext(java.lang.String)
	 */
	public IEast.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IEast#withPopup(java.lang.String)
	 */
	public IEast.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IEast#withTooltip(java.lang.String)
	 */
	public IEast.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code title} to update to client widget
	 *
	 * @param title The new value for {@code title}
	 * @see IEast#withTitle(java.lang.String)
	 */
	public IEast.Updater title(java.lang.String title) {
		keys.add("title");
		builder.setTitle(title);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code border} to update to client widget
	 *
	 * @param border The new value for {@code border}
	 * @see IEast#withBorder(java.lang.String)
	 */
	public IEast.Updater border(java.lang.String border) {
		keys.add("border");
		builder.setBorder(border);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code autoscroll} to update to client widget
	 *
	 * @param autoscroll The new value for {@code autoscroll}
	 * @see IEast#withAutoscroll(boolean)
	 */
	public IEast.Updater autoscroll(boolean autoscroll) {
		keys.add("autoscroll");
		builder.setAutoscroll(autoscroll);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code margins} to update to client widget
	 *
	 * @param margins The new value for {@code margins}
	 * @see IEast#withMargins(java.lang.String)
	 */
	public IEast.Updater margins(java.lang.String margins) {
		keys.add("margins");
		builder.setMargins(margins);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code maxsize} to update to client widget
	 *
	 * @param maxsize The new value for {@code maxsize}
	 * @see IEast#withMaxsize(int)
	 */
	public IEast.Updater maxsize(int maxsize) {
		keys.add("maxsize");
		builder.setMaxsize(maxsize);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code minsize} to update to client widget
	 *
	 * @param minsize The new value for {@code minsize}
	 * @see IEast#withMinsize(int)
	 */
	public IEast.Updater minsize(int minsize) {
		keys.add("minsize");
		builder.setMinsize(minsize);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code splittable} to update to client widget
	 *
	 * @param splittable The new value for {@code splittable}
	 * @see IEast#withSplittable(boolean)
	 */
	public IEast.Updater splittable(boolean splittable) {
		keys.add("splittable");
		builder.setSplittable(splittable);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code collapsible} to update to client widget
	 *
	 * @param collapsible The new value for {@code collapsible}
	 * @see IEast#withCollapsible(boolean)
	 */
	public IEast.Updater collapsible(boolean collapsible) {
		keys.add("collapsible");
		builder.setCollapsible(collapsible);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code open} to update to client widget
	 *
	 * @param open The new value for {@code open}
	 * @see IEast#withOpen(boolean)
	 */
	public IEast.Updater open(boolean open) {
		keys.add("open");
		builder.setOpen(open);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code slidable} to update to client widget
	 *
	 * @param slidable The new value for {@code slidable}
	 * @see IEast#withSlidable(boolean)
	 */
	public IEast.Updater slidable(boolean slidable) {
		keys.add("slidable");
		builder.setSlidable(slidable);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code slide} to update to client widget
	 *
	 * @param slide The new value for {@code slide}
	 * @see IEast#withSlide(boolean)
	 */
	public IEast.Updater slide(boolean slide) {
		keys.add("slide");
		builder.setSlide(slide);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code closable} to update to client widget
	 *
	 * @param closable The new value for {@code closable}
	 * @see IEast#withClosable(boolean)
	 */
	public IEast.Updater closable(boolean closable) {
		keys.add("closable");
		builder.setClosable(closable);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code nativeScrollbar} to update to client widget
	 *
	 * @param nativeScrollbar The new value for {@code nativeScrollbar}
	 * @see IEast#withNativeScrollbar(boolean)
	 */
	public IEast.Updater nativeScrollbar(boolean nativeScrollbar) {
		keys.add("nativeScrollbar");
		builder.setNativeScrollbar(nativeScrollbar);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IEast#withWidgetClass(java.lang.String)
	 */
	public IEast.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IEast.Updater) this;
	}

	/**
	 * Sets the given value of {@code cmargins} to update to client widget
	 *
	 * @param cmargins The new value for {@code cmargins}
	 * @see IEast#withCmargins(java.lang.String)
	 */
	public IEast.Updater cmargins(java.lang.String cmargins) {
		keys.add("cmargins");
		builder.setCmargins(cmargins);
		return (IEast.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
