// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IFisheyebar}.
 */
/*package*/ class IFisheyebarUpdater implements SmartUpdater {
	private final IFisheyebar.Builder builder = new IFisheyebar.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IFisheyebar#withId(java.lang.String)
	 */
	public IFisheyebar.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IFisheyebar#withVisible(boolean)
	 */
	public IFisheyebar.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IFisheyebar#withMold(java.lang.String)
	 */
	public IFisheyebar.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IFisheyebar#withLeft(java.lang.String)
	 */
	public IFisheyebar.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IFisheyebar#withTop(java.lang.String)
	 */
	public IFisheyebar.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IFisheyebar#withZIndex(int)
	 */
	public IFisheyebar.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IFisheyebar#withHeight(java.lang.String)
	 */
	public IFisheyebar.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IFisheyebar#withWidth(java.lang.String)
	 */
	public IFisheyebar.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IFisheyebar#withTooltiptext(java.lang.String)
	 */
	public IFisheyebar.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IFisheyebar#withZclass(java.lang.String)
	 */
	public IFisheyebar.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IFisheyebar#withSclass(java.lang.String)
	 */
	public IFisheyebar.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IFisheyebar#withStyle(java.lang.String)
	 */
	public IFisheyebar.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IFisheyebar#withDraggable(java.lang.String)
	 */
	public IFisheyebar.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IFisheyebar#withFocus(boolean)
	 */
	public IFisheyebar.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IFisheyebar#withDroppable(java.lang.String)
	 */
	public IFisheyebar.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IFisheyebar#withVflex(java.lang.String)
	 */
	public IFisheyebar.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IFisheyebar#withHflex(java.lang.String)
	 */
	public IFisheyebar.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IFisheyebar#withRenderdefer(int)
	 */
	public IFisheyebar.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IFisheyebar#withClientAction(java.lang.String)
	 */
	public IFisheyebar.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IFisheyebar#withTabindex(java.lang.Integer)
	 */
	public IFisheyebar.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IFisheyebar#withCtrlKeys(java.lang.String)
	 */
	public IFisheyebar.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IFisheyebar#withContext(java.lang.String)
	 */
	public IFisheyebar.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IFisheyebar#withPopup(java.lang.String)
	 */
	public IFisheyebar.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IFisheyebar#withTooltip(java.lang.String)
	 */
	public IFisheyebar.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IFisheyebar#withWidgetClass(java.lang.String)
	 */
	public IFisheyebar.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code orient} to update to client widget
	 *
	 * @param orient The new value for {@code orient}
	 * @see IFisheyebar#withOrient(java.lang.String)
	 */
	public IFisheyebar.Updater orient(java.lang.String orient) {
		keys.add("orient");
		builder.setOrient(orient);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code attachEdge} to update to client widget
	 *
	 * @param attachEdge The new value for {@code attachEdge}
	 * @see IFisheyebar#withAttachEdge(java.lang.String)
	 */
	public IFisheyebar.Updater attachEdge(java.lang.String attachEdge) {
		keys.add("attachEdge");
		builder.setAttachEdge(attachEdge);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code labelEdge} to update to client widget
	 *
	 * @param labelEdge The new value for {@code labelEdge}
	 * @see IFisheyebar#withLabelEdge(java.lang.String)
	 */
	public IFisheyebar.Updater labelEdge(java.lang.String labelEdge) {
		keys.add("labelEdge");
		builder.setLabelEdge(labelEdge);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code itemWidth} to update to client widget
	 *
	 * @param itemWidth The new value for {@code itemWidth}
	 * @see IFisheyebar#withItemWidth(int)
	 */
	public IFisheyebar.Updater itemWidth(int itemWidth) {
		keys.add("itemWidth");
		builder.setItemWidth(itemWidth);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code itemHeight} to update to client widget
	 *
	 * @param itemHeight The new value for {@code itemHeight}
	 * @see IFisheyebar#withItemHeight(int)
	 */
	public IFisheyebar.Updater itemHeight(int itemHeight) {
		keys.add("itemHeight");
		builder.setItemHeight(itemHeight);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code itemMaxWidth} to update to client widget
	 *
	 * @param itemMaxWidth The new value for {@code itemMaxWidth}
	 * @see IFisheyebar#withItemMaxWidth(int)
	 */
	public IFisheyebar.Updater itemMaxWidth(int itemMaxWidth) {
		keys.add("itemMaxWidth");
		builder.setItemMaxWidth(itemMaxWidth);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code itemMaxHeight} to update to client widget
	 *
	 * @param itemMaxHeight The new value for {@code itemMaxHeight}
	 * @see IFisheyebar#withItemMaxHeight(int)
	 */
	public IFisheyebar.Updater itemMaxHeight(int itemMaxHeight) {
		keys.add("itemMaxHeight");
		builder.setItemMaxHeight(itemMaxHeight);
		return (IFisheyebar.Updater) this;
	}

	/**
	 * Sets the given value of {@code itemPadding} to update to client widget
	 *
	 * @param itemPadding The new value for {@code itemPadding}
	 * @see IFisheyebar#withItemPadding(int)
	 */
	public IFisheyebar.Updater itemPadding(int itemPadding) {
		keys.add("itemPadding");
		builder.setItemPadding(itemPadding);
		return (IFisheyebar.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
