// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IGoldenPanel}.
 */
/*package*/ class IGoldenPanelUpdater implements SmartUpdater {
	private final IGoldenPanel.Builder builder = new IGoldenPanel.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IGoldenPanel#withId(java.lang.String)
	 */
	public IGoldenPanel.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IGoldenPanel#withVisible(boolean)
	 */
	public IGoldenPanel.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IGoldenPanel#withMold(java.lang.String)
	 */
	public IGoldenPanel.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IGoldenPanel#withLeft(java.lang.String)
	 */
	public IGoldenPanel.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IGoldenPanel#withTop(java.lang.String)
	 */
	public IGoldenPanel.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IGoldenPanel#withZIndex(int)
	 */
	public IGoldenPanel.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IGoldenPanel#withTooltiptext(java.lang.String)
	 */
	public IGoldenPanel.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IGoldenPanel#withZclass(java.lang.String)
	 */
	public IGoldenPanel.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IGoldenPanel#withSclass(java.lang.String)
	 */
	public IGoldenPanel.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IGoldenPanel#withStyle(java.lang.String)
	 */
	public IGoldenPanel.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IGoldenPanel#withFocus(boolean)
	 */
	public IGoldenPanel.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IGoldenPanel#withVflex(java.lang.String)
	 */
	public IGoldenPanel.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IGoldenPanel#withHflex(java.lang.String)
	 */
	public IGoldenPanel.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IGoldenPanel#withRenderdefer(int)
	 */
	public IGoldenPanel.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IGoldenPanel#withClientAction(java.lang.String)
	 */
	public IGoldenPanel.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IGoldenPanel#withTabindex(java.lang.Integer)
	 */
	public IGoldenPanel.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IGoldenPanel#withCtrlKeys(java.lang.String)
	 */
	public IGoldenPanel.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IGoldenPanel#withContext(java.lang.String)
	 */
	public IGoldenPanel.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IGoldenPanel#withPopup(java.lang.String)
	 */
	public IGoldenPanel.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IGoldenPanel#withTooltip(java.lang.String)
	 */
	public IGoldenPanel.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IGoldenPanel#withWidgetClass(java.lang.String)
	 */
	public IGoldenPanel.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code area} to update to client widget
	 *
	 * @param area The new value for {@code area}
	 * @see IGoldenPanel#withArea(java.lang.String)
	 */
	public IGoldenPanel.Updater area(java.lang.String area) {
		keys.add("area");
		builder.setArea(area);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code title} to update to client widget
	 *
	 * @param title The new value for {@code title}
	 * @see IGoldenPanel#withTitle(java.lang.String)
	 */
	public IGoldenPanel.Updater title(java.lang.String title) {
		keys.add("title");
		builder.setTitle(title);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IGoldenPanel#withDraggable(java.lang.String)
	 */
	public IGoldenPanel.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code closable} to update to client widget
	 *
	 * @param closable The new value for {@code closable}
	 * @see IGoldenPanel#withClosable(boolean)
	 */
	public IGoldenPanel.Updater closable(boolean closable) {
		keys.add("closable");
		builder.setClosable(closable);
		return (IGoldenPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IGoldenPanel#withDroppable(java.lang.String)
	 */
	public IGoldenPanel.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IGoldenPanel.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
