// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IGrid}.
 */
/*package*/ class IGridUpdater implements SmartUpdater {
	private final IGrid.Builder builder = new IGrid.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IGrid#withId(java.lang.String)
	 */
	public IGrid.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IGrid#withVisible(boolean)
	 */
	public IGrid.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IGrid#withMold(java.lang.String)
	 */
	public IGrid.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IGrid#withLeft(java.lang.String)
	 */
	public IGrid.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IGrid#withTop(java.lang.String)
	 */
	public IGrid.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IGrid#withZIndex(int)
	 */
	public IGrid.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IGrid#withHeight(java.lang.String)
	 */
	public IGrid.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IGrid#withWidth(java.lang.String)
	 */
	public IGrid.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IGrid#withTooltiptext(java.lang.String)
	 */
	public IGrid.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IGrid#withZclass(java.lang.String)
	 */
	public IGrid.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IGrid#withSclass(java.lang.String)
	 */
	public IGrid.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IGrid#withStyle(java.lang.String)
	 */
	public IGrid.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IGrid#withDraggable(java.lang.String)
	 */
	public IGrid.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IGrid#withFocus(boolean)
	 */
	public IGrid.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IGrid#withDroppable(java.lang.String)
	 */
	public IGrid.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IGrid#withVflex(java.lang.String)
	 */
	public IGrid.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IGrid#withHflex(java.lang.String)
	 */
	public IGrid.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IGrid#withRenderdefer(int)
	 */
	public IGrid.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IGrid#withClientAction(java.lang.String)
	 */
	public IGrid.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IGrid#withTabindex(java.lang.Integer)
	 */
	public IGrid.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IGrid#withCtrlKeys(java.lang.String)
	 */
	public IGrid.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IGrid#withContext(java.lang.String)
	 */
	public IGrid.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IGrid#withPopup(java.lang.String)
	 */
	public IGrid.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IGrid#withTooltip(java.lang.String)
	 */
	public IGrid.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code span} to update to client widget
	 *
	 * @param span The new value for {@code span}
	 * @see IGrid#withSpan(java.lang.String)
	 */
	public IGrid.Updater span(java.lang.String span) {
		keys.add("span");
		builder.setSpan(span);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code sizedByContent} to update to client widget
	 *
	 * @param sizedByContent The new value for {@code sizedByContent}
	 * @see IGrid#withSizedByContent(boolean)
	 */
	public IGrid.Updater sizedByContent(boolean sizedByContent) {
		keys.add("sizedByContent");
		builder.setSizedByContent(sizedByContent);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code autopaging} to update to client widget
	 *
	 * @param autopaging The new value for {@code autopaging}
	 * @see IGrid#withAutopaging(boolean)
	 */
	public IGrid.Updater autopaging(boolean autopaging) {
		keys.add("autopaging");
		builder.setAutopaging(autopaging);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code pagingPosition} to update to client widget
	 *
	 * @param pagingPosition The new value for {@code pagingPosition}
	 * @see IGrid#withPagingPosition(java.lang.String)
	 */
	public IGrid.Updater pagingPosition(java.lang.String pagingPosition) {
		keys.add("pagingPosition");
		builder.setPagingPosition(pagingPosition);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code nativeScrollbar} to update to client widget
	 *
	 * @param nativeScrollbar The new value for {@code nativeScrollbar}
	 * @see IGrid#withNativeScrollbar(boolean)
	 */
	public IGrid.Updater nativeScrollbar(boolean nativeScrollbar) {
		keys.add("nativeScrollbar");
		builder.setNativeScrollbar(nativeScrollbar);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IGrid#withWidgetClass(java.lang.String)
	 */
	public IGrid.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code emptyMessage} to update to client widget
	 *
	 * @param emptyMessage The new value for {@code emptyMessage}
	 * @see IGrid#withEmptyMessage(java.lang.String)
	 */
	public IGrid.Updater emptyMessage(java.lang.String emptyMessage) {
		keys.add("emptyMessage");
		builder.setEmptyMessage(emptyMessage);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code visibleRows} to update to client widget
	 *
	 * @param visibleRows The new value for {@code visibleRows}
	 * @see IGrid#withVisibleRows(int)
	 */
	public IGrid.Updater visibleRows(int visibleRows) {
		keys.add("visibleRows");
		builder.setVisibleRows(visibleRows);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code innerWidth} to update to client widget
	 *
	 * @param innerWidth The new value for {@code innerWidth}
	 * @see IGrid#withInnerWidth(java.lang.String)
	 */
	public IGrid.Updater innerWidth(java.lang.String innerWidth) {
		keys.add("innerWidth");
		builder.setInnerWidth(innerWidth);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code autosort} to update to client widget
	 *
	 * @param autosort The new value for {@code autosort}
	 * @see IGrid#withAutosort(java.lang.String)
	 */
	public IGrid.Updater autosort(java.lang.String autosort) {
		keys.add("autosort");
		builder.setAutosort(autosort);
		return (IGrid.Updater) this;
	}

	/**
	 * Sets the given value of {@code oddRowSclass} to update to client widget
	 *
	 * @param oddRowSclass The new value for {@code oddRowSclass}
	 * @see IGrid#withOddRowSclass(java.lang.String)
	 */
	public IGrid.Updater oddRowSclass(java.lang.String oddRowSclass) {
		keys.add("oddRowSclass");
		builder.setOddRowSclass(oddRowSclass);
		return (IGrid.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
