// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IGroupbox}.
 */
/*package*/ class IGroupboxUpdater implements SmartUpdater {
	private final IGroupbox.Builder builder = new IGroupbox.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IGroupbox#withId(java.lang.String)
	 */
	public IGroupbox.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IGroupbox#withVisible(boolean)
	 */
	public IGroupbox.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IGroupbox#withMold(java.lang.String)
	 */
	public IGroupbox.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IGroupbox#withLeft(java.lang.String)
	 */
	public IGroupbox.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IGroupbox#withTop(java.lang.String)
	 */
	public IGroupbox.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IGroupbox#withZIndex(int)
	 */
	public IGroupbox.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IGroupbox#withHeight(java.lang.String)
	 */
	public IGroupbox.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IGroupbox#withWidth(java.lang.String)
	 */
	public IGroupbox.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IGroupbox#withTooltiptext(java.lang.String)
	 */
	public IGroupbox.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IGroupbox#withZclass(java.lang.String)
	 */
	public IGroupbox.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IGroupbox#withSclass(java.lang.String)
	 */
	public IGroupbox.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IGroupbox#withStyle(java.lang.String)
	 */
	public IGroupbox.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IGroupbox#withDraggable(java.lang.String)
	 */
	public IGroupbox.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IGroupbox#withFocus(boolean)
	 */
	public IGroupbox.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IGroupbox#withDroppable(java.lang.String)
	 */
	public IGroupbox.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IGroupbox#withVflex(java.lang.String)
	 */
	public IGroupbox.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IGroupbox#withHflex(java.lang.String)
	 */
	public IGroupbox.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IGroupbox#withRenderdefer(int)
	 */
	public IGroupbox.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IGroupbox#withClientAction(java.lang.String)
	 */
	public IGroupbox.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IGroupbox#withTabindex(java.lang.Integer)
	 */
	public IGroupbox.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IGroupbox#withCtrlKeys(java.lang.String)
	 */
	public IGroupbox.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IGroupbox#withContext(java.lang.String)
	 */
	public IGroupbox.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IGroupbox#withPopup(java.lang.String)
	 */
	public IGroupbox.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IGroupbox#withTooltip(java.lang.String)
	 */
	public IGroupbox.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IGroupbox#withWidgetClass(java.lang.String)
	 */
	public IGroupbox.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code contentStyle} to update to client widget
	 *
	 * @param contentStyle The new value for {@code contentStyle}
	 * @see IGroupbox#withContentStyle(java.lang.String)
	 */
	public IGroupbox.Updater contentStyle(java.lang.String contentStyle) {
		keys.add("contentStyle");
		builder.setContentStyle(contentStyle);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code contentSclass} to update to client widget
	 *
	 * @param contentSclass The new value for {@code contentSclass}
	 * @see IGroupbox#withContentSclass(java.lang.String)
	 */
	public IGroupbox.Updater contentSclass(java.lang.String contentSclass) {
		keys.add("contentSclass");
		builder.setContentSclass(contentSclass);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code title} to update to client widget
	 *
	 * @param title The new value for {@code title}
	 * @see IGroupbox#withTitle(java.lang.String)
	 */
	public IGroupbox.Updater title(java.lang.String title) {
		keys.add("title");
		builder.setTitle(title);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code open} to update to client widget
	 *
	 * @param open The new value for {@code open}
	 * @see IGroupbox#withOpen(boolean)
	 */
	public IGroupbox.Updater open(boolean open) {
		keys.add("open");
		builder.setOpen(open);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code closable} to update to client widget
	 *
	 * @param closable The new value for {@code closable}
	 * @see IGroupbox#withClosable(boolean)
	 */
	public IGroupbox.Updater closable(boolean closable) {
		keys.add("closable");
		builder.setClosable(closable);
		return (IGroupbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code nativeScrollbar} to update to client widget
	 *
	 * @param nativeScrollbar The new value for {@code nativeScrollbar}
	 * @see IGroupbox#withNativeScrollbar(boolean)
	 */
	public IGroupbox.Updater nativeScrollbar(boolean nativeScrollbar) {
		keys.add("nativeScrollbar");
		builder.setNativeScrollbar(nativeScrollbar);
		return (IGroupbox.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
