// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IGroupfoot}.
 */
/*package*/ class IGroupfootUpdater implements SmartUpdater {
	private final IGroupfoot.Builder builder = new IGroupfoot.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IGroupfoot#withId(java.lang.String)
	 */
	public IGroupfoot.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IGroupfoot#withVisible(boolean)
	 */
	public IGroupfoot.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IGroupfoot#withMold(java.lang.String)
	 */
	public IGroupfoot.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IGroupfoot#withLeft(java.lang.String)
	 */
	public IGroupfoot.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IGroupfoot#withTop(java.lang.String)
	 */
	public IGroupfoot.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IGroupfoot#withZIndex(int)
	 */
	public IGroupfoot.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IGroupfoot#withHeight(java.lang.String)
	 */
	public IGroupfoot.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IGroupfoot#withWidth(java.lang.String)
	 */
	public IGroupfoot.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IGroupfoot#withTooltiptext(java.lang.String)
	 */
	public IGroupfoot.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IGroupfoot#withZclass(java.lang.String)
	 */
	public IGroupfoot.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IGroupfoot#withSclass(java.lang.String)
	 */
	public IGroupfoot.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IGroupfoot#withStyle(java.lang.String)
	 */
	public IGroupfoot.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IGroupfoot#withDraggable(java.lang.String)
	 */
	public IGroupfoot.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IGroupfoot#withFocus(boolean)
	 */
	public IGroupfoot.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IGroupfoot#withDroppable(java.lang.String)
	 */
	public IGroupfoot.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IGroupfoot#withVflex(java.lang.String)
	 */
	public IGroupfoot.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IGroupfoot#withHflex(java.lang.String)
	 */
	public IGroupfoot.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IGroupfoot#withRenderdefer(int)
	 */
	public IGroupfoot.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IGroupfoot#withClientAction(java.lang.String)
	 */
	public IGroupfoot.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IGroupfoot#withTabindex(java.lang.Integer)
	 */
	public IGroupfoot.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IGroupfoot#withCtrlKeys(java.lang.String)
	 */
	public IGroupfoot.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IGroupfoot#withContext(java.lang.String)
	 */
	public IGroupfoot.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IGroupfoot#withPopup(java.lang.String)
	 */
	public IGroupfoot.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IGroupfoot#withTooltip(java.lang.String)
	 */
	public IGroupfoot.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code align} to update to client widget
	 *
	 * @param align The new value for {@code align}
	 * @see IGroupfoot#withAlign(java.lang.String)
	 */
	public IGroupfoot.Updater align(java.lang.String align) {
		keys.add("align");
		builder.setAlign(align);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code valign} to update to client widget
	 *
	 * @param valign The new value for {@code valign}
	 * @see IGroupfoot#withValign(java.lang.String)
	 */
	public IGroupfoot.Updater valign(java.lang.String valign) {
		keys.add("valign");
		builder.setValign(valign);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code nowrap} to update to client widget
	 *
	 * @param nowrap The new value for {@code nowrap}
	 * @see IGroupfoot#withNowrap(boolean)
	 */
	public IGroupfoot.Updater nowrap(boolean nowrap) {
		keys.add("nowrap");
		builder.setNowrap(nowrap);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code loaded} to update to client widget
	 *
	 * @param loaded The new value for {@code loaded}
	 * @see IGroupfoot#withLoaded(boolean)
	 */
	public IGroupfoot.Updater loaded(boolean loaded) {
		keys.add("loaded");
		builder.setLoaded(loaded);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code index} to update to client widget
	 *
	 * @param index The new value for {@code index}
	 * @see IGroupfoot#withIndex(int)
	 */
	public IGroupfoot.Updater index(int index) {
		keys.add("index");
		builder.setIndex(index);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IGroupfoot#withWidgetClass(java.lang.String)
	 */
	public IGroupfoot.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IGroupfoot.Updater) this;
	}

	/**
	 * Sets the given value of {@code label} to update to client widget
	 *
	 * @param label The new value for {@code label}
	 * @see IGroupfoot#withLabel(java.lang.String)
	 */
	public IGroupfoot.Updater label(java.lang.String label) {
		keys.add("label");
		builder.setLabel(label);
		return (IGroupfoot.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
