// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Locale;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IIntbox}.
 */
/*package*/ class IIntboxUpdater implements SmartUpdater {
	private final IIntbox.Builder builder = new IIntbox.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IIntbox#withId(java.lang.String)
	 */
	public IIntbox.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IIntbox#withVisible(boolean)
	 */
	public IIntbox.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IIntbox#withMold(java.lang.String)
	 */
	public IIntbox.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IIntbox#withLeft(java.lang.String)
	 */
	public IIntbox.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IIntbox#withTop(java.lang.String)
	 */
	public IIntbox.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IIntbox#withZIndex(int)
	 */
	public IIntbox.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IIntbox#withHeight(java.lang.String)
	 */
	public IIntbox.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IIntbox#withWidth(java.lang.String)
	 */
	public IIntbox.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IIntbox#withTooltiptext(java.lang.String)
	 */
	public IIntbox.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IIntbox#withZclass(java.lang.String)
	 */
	public IIntbox.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IIntbox#withSclass(java.lang.String)
	 */
	public IIntbox.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IIntbox#withStyle(java.lang.String)
	 */
	public IIntbox.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IIntbox#withDraggable(java.lang.String)
	 */
	public IIntbox.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IIntbox#withFocus(boolean)
	 */
	public IIntbox.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IIntbox#withDroppable(java.lang.String)
	 */
	public IIntbox.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IIntbox#withVflex(java.lang.String)
	 */
	public IIntbox.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IIntbox#withHflex(java.lang.String)
	 */
	public IIntbox.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IIntbox#withRenderdefer(int)
	 */
	public IIntbox.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IIntbox#withClientAction(java.lang.String)
	 */
	public IIntbox.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IIntbox#withTabindex(java.lang.Integer)
	 */
	public IIntbox.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IIntbox#withCtrlKeys(java.lang.String)
	 */
	public IIntbox.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IIntbox#withContext(java.lang.String)
	 */
	public IIntbox.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IIntbox#withPopup(java.lang.String)
	 */
	public IIntbox.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IIntbox#withTooltip(java.lang.String)
	 */
	public IIntbox.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code readonly} to update to client widget
	 *
	 * @param readonly The new value for {@code readonly}
	 * @see IIntbox#withReadonly(boolean)
	 */
	public IIntbox.Updater readonly(boolean readonly) {
		keys.add("readonly");
		builder.setReadonly(readonly);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code name} to update to client widget
	 *
	 * @param name The new value for {@code name}
	 * @see IIntbox#withName(java.lang.String)
	 */
	public IIntbox.Updater name(java.lang.String name) {
		keys.add("name");
		builder.setName(name);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code placeholder} to update to client widget
	 *
	 * @param placeholder The new value for {@code placeholder}
	 * @see IIntbox#withPlaceholder(java.lang.String)
	 */
	public IIntbox.Updater placeholder(java.lang.String placeholder) {
		keys.add("placeholder");
		builder.setPlaceholder(placeholder);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code value} to update to client widget
	 *
	 * @param value The new value for {@code value}
	 * @see IIntbox#withValue(java.lang.Integer)
	 */
	public IIntbox.Updater value(Integer value) {
		keys.add("value");
		builder.setValue(value);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code constraint} to update to client widget
	 *
	 * @param constraint The new value for {@code constraint}
	 * @see IIntbox#withConstraint(java.lang.String)
	 */
	public IIntbox.Updater constraint(java.lang.String constraint) {
		keys.add("constraint");
		builder.setConstraint(constraint);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorboxSclass} to update to client widget
	 *
	 * @param errorboxSclass The new value for {@code errorboxSclass}
	 * @see IIntbox#withErrorboxSclass(java.lang.String)
	 */
	public IIntbox.Updater errorboxSclass(java.lang.String errorboxSclass) {
		keys.add("errorboxSclass");
		builder.setErrorboxSclass(errorboxSclass);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorboxIconSclass} to update to client widget
	 *
	 * @param errorboxIconSclass The new value for {@code errorboxIconSclass}
	 * @see IIntbox#withErrorboxIconSclass(java.lang.String)
	 */
	public IIntbox.Updater errorboxIconSclass(java.lang.String errorboxIconSclass) {
		keys.add("errorboxIconSclass");
		builder.setErrorboxIconSclass(errorboxIconSclass);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see IIntbox#withDisabled(boolean)
	 */
	public IIntbox.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code inplace} to update to client widget
	 *
	 * @param inplace The new value for {@code inplace}
	 * @see IIntbox#withInplace(boolean)
	 */
	public IIntbox.Updater inplace(boolean inplace) {
		keys.add("inplace");
		builder.setInplace(inplace);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code maxlength} to update to client widget
	 *
	 * @param maxlength The new value for {@code maxlength}
	 * @see IIntbox#withMaxlength(int)
	 */
	public IIntbox.Updater maxlength(int maxlength) {
		keys.add("maxlength");
		builder.setMaxlength(maxlength);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code instant} to update to client widget
	 *
	 * @param instant The new value for {@code instant}
	 * @see IIntbox#withInstant(boolean)
	 */
	public IIntbox.Updater instant(boolean instant) {
		keys.add("instant");
		builder.setInstant(instant);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorMessage} to update to client widget
	 *
	 * @param errorMessage The new value for {@code errorMessage}
	 * @see IIntbox#withErrorMessage(java.lang.String)
	 */
	public IIntbox.Updater errorMessage(java.lang.String errorMessage) {
		keys.add("errorMessage");
		builder.setErrorMessage(errorMessage);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code format} to update to client widget
	 *
	 * @param format The new value for {@code format}
	 * @see IIntbox#withFormat(java.lang.String)
	 */
	public IIntbox.Updater format(java.lang.String format) {
		keys.add("format");
		builder.setFormat(format);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code locale} to update to client widget
	 *
	 * @param locale The new value for {@code locale}
	 * @see IIntbox#withLocale(java.util.Locale)
	 */
	public IIntbox.Updater locale(Locale locale) {
		keys.add("locale");
		builder.setLocale(locale);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code cols} to update to client widget
	 *
	 * @param cols The new value for {@code cols}
	 * @see IIntbox#withCols(int)
	 */
	public IIntbox.Updater cols(int cols) {
		keys.add("cols");
		builder.setCols(cols);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code roundingMode} to update to client widget
	 *
	 * @param roundingMode The new value for {@code roundingMode}
	 * @see IIntbox#withRoundingMode(int)
	 */
	public IIntbox.Updater roundingMode(int roundingMode) {
		keys.add("roundingMode");
		builder.setRoundingMode(roundingMode);
		return (IIntbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IIntbox#withWidgetClass(java.lang.String)
	 */
	public IIntbox.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IIntbox.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
