// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.image.Image;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ILineitem}.
 */
/*package*/ class ILineitemUpdater implements SmartUpdater {
	private final ILineitem.Builder builder = new ILineitem.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ILineitem#withId(java.lang.String)
	 */
	public ILineitem.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ILineitem#withVisible(boolean)
	 */
	public ILineitem.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ILineitem#withMold(java.lang.String)
	 */
	public ILineitem.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ILineitem#withLeft(java.lang.String)
	 */
	public ILineitem.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ILineitem#withTop(java.lang.String)
	 */
	public ILineitem.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ILineitem#withZIndex(int)
	 */
	public ILineitem.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ILineitem#withHeight(java.lang.String)
	 */
	public ILineitem.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see ILineitem#withWidth(java.lang.String)
	 */
	public ILineitem.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ILineitem#withTooltiptext(java.lang.String)
	 */
	public ILineitem.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ILineitem#withZclass(java.lang.String)
	 */
	public ILineitem.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ILineitem#withSclass(java.lang.String)
	 */
	public ILineitem.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ILineitem#withStyle(java.lang.String)
	 */
	public ILineitem.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ILineitem#withDraggable(java.lang.String)
	 */
	public ILineitem.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ILineitem#withFocus(boolean)
	 */
	public ILineitem.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ILineitem#withDroppable(java.lang.String)
	 */
	public ILineitem.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ILineitem#withVflex(java.lang.String)
	 */
	public ILineitem.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see ILineitem#withHflex(java.lang.String)
	 */
	public ILineitem.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ILineitem#withRenderdefer(int)
	 */
	public ILineitem.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ILineitem#withClientAction(java.lang.String)
	 */
	public ILineitem.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ILineitem#withTabindex(java.lang.Integer)
	 */
	public ILineitem.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see ILineitem#withCtrlKeys(java.lang.String)
	 */
	public ILineitem.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see ILineitem#withContext(java.lang.String)
	 */
	public ILineitem.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see ILineitem#withPopup(java.lang.String)
	 */
	public ILineitem.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see ILineitem#withTooltip(java.lang.String)
	 */
	public ILineitem.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ILineitem#withWidgetClass(java.lang.String)
	 */
	public ILineitem.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code pointStyle} to update to client widget
	 *
	 * @param pointStyle The new value for {@code pointStyle}
	 * @see ILineitem#withPointStyle(java.lang.String)
	 */
	public ILineitem.Updater pointStyle(java.lang.String pointStyle) {
		keys.add("pointStyle");
		builder.setPointStyle(pointStyle);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code pointIconSclass} to update to client widget
	 *
	 * @param pointIconSclass The new value for {@code pointIconSclass}
	 * @see ILineitem#withPointIconSclass(java.lang.String)
	 */
	public ILineitem.Updater pointIconSclass(java.lang.String pointIconSclass) {
		keys.add("pointIconSclass");
		builder.setPointIconSclass(pointIconSclass);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code frontSpace} to update to client widget
	 *
	 * @param frontSpace The new value for {@code frontSpace}
	 * @see ILineitem#withFrontSpace(java.lang.String)
	 */
	public ILineitem.Updater frontSpace(java.lang.String frontSpace) {
		keys.add("frontSpace");
		builder.setFrontSpace(frontSpace);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code backSpace} to update to client widget
	 *
	 * @param backSpace The new value for {@code backSpace}
	 * @see ILineitem#withBackSpace(java.lang.String)
	 */
	public ILineitem.Updater backSpace(java.lang.String backSpace) {
		keys.add("backSpace");
		builder.setBackSpace(backSpace);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code pointVisible} to update to client widget
	 *
	 * @param pointVisible The new value for {@code pointVisible}
	 * @see ILineitem#withPointVisible(boolean)
	 */
	public ILineitem.Updater pointVisible(boolean pointVisible) {
		keys.add("pointVisible");
		builder.setPointVisible(pointVisible);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code opposite} to update to client widget
	 *
	 * @param opposite The new value for {@code opposite}
	 * @see ILineitem#withOpposite(boolean)
	 */
	public ILineitem.Updater opposite(boolean opposite) {
		keys.add("opposite");
		builder.setOpposite(opposite);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code pointImageSrc} to update to client widget
	 *
	 * @param pointImageSrc The new value for {@code pointImageSrc}
	 * @see ILineitem#withPointImageSrc(java.lang.String)
	 */
	public ILineitem.Updater pointImageSrc(java.lang.String pointImageSrc) {
		keys.add("pointImageSrc");
		builder.setPointImageSrc(pointImageSrc);
		return (ILineitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code pointImageContent} to update to client widget
	 *
	 * @param pointImageContent The new value for {@code pointImageContent}
	 * @see ILineitem#withPointImageContent(org.zkoss.image.Image)
	 */
	public ILineitem.Updater pointImageContent(Image pointImageContent) {
		keys.add("pointImageContent");
		builder.setPointImageContent(pointImageContent);
		return (ILineitem.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
