// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IListhead}.
 */
/*package*/ class IListheadUpdater implements SmartUpdater {
	private final IListhead.Builder builder = new IListhead.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IListhead#withId(java.lang.String)
	 */
	public IListhead.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IListhead#withVisible(boolean)
	 */
	public IListhead.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IListhead#withMold(java.lang.String)
	 */
	public IListhead.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IListhead#withLeft(java.lang.String)
	 */
	public IListhead.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IListhead#withTop(java.lang.String)
	 */
	public IListhead.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IListhead#withZIndex(int)
	 */
	public IListhead.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IListhead#withTooltiptext(java.lang.String)
	 */
	public IListhead.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IListhead#withZclass(java.lang.String)
	 */
	public IListhead.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IListhead#withSclass(java.lang.String)
	 */
	public IListhead.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IListhead#withStyle(java.lang.String)
	 */
	public IListhead.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IListhead#withDraggable(java.lang.String)
	 */
	public IListhead.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IListhead#withFocus(boolean)
	 */
	public IListhead.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IListhead#withDroppable(java.lang.String)
	 */
	public IListhead.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IListhead#withRenderdefer(int)
	 */
	public IListhead.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IListhead#withClientAction(java.lang.String)
	 */
	public IListhead.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IListhead#withTabindex(java.lang.Integer)
	 */
	public IListhead.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IListhead#withCtrlKeys(java.lang.String)
	 */
	public IListhead.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IListhead#withContext(java.lang.String)
	 */
	public IListhead.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IListhead#withPopup(java.lang.String)
	 */
	public IListhead.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IListhead#withTooltip(java.lang.String)
	 */
	public IListhead.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code sizable} to update to client widget
	 *
	 * @param sizable The new value for {@code sizable}
	 * @see IListhead#withSizable(boolean)
	 */
	public IListhead.Updater sizable(boolean sizable) {
		keys.add("sizable");
		builder.setSizable(sizable);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IListhead#withWidgetClass(java.lang.String)
	 */
	public IListhead.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code columnshide} to update to client widget
	 *
	 * @param columnshide The new value for {@code columnshide}
	 * @see IListhead#withColumnshide(boolean)
	 */
	public IListhead.Updater columnshide(boolean columnshide) {
		keys.add("columnshide");
		builder.setColumnshide(columnshide);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code columnsgroup} to update to client widget
	 *
	 * @param columnsgroup The new value for {@code columnsgroup}
	 * @see IListhead#withColumnsgroup(boolean)
	 */
	public IListhead.Updater columnsgroup(boolean columnsgroup) {
		keys.add("columnsgroup");
		builder.setColumnsgroup(columnsgroup);
		return (IListhead.Updater) this;
	}

	/**
	 * Sets the given value of {@code menupopup} to update to client widget
	 *
	 * @param menupopup The new value for {@code menupopup}
	 * @see IListhead#withMenupopup(java.lang.String)
	 */
	public IListhead.Updater menupopup(java.lang.String menupopup) {
		keys.add("menupopup");
		builder.setMenupopup(menupopup);
		return (IListhead.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
