// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IMenu}.
 */
/*package*/ class IMenuUpdater implements SmartUpdater {
	private final IMenu.Builder builder = new IMenu.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IMenu#withId(java.lang.String)
	 */
	public IMenu.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IMenu#withVisible(boolean)
	 */
	public IMenu.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IMenu#withMold(java.lang.String)
	 */
	public IMenu.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IMenu#withLeft(java.lang.String)
	 */
	public IMenu.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IMenu#withTop(java.lang.String)
	 */
	public IMenu.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IMenu#withZIndex(int)
	 */
	public IMenu.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IMenu#withHeight(java.lang.String)
	 */
	public IMenu.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IMenu#withWidth(java.lang.String)
	 */
	public IMenu.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IMenu#withTooltiptext(java.lang.String)
	 */
	public IMenu.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IMenu#withZclass(java.lang.String)
	 */
	public IMenu.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IMenu#withSclass(java.lang.String)
	 */
	public IMenu.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IMenu#withStyle(java.lang.String)
	 */
	public IMenu.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IMenu#withDraggable(java.lang.String)
	 */
	public IMenu.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IMenu#withFocus(boolean)
	 */
	public IMenu.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IMenu#withDroppable(java.lang.String)
	 */
	public IMenu.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IMenu#withVflex(java.lang.String)
	 */
	public IMenu.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IMenu#withHflex(java.lang.String)
	 */
	public IMenu.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IMenu#withRenderdefer(int)
	 */
	public IMenu.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IMenu#withClientAction(java.lang.String)
	 */
	public IMenu.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IMenu#withTabindex(java.lang.Integer)
	 */
	public IMenu.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IMenu#withCtrlKeys(java.lang.String)
	 */
	public IMenu.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IMenu#withContext(java.lang.String)
	 */
	public IMenu.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IMenu#withPopup(java.lang.String)
	 */
	public IMenu.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IMenu#withTooltip(java.lang.String)
	 */
	public IMenu.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code label} to update to client widget
	 *
	 * @param label The new value for {@code label}
	 * @see IMenu#withLabel(java.lang.String)
	 */
	public IMenu.Updater label(java.lang.String label) {
		keys.add("label");
		builder.setLabel(label);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconSclass} to update to client widget
	 *
	 * @param iconSclass The new value for {@code iconSclass}
	 * @see IMenu#withIconSclass(java.lang.String)
	 */
	public IMenu.Updater iconSclass(java.lang.String iconSclass) {
		keys.add("iconSclass");
		builder.setIconSclass(iconSclass);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconSclasses} to update to client widget
	 *
	 * @param iconSclasses The new value for {@code iconSclasses}
	 * @see IMenu#withIconSclasses(java.lang.String[])
	 */
	public IMenu.Updater iconSclasses(java.lang.String[] iconSclasses) {
		keys.add("iconSclasses");
		builder.setIconSclasses(iconSclasses);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconTooltip} to update to client widget
	 *
	 * @param iconTooltip The new value for {@code iconTooltip}
	 * @see IMenu#withIconTooltip(java.lang.String)
	 */
	public IMenu.Updater iconTooltip(java.lang.String iconTooltip) {
		keys.add("iconTooltip");
		builder.setIconTooltip(iconTooltip);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconTooltips} to update to client widget
	 *
	 * @param iconTooltips The new value for {@code iconTooltips}
	 * @see IMenu#withIconTooltips(java.lang.String[])
	 */
	public IMenu.Updater iconTooltips(java.lang.String[] iconTooltips) {
		keys.add("iconTooltips");
		builder.setIconTooltips(iconTooltips);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code image} to update to client widget
	 *
	 * @param image The new value for {@code image}
	 * @see IMenu#withImage(java.lang.String)
	 */
	public IMenu.Updater image(java.lang.String image) {
		keys.add("image");
		builder.setImage(image);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code hoverImage} to update to client widget
	 *
	 * @param hoverImage The new value for {@code hoverImage}
	 * @see IMenu#withHoverImage(java.lang.String)
	 */
	public IMenu.Updater hoverImage(java.lang.String hoverImage) {
		keys.add("hoverImage");
		builder.setHoverImage(hoverImage);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code preloadImage} to update to client widget
	 *
	 * @param preloadImage The new value for {@code preloadImage}
	 * @see IMenu#withPreloadImage(boolean)
	 */
	public IMenu.Updater preloadImage(boolean preloadImage) {
		keys.add("preloadImage");
		builder.setPreloadImage(preloadImage);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see IMenu#withDisabled(boolean)
	 */
	public IMenu.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IMenu#withWidgetClass(java.lang.String)
	 */
	public IMenu.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IMenu.Updater) this;
	}

	/**
	 * Sets the given value of {@code content} to update to client widget
	 *
	 * @param content The new value for {@code content}
	 * @see IMenu#withContent(java.lang.String)
	 */
	public IMenu.Updater content(java.lang.String content) {
		keys.add("content");
		builder.setContent(content);
		return (IMenu.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
