// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IMenuitem}.
 */
/*package*/ class IMenuitemUpdater implements SmartUpdater {
	private final IMenuitem.Builder builder = new IMenuitem.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IMenuitem#withId(java.lang.String)
	 */
	public IMenuitem.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IMenuitem#withVisible(boolean)
	 */
	public IMenuitem.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IMenuitem#withMold(java.lang.String)
	 */
	public IMenuitem.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IMenuitem#withLeft(java.lang.String)
	 */
	public IMenuitem.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IMenuitem#withTop(java.lang.String)
	 */
	public IMenuitem.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IMenuitem#withZIndex(int)
	 */
	public IMenuitem.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IMenuitem#withHeight(java.lang.String)
	 */
	public IMenuitem.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IMenuitem#withWidth(java.lang.String)
	 */
	public IMenuitem.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IMenuitem#withTooltiptext(java.lang.String)
	 */
	public IMenuitem.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IMenuitem#withZclass(java.lang.String)
	 */
	public IMenuitem.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IMenuitem#withSclass(java.lang.String)
	 */
	public IMenuitem.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IMenuitem#withStyle(java.lang.String)
	 */
	public IMenuitem.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IMenuitem#withDraggable(java.lang.String)
	 */
	public IMenuitem.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IMenuitem#withFocus(boolean)
	 */
	public IMenuitem.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IMenuitem#withDroppable(java.lang.String)
	 */
	public IMenuitem.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IMenuitem#withVflex(java.lang.String)
	 */
	public IMenuitem.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IMenuitem#withHflex(java.lang.String)
	 */
	public IMenuitem.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IMenuitem#withRenderdefer(int)
	 */
	public IMenuitem.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IMenuitem#withClientAction(java.lang.String)
	 */
	public IMenuitem.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IMenuitem#withTabindex(java.lang.Integer)
	 */
	public IMenuitem.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IMenuitem#withCtrlKeys(java.lang.String)
	 */
	public IMenuitem.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IMenuitem#withContext(java.lang.String)
	 */
	public IMenuitem.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IMenuitem#withPopup(java.lang.String)
	 */
	public IMenuitem.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IMenuitem#withTooltip(java.lang.String)
	 */
	public IMenuitem.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code label} to update to client widget
	 *
	 * @param label The new value for {@code label}
	 * @see IMenuitem#withLabel(java.lang.String)
	 */
	public IMenuitem.Updater label(java.lang.String label) {
		keys.add("label");
		builder.setLabel(label);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconSclass} to update to client widget
	 *
	 * @param iconSclass The new value for {@code iconSclass}
	 * @see IMenuitem#withIconSclass(java.lang.String)
	 */
	public IMenuitem.Updater iconSclass(java.lang.String iconSclass) {
		keys.add("iconSclass");
		builder.setIconSclass(iconSclass);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconSclasses} to update to client widget
	 *
	 * @param iconSclasses The new value for {@code iconSclasses}
	 * @see IMenuitem#withIconSclasses(java.lang.String[])
	 */
	public IMenuitem.Updater iconSclasses(java.lang.String[] iconSclasses) {
		keys.add("iconSclasses");
		builder.setIconSclasses(iconSclasses);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconTooltip} to update to client widget
	 *
	 * @param iconTooltip The new value for {@code iconTooltip}
	 * @see IMenuitem#withIconTooltip(java.lang.String)
	 */
	public IMenuitem.Updater iconTooltip(java.lang.String iconTooltip) {
		keys.add("iconTooltip");
		builder.setIconTooltip(iconTooltip);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconTooltips} to update to client widget
	 *
	 * @param iconTooltips The new value for {@code iconTooltips}
	 * @see IMenuitem#withIconTooltips(java.lang.String[])
	 */
	public IMenuitem.Updater iconTooltips(java.lang.String[] iconTooltips) {
		keys.add("iconTooltips");
		builder.setIconTooltips(iconTooltips);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code image} to update to client widget
	 *
	 * @param image The new value for {@code image}
	 * @see IMenuitem#withImage(java.lang.String)
	 */
	public IMenuitem.Updater image(java.lang.String image) {
		keys.add("image");
		builder.setImage(image);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code hoverImage} to update to client widget
	 *
	 * @param hoverImage The new value for {@code hoverImage}
	 * @see IMenuitem#withHoverImage(java.lang.String)
	 */
	public IMenuitem.Updater hoverImage(java.lang.String hoverImage) {
		keys.add("hoverImage");
		builder.setHoverImage(hoverImage);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code preloadImage} to update to client widget
	 *
	 * @param preloadImage The new value for {@code preloadImage}
	 * @see IMenuitem#withPreloadImage(boolean)
	 */
	public IMenuitem.Updater preloadImage(boolean preloadImage) {
		keys.add("preloadImage");
		builder.setPreloadImage(preloadImage);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see IMenuitem#withDisabled(boolean)
	 */
	public IMenuitem.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IMenuitem#withWidgetClass(java.lang.String)
	 */
	public IMenuitem.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code autodisable} to update to client widget
	 *
	 * @param autodisable The new value for {@code autodisable}
	 * @see IMenuitem#withAutodisable(java.lang.String)
	 */
	public IMenuitem.Updater autodisable(java.lang.String autodisable) {
		keys.add("autodisable");
		builder.setAutodisable(autodisable);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code href} to update to client widget
	 *
	 * @param href The new value for {@code href}
	 * @see IMenuitem#withHref(java.lang.String)
	 */
	public IMenuitem.Updater href(java.lang.String href) {
		keys.add("href");
		builder.setHref(href);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code target} to update to client widget
	 *
	 * @param target The new value for {@code target}
	 * @see IMenuitem#withTarget(java.lang.String)
	 */
	public IMenuitem.Updater target(java.lang.String target) {
		keys.add("target");
		builder.setTarget(target);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code upload} to update to client widget
	 *
	 * @param upload The new value for {@code upload}
	 * @see IMenuitem#withUpload(java.lang.String)
	 */
	public IMenuitem.Updater upload(java.lang.String upload) {
		keys.add("upload");
		builder.setUpload(upload);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code checkmark} to update to client widget
	 *
	 * @param checkmark The new value for {@code checkmark}
	 * @see IMenuitem#withCheckmark(boolean)
	 */
	public IMenuitem.Updater checkmark(boolean checkmark) {
		keys.add("checkmark");
		builder.setCheckmark(checkmark);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code checked} to update to client widget
	 *
	 * @param checked The new value for {@code checked}
	 * @see IMenuitem#withChecked(boolean)
	 */
	public IMenuitem.Updater checked(boolean checked) {
		keys.add("checked");
		builder.setChecked(checked);
		return (IMenuitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code autocheck} to update to client widget
	 *
	 * @param autocheck The new value for {@code autocheck}
	 * @see IMenuitem#withAutocheck(boolean)
	 */
	public IMenuitem.Updater autocheck(boolean autocheck) {
		keys.add("autocheck");
		builder.setAutocheck(autocheck);
		return (IMenuitem.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
