// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IMultislider}.
 */
/*package*/ class IMultisliderUpdater implements SmartUpdater {
	private final IMultislider.Builder builder = new IMultislider.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IMultislider#withId(java.lang.String)
	 */
	public IMultislider.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IMultislider#withVisible(boolean)
	 */
	public IMultislider.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IMultislider#withMold(java.lang.String)
	 */
	public IMultislider.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IMultislider#withLeft(java.lang.String)
	 */
	public IMultislider.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IMultislider#withTop(java.lang.String)
	 */
	public IMultislider.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IMultislider#withZIndex(int)
	 */
	public IMultislider.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IMultislider#withHeight(java.lang.String)
	 */
	public IMultislider.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IMultislider#withWidth(java.lang.String)
	 */
	public IMultislider.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IMultislider#withTooltiptext(java.lang.String)
	 */
	public IMultislider.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IMultislider#withZclass(java.lang.String)
	 */
	public IMultislider.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IMultislider#withSclass(java.lang.String)
	 */
	public IMultislider.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IMultislider#withStyle(java.lang.String)
	 */
	public IMultislider.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IMultislider#withDraggable(java.lang.String)
	 */
	public IMultislider.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IMultislider#withFocus(boolean)
	 */
	public IMultislider.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IMultislider#withDroppable(java.lang.String)
	 */
	public IMultislider.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IMultislider#withVflex(java.lang.String)
	 */
	public IMultislider.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IMultislider#withHflex(java.lang.String)
	 */
	public IMultislider.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IMultislider#withRenderdefer(int)
	 */
	public IMultislider.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IMultislider#withClientAction(java.lang.String)
	 */
	public IMultislider.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IMultislider#withTabindex(java.lang.Integer)
	 */
	public IMultislider.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IMultislider#withCtrlKeys(java.lang.String)
	 */
	public IMultislider.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IMultislider#withContext(java.lang.String)
	 */
	public IMultislider.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IMultislider#withPopup(java.lang.String)
	 */
	public IMultislider.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IMultislider#withTooltip(java.lang.String)
	 */
	public IMultislider.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see IMultislider#withDisabled(boolean)
	 */
	public IMultislider.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code min} to update to client widget
	 *
	 * @param min The new value for {@code min}
	 * @see IMultislider#withMin(int)
	 */
	public IMultislider.Updater min(int min) {
		keys.add("min");
		builder.setMin(min);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code max} to update to client widget
	 *
	 * @param max The new value for {@code max}
	 * @see IMultislider#withMax(int)
	 */
	public IMultislider.Updater max(int max) {
		keys.add("max");
		builder.setMax(max);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code step} to update to client widget
	 *
	 * @param step The new value for {@code step}
	 * @see IMultislider#withStep(int)
	 */
	public IMultislider.Updater step(int step) {
		keys.add("step");
		builder.setStep(step);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code orient} to update to client widget
	 *
	 * @param orient The new value for {@code orient}
	 * @see IMultislider#withOrient(java.lang.String)
	 */
	public IMultislider.Updater orient(java.lang.String orient) {
		keys.add("orient");
		builder.setOrient(orient);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltipVisible} to update to client widget
	 *
	 * @param tooltipVisible The new value for {@code tooltipVisible}
	 * @see IMultislider#withTooltipVisible(boolean)
	 */
	public IMultislider.Updater tooltipVisible(boolean tooltipVisible) {
		keys.add("tooltipVisible");
		builder.setTooltipVisible(tooltipVisible);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code markScale} to update to client widget
	 *
	 * @param markScale The new value for {@code markScale}
	 * @see IMultislider#withMarkScale(int)
	 */
	public IMultislider.Updater markScale(int markScale) {
		keys.add("markScale");
		builder.setMarkScale(markScale);
		return (IMultislider.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IMultislider#withWidgetClass(java.lang.String)
	 */
	public IMultislider.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IMultislider.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
