// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IOrgitem}.
 */
/*package*/ class IOrgitemUpdater implements SmartUpdater {
	private final IOrgitem.Builder builder = new IOrgitem.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IOrgitem#withId(java.lang.String)
	 */
	public IOrgitem.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IOrgitem#withVisible(boolean)
	 */
	public IOrgitem.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IOrgitem#withMold(java.lang.String)
	 */
	public IOrgitem.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IOrgitem#withLeft(java.lang.String)
	 */
	public IOrgitem.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IOrgitem#withTop(java.lang.String)
	 */
	public IOrgitem.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IOrgitem#withZIndex(int)
	 */
	public IOrgitem.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IOrgitem#withHeight(java.lang.String)
	 */
	public IOrgitem.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IOrgitem#withWidth(java.lang.String)
	 */
	public IOrgitem.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IOrgitem#withTooltiptext(java.lang.String)
	 */
	public IOrgitem.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IOrgitem#withZclass(java.lang.String)
	 */
	public IOrgitem.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IOrgitem#withSclass(java.lang.String)
	 */
	public IOrgitem.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IOrgitem#withStyle(java.lang.String)
	 */
	public IOrgitem.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IOrgitem#withDraggable(java.lang.String)
	 */
	public IOrgitem.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IOrgitem#withFocus(boolean)
	 */
	public IOrgitem.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IOrgitem#withDroppable(java.lang.String)
	 */
	public IOrgitem.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IOrgitem#withVflex(java.lang.String)
	 */
	public IOrgitem.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IOrgitem#withHflex(java.lang.String)
	 */
	public IOrgitem.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IOrgitem#withRenderdefer(int)
	 */
	public IOrgitem.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IOrgitem#withClientAction(java.lang.String)
	 */
	public IOrgitem.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IOrgitem#withTabindex(java.lang.Integer)
	 */
	public IOrgitem.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IOrgitem#withCtrlKeys(java.lang.String)
	 */
	public IOrgitem.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IOrgitem#withContext(java.lang.String)
	 */
	public IOrgitem.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IOrgitem#withPopup(java.lang.String)
	 */
	public IOrgitem.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IOrgitem#withTooltip(java.lang.String)
	 */
	public IOrgitem.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IOrgitem#withWidgetClass(java.lang.String)
	 */
	public IOrgitem.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code label} to update to client widget
	 *
	 * @param label The new value for {@code label}
	 * @see IOrgitem#withLabel(java.lang.String)
	 */
	public IOrgitem.Updater label(java.lang.String label) {
		keys.add("label");
		builder.setLabel(label);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code image} to update to client widget
	 *
	 * @param image The new value for {@code image}
	 * @see IOrgitem#withImage(java.lang.String)
	 */
	public IOrgitem.Updater image(java.lang.String image) {
		keys.add("image");
		builder.setImage(image);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code selectable} to update to client widget
	 *
	 * @param selectable The new value for {@code selectable}
	 * @see IOrgitem#withSelectable(boolean)
	 */
	public IOrgitem.Updater selectable(boolean selectable) {
		keys.add("selectable");
		builder.setSelectable(selectable);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see IOrgitem#withDisabled(boolean)
	 */
	public IOrgitem.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code rendered} to update to client widget
	 *
	 * @param rendered The new value for {@code rendered}
	 * @see IOrgitem#withRendered(boolean)
	 */
	public IOrgitem.Updater rendered(boolean rendered) {
		keys.add("rendered");
		builder.setRendered(rendered);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code loaded} to update to client widget
	 *
	 * @param loaded The new value for {@code loaded}
	 * @see IOrgitem#withLoaded(boolean)
	 */
	public IOrgitem.Updater loaded(boolean loaded) {
		keys.add("loaded");
		builder.setLoaded(loaded);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code open} to update to client widget
	 *
	 * @param open The new value for {@code open}
	 * @see IOrgitem#withOpen(boolean)
	 */
	public IOrgitem.Updater open(boolean open) {
		keys.add("open");
		builder.setOpen(open);
		return (IOrgitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code selected} to update to client widget
	 *
	 * @param selected The new value for {@code selected}
	 * @see IOrgitem#withSelected(boolean)
	 */
	public IOrgitem.Updater selected(boolean selected) {
		keys.add("selected");
		builder.setSelected(selected);
		return (IOrgitem.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
