// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IPaging}.
 */
/*package*/ class IPagingUpdater implements SmartUpdater {
	private final IPaging.Builder builder = new IPaging.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IPaging#withId(java.lang.String)
	 */
	public IPaging.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IPaging#withVisible(boolean)
	 */
	public IPaging.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IPaging#withMold(java.lang.String)
	 */
	public IPaging.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IPaging#withLeft(java.lang.String)
	 */
	public IPaging.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IPaging#withTop(java.lang.String)
	 */
	public IPaging.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IPaging#withZIndex(int)
	 */
	public IPaging.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IPaging#withHeight(java.lang.String)
	 */
	public IPaging.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IPaging#withWidth(java.lang.String)
	 */
	public IPaging.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IPaging#withTooltiptext(java.lang.String)
	 */
	public IPaging.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IPaging#withZclass(java.lang.String)
	 */
	public IPaging.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IPaging#withSclass(java.lang.String)
	 */
	public IPaging.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IPaging#withStyle(java.lang.String)
	 */
	public IPaging.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IPaging#withDraggable(java.lang.String)
	 */
	public IPaging.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IPaging#withFocus(boolean)
	 */
	public IPaging.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IPaging#withDroppable(java.lang.String)
	 */
	public IPaging.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IPaging#withVflex(java.lang.String)
	 */
	public IPaging.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IPaging#withHflex(java.lang.String)
	 */
	public IPaging.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IPaging#withRenderdefer(int)
	 */
	public IPaging.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IPaging#withClientAction(java.lang.String)
	 */
	public IPaging.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IPaging#withTabindex(java.lang.Integer)
	 */
	public IPaging.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IPaging#withCtrlKeys(java.lang.String)
	 */
	public IPaging.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IPaging#withContext(java.lang.String)
	 */
	public IPaging.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IPaging#withPopup(java.lang.String)
	 */
	public IPaging.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IPaging#withTooltip(java.lang.String)
	 */
	public IPaging.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see IPaging#withDisabled(boolean)
	 */
	public IPaging.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IPaging#withWidgetClass(java.lang.String)
	 */
	public IPaging.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code pageSize} to update to client widget
	 *
	 * @param pageSize The new value for {@code pageSize}
	 * @see IPaging#withPageSize(int)
	 */
	public IPaging.Updater pageSize(int pageSize) {
		keys.add("pageSize");
		builder.setPageSize(pageSize);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code totalSize} to update to client widget
	 *
	 * @param totalSize The new value for {@code totalSize}
	 * @see IPaging#withTotalSize(int)
	 */
	public IPaging.Updater totalSize(int totalSize) {
		keys.add("totalSize");
		builder.setTotalSize(totalSize);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code pageCount} to update to client widget
	 *
	 * @param pageCount The new value for {@code pageCount}
	 * @see IPaging#withPageCount(int)
	 */
	public IPaging.Updater pageCount(int pageCount) {
		keys.add("pageCount");
		builder.setPageCount(pageCount);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code detailed} to update to client widget
	 *
	 * @param detailed The new value for {@code detailed}
	 * @see IPaging#withDetailed(boolean)
	 */
	public IPaging.Updater detailed(boolean detailed) {
		keys.add("detailed");
		builder.setDetailed(detailed);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code autohide} to update to client widget
	 *
	 * @param autohide The new value for {@code autohide}
	 * @see IPaging#withAutohide(boolean)
	 */
	public IPaging.Updater autohide(boolean autohide) {
		keys.add("autohide");
		builder.setAutohide(autohide);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code activePage} to update to client widget
	 *
	 * @param activePage The new value for {@code activePage}
	 * @see IPaging#withActivePage(int)
	 */
	public IPaging.Updater activePage(int activePage) {
		keys.add("activePage");
		builder.setActivePage(activePage);
		return (IPaging.Updater) this;
	}

	/**
	 * Sets the given value of {@code pageIncrement} to update to client widget
	 *
	 * @param pageIncrement The new value for {@code pageIncrement}
	 * @see IPaging#withPageIncrement(int)
	 */
	public IPaging.Updater pageIncrement(int pageIncrement) {
		keys.add("pageIncrement");
		builder.setPageIncrement(pageIncrement);
		return (IPaging.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
