// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IPanel}.
 */
/*package*/ class IPanelUpdater implements SmartUpdater {
	private final IPanel.Builder builder = new IPanel.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IPanel#withId(java.lang.String)
	 */
	public IPanel.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IPanel#withVisible(boolean)
	 */
	public IPanel.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IPanel#withMold(java.lang.String)
	 */
	public IPanel.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IPanel#withLeft(java.lang.String)
	 */
	public IPanel.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IPanel#withTop(java.lang.String)
	 */
	public IPanel.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IPanel#withZIndex(int)
	 */
	public IPanel.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IPanel#withHeight(java.lang.String)
	 */
	public IPanel.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IPanel#withWidth(java.lang.String)
	 */
	public IPanel.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IPanel#withTooltiptext(java.lang.String)
	 */
	public IPanel.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IPanel#withZclass(java.lang.String)
	 */
	public IPanel.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IPanel#withSclass(java.lang.String)
	 */
	public IPanel.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IPanel#withStyle(java.lang.String)
	 */
	public IPanel.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IPanel#withDraggable(java.lang.String)
	 */
	public IPanel.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IPanel#withFocus(boolean)
	 */
	public IPanel.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IPanel#withDroppable(java.lang.String)
	 */
	public IPanel.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IPanel#withVflex(java.lang.String)
	 */
	public IPanel.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IPanel#withHflex(java.lang.String)
	 */
	public IPanel.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IPanel#withRenderdefer(int)
	 */
	public IPanel.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IPanel#withClientAction(java.lang.String)
	 */
	public IPanel.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IPanel#withTabindex(java.lang.Integer)
	 */
	public IPanel.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IPanel#withCtrlKeys(java.lang.String)
	 */
	public IPanel.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IPanel#withContext(java.lang.String)
	 */
	public IPanel.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IPanel#withPopup(java.lang.String)
	 */
	public IPanel.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IPanel#withTooltip(java.lang.String)
	 */
	public IPanel.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IPanel#withWidgetClass(java.lang.String)
	 */
	public IPanel.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code title} to update to client widget
	 *
	 * @param title The new value for {@code title}
	 * @see IPanel#withTitle(java.lang.String)
	 */
	public IPanel.Updater title(java.lang.String title) {
		keys.add("title");
		builder.setTitle(title);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code closable} to update to client widget
	 *
	 * @param closable The new value for {@code closable}
	 * @see IPanel#withClosable(boolean)
	 */
	public IPanel.Updater closable(boolean closable) {
		keys.add("closable");
		builder.setClosable(closable);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code floatable} to update to client widget
	 *
	 * @param floatable The new value for {@code floatable}
	 * @see IPanel#withFloatable(boolean)
	 */
	public IPanel.Updater floatable(boolean floatable) {
		keys.add("floatable");
		builder.setFloatable(floatable);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code collapsible} to update to client widget
	 *
	 * @param collapsible The new value for {@code collapsible}
	 * @see IPanel#withCollapsible(boolean)
	 */
	public IPanel.Updater collapsible(boolean collapsible) {
		keys.add("collapsible");
		builder.setCollapsible(collapsible);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code movable} to update to client widget
	 *
	 * @param movable The new value for {@code movable}
	 * @see IPanel#withMovable(boolean)
	 */
	public IPanel.Updater movable(boolean movable) {
		keys.add("movable");
		builder.setMovable(movable);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code maximizable} to update to client widget
	 *
	 * @param maximizable The new value for {@code maximizable}
	 * @see IPanel#withMaximizable(boolean)
	 */
	public IPanel.Updater maximizable(boolean maximizable) {
		keys.add("maximizable");
		builder.setMaximizable(maximizable);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code minimizable} to update to client widget
	 *
	 * @param minimizable The new value for {@code minimizable}
	 * @see IPanel#withMinimizable(boolean)
	 */
	public IPanel.Updater minimizable(boolean minimizable) {
		keys.add("minimizable");
		builder.setMinimizable(minimizable);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code maximized} to update to client widget
	 *
	 * @param maximized The new value for {@code maximized}
	 * @see IPanel#withMaximized(boolean)
	 */
	public IPanel.Updater maximized(boolean maximized) {
		keys.add("maximized");
		builder.setMaximized(maximized);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code minimized} to update to client widget
	 *
	 * @param minimized The new value for {@code minimized}
	 * @see IPanel#withMinimized(boolean)
	 */
	public IPanel.Updater minimized(boolean minimized) {
		keys.add("minimized");
		builder.setMinimized(minimized);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code sizable} to update to client widget
	 *
	 * @param sizable The new value for {@code sizable}
	 * @see IPanel#withSizable(boolean)
	 */
	public IPanel.Updater sizable(boolean sizable) {
		keys.add("sizable");
		builder.setSizable(sizable);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code minheight} to update to client widget
	 *
	 * @param minheight The new value for {@code minheight}
	 * @see IPanel#withMinheight(int)
	 */
	public IPanel.Updater minheight(int minheight) {
		keys.add("minheight");
		builder.setMinheight(minheight);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code minwidth} to update to client widget
	 *
	 * @param minwidth The new value for {@code minwidth}
	 * @see IPanel#withMinwidth(int)
	 */
	public IPanel.Updater minwidth(int minwidth) {
		keys.add("minwidth");
		builder.setMinwidth(minwidth);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code open} to update to client widget
	 *
	 * @param open The new value for {@code open}
	 * @see IPanel#withOpen(boolean)
	 */
	public IPanel.Updater open(boolean open) {
		keys.add("open");
		builder.setOpen(open);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code border} to update to client widget
	 *
	 * @param border The new value for {@code border}
	 * @see IPanel#withBorder(java.lang.String)
	 */
	public IPanel.Updater border(java.lang.String border) {
		keys.add("border");
		builder.setBorder(border);
		return (IPanel.Updater) this;
	}

	/**
	 * Sets the given value of {@code nativeScrollbar} to update to client widget
	 *
	 * @param nativeScrollbar The new value for {@code nativeScrollbar}
	 * @see IPanel#withNativeScrollbar(boolean)
	 */
	public IPanel.Updater nativeScrollbar(boolean nativeScrollbar) {
		keys.add("nativeScrollbar");
		builder.setNativeScrollbar(nativeScrollbar);
		return (IPanel.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
