// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IPdfviewer}.
 */
/*package*/ class IPdfviewerUpdater implements SmartUpdater {
	private final IPdfviewer.Builder builder = new IPdfviewer.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IPdfviewer#withId(java.lang.String)
	 */
	public IPdfviewer.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IPdfviewer#withVisible(boolean)
	 */
	public IPdfviewer.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IPdfviewer#withMold(java.lang.String)
	 */
	public IPdfviewer.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IPdfviewer#withLeft(java.lang.String)
	 */
	public IPdfviewer.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IPdfviewer#withTop(java.lang.String)
	 */
	public IPdfviewer.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IPdfviewer#withZIndex(int)
	 */
	public IPdfviewer.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IPdfviewer#withHeight(java.lang.String)
	 */
	public IPdfviewer.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IPdfviewer#withWidth(java.lang.String)
	 */
	public IPdfviewer.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IPdfviewer#withTooltiptext(java.lang.String)
	 */
	public IPdfviewer.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IPdfviewer#withZclass(java.lang.String)
	 */
	public IPdfviewer.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IPdfviewer#withSclass(java.lang.String)
	 */
	public IPdfviewer.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IPdfviewer#withStyle(java.lang.String)
	 */
	public IPdfviewer.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IPdfviewer#withDraggable(java.lang.String)
	 */
	public IPdfviewer.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IPdfviewer#withFocus(boolean)
	 */
	public IPdfviewer.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IPdfviewer#withDroppable(java.lang.String)
	 */
	public IPdfviewer.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IPdfviewer#withVflex(java.lang.String)
	 */
	public IPdfviewer.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IPdfviewer#withHflex(java.lang.String)
	 */
	public IPdfviewer.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IPdfviewer#withRenderdefer(int)
	 */
	public IPdfviewer.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IPdfviewer#withClientAction(java.lang.String)
	 */
	public IPdfviewer.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IPdfviewer#withTabindex(java.lang.Integer)
	 */
	public IPdfviewer.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IPdfviewer#withCtrlKeys(java.lang.String)
	 */
	public IPdfviewer.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IPdfviewer#withContext(java.lang.String)
	 */
	public IPdfviewer.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IPdfviewer#withPopup(java.lang.String)
	 */
	public IPdfviewer.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IPdfviewer#withTooltip(java.lang.String)
	 */
	public IPdfviewer.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IPdfviewer#withWidgetClass(java.lang.String)
	 */
	public IPdfviewer.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code src} to update to client widget
	 *
	 * @param src The new value for {@code src}
	 * @see IPdfviewer#withSrc(java.lang.String)
	 */
	public IPdfviewer.Updater src(java.lang.String src) {
		keys.add("src");
		builder.setSrc(src);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code zoom} to update to client widget
	 *
	 * @param zoom The new value for {@code zoom}
	 * @see IPdfviewer#withZoom(double)
	 */
	public IPdfviewer.Updater zoom(double zoom) {
		keys.add("zoom");
		builder.setZoom(zoom);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code zoomMode} to update to client widget
	 *
	 * @param zoomMode The new value for {@code zoomMode}
	 * @see IPdfviewer#withZoomMode(org.zkoss.stateless.sul.IPdfviewer.ZoomMode)
	 */
	public IPdfviewer.Updater zoomMode(IPdfviewer.ZoomMode zoomMode) {
		keys.add("zoomMode");
		builder.setZoomMode(zoomMode);
		return (IPdfviewer.Updater) this;
	}

	/**
	 * Sets the given value of {@code rotation} to update to client widget
	 *
	 * @param rotation The new value for {@code rotation}
	 * @see IPdfviewer#withRotation(int)
	 */
	public IPdfviewer.Updater rotation(int rotation) {
		keys.add("rotation");
		builder.setRotation(rotation);
		return (IPdfviewer.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
