// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IRadio}.
 */
/*package*/ class IRadioUpdater implements SmartUpdater {
	private final IRadio.Builder builder = new IRadio.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IRadio#withId(java.lang.String)
	 */
	public IRadio.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IRadio#withVisible(boolean)
	 */
	public IRadio.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IRadio#withMold(java.lang.String)
	 */
	public IRadio.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IRadio#withLeft(java.lang.String)
	 */
	public IRadio.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IRadio#withTop(java.lang.String)
	 */
	public IRadio.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IRadio#withZIndex(int)
	 */
	public IRadio.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IRadio#withHeight(java.lang.String)
	 */
	public IRadio.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IRadio#withWidth(java.lang.String)
	 */
	public IRadio.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IRadio#withTooltiptext(java.lang.String)
	 */
	public IRadio.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IRadio#withZclass(java.lang.String)
	 */
	public IRadio.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IRadio#withSclass(java.lang.String)
	 */
	public IRadio.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IRadio#withStyle(java.lang.String)
	 */
	public IRadio.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IRadio#withDraggable(java.lang.String)
	 */
	public IRadio.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IRadio#withFocus(boolean)
	 */
	public IRadio.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IRadio#withDroppable(java.lang.String)
	 */
	public IRadio.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IRadio#withVflex(java.lang.String)
	 */
	public IRadio.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IRadio#withHflex(java.lang.String)
	 */
	public IRadio.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IRadio#withRenderdefer(int)
	 */
	public IRadio.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IRadio#withClientAction(java.lang.String)
	 */
	public IRadio.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IRadio#withTabindex(java.lang.Integer)
	 */
	public IRadio.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IRadio#withCtrlKeys(java.lang.String)
	 */
	public IRadio.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IRadio#withContext(java.lang.String)
	 */
	public IRadio.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IRadio#withPopup(java.lang.String)
	 */
	public IRadio.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IRadio#withTooltip(java.lang.String)
	 */
	public IRadio.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code label} to update to client widget
	 *
	 * @param label The new value for {@code label}
	 * @see IRadio#withLabel(java.lang.String)
	 */
	public IRadio.Updater label(java.lang.String label) {
		keys.add("label");
		builder.setLabel(label);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconSclass} to update to client widget
	 *
	 * @param iconSclass The new value for {@code iconSclass}
	 * @see IRadio#withIconSclass(java.lang.String)
	 */
	public IRadio.Updater iconSclass(java.lang.String iconSclass) {
		keys.add("iconSclass");
		builder.setIconSclass(iconSclass);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconSclasses} to update to client widget
	 *
	 * @param iconSclasses The new value for {@code iconSclasses}
	 * @see IRadio#withIconSclasses(java.lang.String[])
	 */
	public IRadio.Updater iconSclasses(java.lang.String[] iconSclasses) {
		keys.add("iconSclasses");
		builder.setIconSclasses(iconSclasses);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconTooltip} to update to client widget
	 *
	 * @param iconTooltip The new value for {@code iconTooltip}
	 * @see IRadio#withIconTooltip(java.lang.String)
	 */
	public IRadio.Updater iconTooltip(java.lang.String iconTooltip) {
		keys.add("iconTooltip");
		builder.setIconTooltip(iconTooltip);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconTooltips} to update to client widget
	 *
	 * @param iconTooltips The new value for {@code iconTooltips}
	 * @see IRadio#withIconTooltips(java.lang.String[])
	 */
	public IRadio.Updater iconTooltips(java.lang.String[] iconTooltips) {
		keys.add("iconTooltips");
		builder.setIconTooltips(iconTooltips);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code image} to update to client widget
	 *
	 * @param image The new value for {@code image}
	 * @see IRadio#withImage(java.lang.String)
	 */
	public IRadio.Updater image(java.lang.String image) {
		keys.add("image");
		builder.setImage(image);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code hoverImage} to update to client widget
	 *
	 * @param hoverImage The new value for {@code hoverImage}
	 * @see IRadio#withHoverImage(java.lang.String)
	 */
	public IRadio.Updater hoverImage(java.lang.String hoverImage) {
		keys.add("hoverImage");
		builder.setHoverImage(hoverImage);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code preloadImage} to update to client widget
	 *
	 * @param preloadImage The new value for {@code preloadImage}
	 * @see IRadio#withPreloadImage(boolean)
	 */
	public IRadio.Updater preloadImage(boolean preloadImage) {
		keys.add("preloadImage");
		builder.setPreloadImage(preloadImage);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code value} to update to client widget
	 *
	 * @param value The new value for {@code value}
	 * @see IRadio#withValue(java.lang.Object)
	 */
	public IRadio.Updater value(java.lang.Object value) {
		keys.add("value");
		builder.setValue(value);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code autodisable} to update to client widget
	 *
	 * @param autodisable The new value for {@code autodisable}
	 * @see IRadio#withAutodisable(java.lang.String)
	 */
	public IRadio.Updater autodisable(java.lang.String autodisable) {
		keys.add("autodisable");
		builder.setAutodisable(autodisable);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code name} to update to client widget
	 *
	 * @param name The new value for {@code name}
	 * @see IRadio#withName(java.lang.String)
	 */
	public IRadio.Updater name(java.lang.String name) {
		keys.add("name");
		builder.setName(name);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see IRadio#withDisabled(boolean)
	 */
	public IRadio.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code indeterminate} to update to client widget
	 *
	 * @param indeterminate The new value for {@code indeterminate}
	 * @see IRadio#withIndeterminate(boolean)
	 */
	public IRadio.Updater indeterminate(boolean indeterminate) {
		keys.add("indeterminate");
		builder.setIndeterminate(indeterminate);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code checked} to update to client widget
	 *
	 * @param checked The new value for {@code checked}
	 * @see IRadio#withChecked(boolean)
	 */
	public IRadio.Updater checked(boolean checked) {
		keys.add("checked");
		builder.setChecked(checked);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IRadio#withWidgetClass(java.lang.String)
	 */
	public IRadio.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IRadio.Updater) this;
	}

	/**
	 * Sets the given value of {@code radiogroup} to update to client widget
	 *
	 * @param radiogroup The new value for {@code radiogroup}
	 * @see IRadio#withRadiogroup(java.lang.String)
	 */
	public IRadio.Updater radiogroup(java.lang.String radiogroup) {
		keys.add("radiogroup");
		builder.setRadiogroup(radiogroup);
		return (IRadio.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
