// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IRating}.
 */
/*package*/ class IRatingUpdater implements SmartUpdater {
	private final IRating.Builder builder = new IRating.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IRating#withId(java.lang.String)
	 */
	public IRating.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IRating#withVisible(boolean)
	 */
	public IRating.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IRating#withMold(java.lang.String)
	 */
	public IRating.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IRating#withLeft(java.lang.String)
	 */
	public IRating.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IRating#withTop(java.lang.String)
	 */
	public IRating.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IRating#withZIndex(int)
	 */
	public IRating.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IRating#withHeight(java.lang.String)
	 */
	public IRating.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IRating#withWidth(java.lang.String)
	 */
	public IRating.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IRating#withTooltiptext(java.lang.String)
	 */
	public IRating.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IRating#withZclass(java.lang.String)
	 */
	public IRating.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IRating#withSclass(java.lang.String)
	 */
	public IRating.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IRating#withStyle(java.lang.String)
	 */
	public IRating.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IRating#withDraggable(java.lang.String)
	 */
	public IRating.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IRating#withFocus(boolean)
	 */
	public IRating.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IRating#withDroppable(java.lang.String)
	 */
	public IRating.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IRating#withVflex(java.lang.String)
	 */
	public IRating.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IRating#withHflex(java.lang.String)
	 */
	public IRating.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IRating#withRenderdefer(int)
	 */
	public IRating.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IRating#withClientAction(java.lang.String)
	 */
	public IRating.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IRating#withTabindex(java.lang.Integer)
	 */
	public IRating.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see IRating#withDisabled(boolean)
	 */
	public IRating.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IRating#withWidgetClass(java.lang.String)
	 */
	public IRating.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code max} to update to client widget
	 *
	 * @param max The new value for {@code max}
	 * @see IRating#withMax(int)
	 */
	public IRating.Updater max(int max) {
		keys.add("max");
		builder.setMax(max);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code rating} to update to client widget
	 *
	 * @param rating The new value for {@code rating}
	 * @see IRating#withRating(int)
	 */
	public IRating.Updater rating(int rating) {
		keys.add("rating");
		builder.setRating(rating);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code readonly} to update to client widget
	 *
	 * @param readonly The new value for {@code readonly}
	 * @see IRating#withReadonly(boolean)
	 */
	public IRating.Updater readonly(boolean readonly) {
		keys.add("readonly");
		builder.setReadonly(readonly);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code cancelable} to update to client widget
	 *
	 * @param cancelable The new value for {@code cancelable}
	 * @see IRating#withCancelable(boolean)
	 */
	public IRating.Updater cancelable(boolean cancelable) {
		keys.add("cancelable");
		builder.setCancelable(cancelable);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code orient} to update to client widget
	 *
	 * @param orient The new value for {@code orient}
	 * @see IRating#withOrient(java.lang.String)
	 */
	public IRating.Updater orient(java.lang.String orient) {
		keys.add("orient");
		builder.setOrient(orient);
		return (IRating.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconSclass} to update to client widget
	 *
	 * @param iconSclass The new value for {@code iconSclass}
	 * @see IRating#withIconSclass(java.lang.String)
	 */
	public IRating.Updater iconSclass(java.lang.String iconSclass) {
		keys.add("iconSclass");
		builder.setIconSclass(iconSclass);
		return (IRating.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
