// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IScript}.
 */
/*package*/ class IScriptUpdater implements SmartUpdater {
	private final IScript.Builder builder = new IScript.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IScript#withId(java.lang.String)
	 */
	public IScript.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IScript.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IScript#withVisible(boolean)
	 */
	public IScript.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IScript.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IScript#withMold(java.lang.String)
	 */
	public IScript.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IScript.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IScript#withWidgetClass(java.lang.String)
	 */
	public IScript.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IScript.Updater) this;
	}

	/**
	 * Sets the given value of {@code charset} to update to client widget
	 *
	 * @param charset The new value for {@code charset}
	 * @see IScript#withCharset(java.lang.String)
	 */
	public IScript.Updater charset(java.lang.String charset) {
		keys.add("charset");
		builder.setCharset(charset);
		return (IScript.Updater) this;
	}

	/**
	 * Sets the given value of {@code src} to update to client widget
	 *
	 * @param src The new value for {@code src}
	 * @see IScript#withSrc(java.lang.String)
	 */
	public IScript.Updater src(java.lang.String src) {
		keys.add("src");
		builder.setSrc(src);
		return (IScript.Updater) this;
	}

	/**
	 * Sets the given value of {@code defer} to update to client widget
	 *
	 * @param defer The new value for {@code defer}
	 * @see IScript#withDefer(boolean)
	 */
	public IScript.Updater defer(boolean defer) {
		keys.add("defer");
		builder.setDefer(defer);
		return (IScript.Updater) this;
	}

	/**
	 * Sets the given value of {@code content} to update to client widget
	 *
	 * @param content The new value for {@code content}
	 * @see IScript#withContent(java.lang.String)
	 */
	public IScript.Updater content(java.lang.String content) {
		keys.add("content");
		builder.setContent(content);
		return (IScript.Updater) this;
	}

	/**
	 * Sets the given value of {@code packages} to update to client widget
	 *
	 * @param packages The new value for {@code packages}
	 * @see IScript#withPackages(java.lang.String)
	 */
	public IScript.Updater packages(java.lang.String packages) {
		keys.add("packages");
		builder.setPackages(packages);
		return (IScript.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
