// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ISearchbox}.
 */
/*package*/ class ISearchboxUpdater implements SmartUpdater {
	private final ISearchbox.Builder builder = new ISearchbox.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ISearchbox#withId(java.lang.String)
	 */
	public ISearchbox.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ISearchbox#withVisible(boolean)
	 */
	public ISearchbox.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ISearchbox#withMold(java.lang.String)
	 */
	public ISearchbox.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ISearchbox#withLeft(java.lang.String)
	 */
	public ISearchbox.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ISearchbox#withTop(java.lang.String)
	 */
	public ISearchbox.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ISearchbox#withZIndex(int)
	 */
	public ISearchbox.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ISearchbox#withHeight(java.lang.String)
	 */
	public ISearchbox.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see ISearchbox#withWidth(java.lang.String)
	 */
	public ISearchbox.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ISearchbox#withTooltiptext(java.lang.String)
	 */
	public ISearchbox.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ISearchbox#withZclass(java.lang.String)
	 */
	public ISearchbox.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ISearchbox#withSclass(java.lang.String)
	 */
	public ISearchbox.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ISearchbox#withStyle(java.lang.String)
	 */
	public ISearchbox.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ISearchbox#withDraggable(java.lang.String)
	 */
	public ISearchbox.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ISearchbox#withFocus(boolean)
	 */
	public ISearchbox.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ISearchbox#withDroppable(java.lang.String)
	 */
	public ISearchbox.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ISearchbox#withVflex(java.lang.String)
	 */
	public ISearchbox.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see ISearchbox#withHflex(java.lang.String)
	 */
	public ISearchbox.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ISearchbox#withRenderdefer(int)
	 */
	public ISearchbox.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ISearchbox#withClientAction(java.lang.String)
	 */
	public ISearchbox.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ISearchbox#withTabindex(java.lang.Integer)
	 */
	public ISearchbox.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see ISearchbox#withDisabled(boolean)
	 */
	public ISearchbox.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ISearchbox#withWidgetClass(java.lang.String)
	 */
	public ISearchbox.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code searchMessage} to update to client widget
	 *
	 * @param searchMessage The new value for {@code searchMessage}
	 * @see ISearchbox#withSearchMessage(java.lang.String)
	 */
	public ISearchbox.Updater searchMessage(java.lang.String searchMessage) {
		keys.add("searchMessage");
		builder.setSearchMessage(searchMessage);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code placeholder} to update to client widget
	 *
	 * @param placeholder The new value for {@code placeholder}
	 * @see ISearchbox#withPlaceholder(java.lang.String)
	 */
	public ISearchbox.Updater placeholder(java.lang.String placeholder) {
		keys.add("placeholder");
		builder.setPlaceholder(placeholder);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code multiple} to update to client widget
	 *
	 * @param multiple The new value for {@code multiple}
	 * @see ISearchbox#withMultiple(boolean)
	 */
	public ISearchbox.Updater multiple(boolean multiple) {
		keys.add("multiple");
		builder.setMultiple(multiple);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code open} to update to client widget
	 *
	 * @param open The new value for {@code open}
	 * @see ISearchbox#withOpen(boolean)
	 */
	public ISearchbox.Updater open(boolean open) {
		keys.add("open");
		builder.setOpen(open);
		return (ISearchbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code autoclose} to update to client widget
	 *
	 * @param autoclose The new value for {@code autoclose}
	 * @see ISearchbox#withAutoclose(boolean)
	 */
	public ISearchbox.Updater autoclose(boolean autoclose) {
		keys.add("autoclose");
		builder.setAutoclose(autoclose);
		return (ISearchbox.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
