// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ISelectbox}.
 */
/*package*/ class ISelectboxUpdater implements SmartUpdater {
	private final ISelectbox.Builder builder = new ISelectbox.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ISelectbox#withId(java.lang.String)
	 */
	public ISelectbox.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ISelectbox#withVisible(boolean)
	 */
	public ISelectbox.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ISelectbox#withMold(java.lang.String)
	 */
	public ISelectbox.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ISelectbox#withLeft(java.lang.String)
	 */
	public ISelectbox.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ISelectbox#withTop(java.lang.String)
	 */
	public ISelectbox.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ISelectbox#withZIndex(int)
	 */
	public ISelectbox.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ISelectbox#withHeight(java.lang.String)
	 */
	public ISelectbox.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see ISelectbox#withWidth(java.lang.String)
	 */
	public ISelectbox.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ISelectbox#withTooltiptext(java.lang.String)
	 */
	public ISelectbox.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ISelectbox#withZclass(java.lang.String)
	 */
	public ISelectbox.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ISelectbox#withSclass(java.lang.String)
	 */
	public ISelectbox.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ISelectbox#withStyle(java.lang.String)
	 */
	public ISelectbox.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ISelectbox#withDraggable(java.lang.String)
	 */
	public ISelectbox.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ISelectbox#withFocus(boolean)
	 */
	public ISelectbox.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ISelectbox#withDroppable(java.lang.String)
	 */
	public ISelectbox.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ISelectbox#withVflex(java.lang.String)
	 */
	public ISelectbox.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see ISelectbox#withHflex(java.lang.String)
	 */
	public ISelectbox.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ISelectbox#withRenderdefer(int)
	 */
	public ISelectbox.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ISelectbox#withClientAction(java.lang.String)
	 */
	public ISelectbox.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ISelectbox#withTabindex(java.lang.Integer)
	 */
	public ISelectbox.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see ISelectbox#withDisabled(boolean)
	 */
	public ISelectbox.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ISelectbox#withWidgetClass(java.lang.String)
	 */
	public ISelectbox.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code name} to update to client widget
	 *
	 * @param name The new value for {@code name}
	 * @see ISelectbox#withName(java.lang.String)
	 */
	public ISelectbox.Updater name(java.lang.String name) {
		keys.add("name");
		builder.setName(name);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code multiple} to update to client widget
	 *
	 * @param multiple The new value for {@code multiple}
	 * @see ISelectbox#withMultiple(boolean)
	 */
	public ISelectbox.Updater multiple(boolean multiple) {
		keys.add("multiple");
		builder.setMultiple(multiple);
		return (ISelectbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code maxlength} to update to client widget
	 *
	 * @param maxlength The new value for {@code maxlength}
	 * @see ISelectbox#withMaxlength(int)
	 */
	public ISelectbox.Updater maxlength(int maxlength) {
		keys.add("maxlength");
		builder.setMaxlength(maxlength);
		return (ISelectbox.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
