// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ISignature}.
 */
/*package*/ class ISignatureUpdater implements SmartUpdater {
	private final ISignature.Builder builder = new ISignature.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ISignature#withId(java.lang.String)
	 */
	public ISignature.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ISignature#withVisible(boolean)
	 */
	public ISignature.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ISignature#withMold(java.lang.String)
	 */
	public ISignature.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ISignature#withLeft(java.lang.String)
	 */
	public ISignature.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ISignature#withTop(java.lang.String)
	 */
	public ISignature.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ISignature#withZIndex(int)
	 */
	public ISignature.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ISignature#withHeight(java.lang.String)
	 */
	public ISignature.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see ISignature#withWidth(java.lang.String)
	 */
	public ISignature.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ISignature#withTooltiptext(java.lang.String)
	 */
	public ISignature.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ISignature#withZclass(java.lang.String)
	 */
	public ISignature.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ISignature#withSclass(java.lang.String)
	 */
	public ISignature.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ISignature#withStyle(java.lang.String)
	 */
	public ISignature.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ISignature#withDraggable(java.lang.String)
	 */
	public ISignature.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ISignature#withFocus(boolean)
	 */
	public ISignature.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ISignature#withDroppable(java.lang.String)
	 */
	public ISignature.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ISignature#withVflex(java.lang.String)
	 */
	public ISignature.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see ISignature#withHflex(java.lang.String)
	 */
	public ISignature.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ISignature#withRenderdefer(int)
	 */
	public ISignature.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ISignature#withClientAction(java.lang.String)
	 */
	public ISignature.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ISignature#withTabindex(java.lang.Integer)
	 */
	public ISignature.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see ISignature#withCtrlKeys(java.lang.String)
	 */
	public ISignature.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see ISignature#withContext(java.lang.String)
	 */
	public ISignature.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see ISignature#withPopup(java.lang.String)
	 */
	public ISignature.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see ISignature#withTooltip(java.lang.String)
	 */
	public ISignature.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ISignature#withWidgetClass(java.lang.String)
	 */
	public ISignature.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code backgroundImage} to update to client widget
	 *
	 * @param backgroundImage The new value for {@code backgroundImage}
	 * @see ISignature#withBackgroundImage(java.lang.String)
	 */
	public ISignature.Updater backgroundImage(java.lang.String backgroundImage) {
		keys.add("backgroundImage");
		builder.setBackgroundImage(backgroundImage);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code undoLabel} to update to client widget
	 *
	 * @param undoLabel The new value for {@code undoLabel}
	 * @see ISignature#withUndoLabel(java.lang.String)
	 */
	public ISignature.Updater undoLabel(java.lang.String undoLabel) {
		keys.add("undoLabel");
		builder.setUndoLabel(undoLabel);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code saveLabel} to update to client widget
	 *
	 * @param saveLabel The new value for {@code saveLabel}
	 * @see ISignature#withSaveLabel(java.lang.String)
	 */
	public ISignature.Updater saveLabel(java.lang.String saveLabel) {
		keys.add("saveLabel");
		builder.setSaveLabel(saveLabel);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code clearLabel} to update to client widget
	 *
	 * @param clearLabel The new value for {@code clearLabel}
	 * @see ISignature#withClearLabel(java.lang.String)
	 */
	public ISignature.Updater clearLabel(java.lang.String clearLabel) {
		keys.add("clearLabel");
		builder.setClearLabel(clearLabel);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code penSize} to update to client widget
	 *
	 * @param penSize The new value for {@code penSize}
	 * @see ISignature#withPenSize(int)
	 */
	public ISignature.Updater penSize(int penSize) {
		keys.add("penSize");
		builder.setPenSize(penSize);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code penColor} to update to client widget
	 *
	 * @param penColor The new value for {@code penColor}
	 * @see ISignature#withPenColor(java.lang.String)
	 */
	public ISignature.Updater penColor(java.lang.String penColor) {
		keys.add("penColor");
		builder.setPenColor(penColor);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code backgroundColor} to update to client widget
	 *
	 * @param backgroundColor The new value for {@code backgroundColor}
	 * @see ISignature#withBackgroundColor(java.lang.String)
	 */
	public ISignature.Updater backgroundColor(java.lang.String backgroundColor) {
		keys.add("backgroundColor");
		builder.setBackgroundColor(backgroundColor);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code saveType} to update to client widget
	 *
	 * @param saveType The new value for {@code saveType}
	 * @see ISignature#withSaveType(java.lang.String)
	 */
	public ISignature.Updater saveType(java.lang.String saveType) {
		keys.add("saveType");
		builder.setSaveType(saveType);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code backgroundIncluded} to update to client widget
	 *
	 * @param backgroundIncluded The new value for {@code backgroundIncluded}
	 * @see ISignature#withBackgroundIncluded(boolean)
	 */
	public ISignature.Updater backgroundIncluded(boolean backgroundIncluded) {
		keys.add("backgroundIncluded");
		builder.setBackgroundIncluded(backgroundIncluded);
		return (ISignature.Updater) this;
	}

	/**
	 * Sets the given value of {@code toolbarVisible} to update to client widget
	 *
	 * @param toolbarVisible The new value for {@code toolbarVisible}
	 * @see ISignature#withToolbarVisible(boolean)
	 */
	public ISignature.Updater toolbarVisible(boolean toolbarVisible) {
		keys.add("toolbarVisible");
		builder.setToolbarVisible(toolbarVisible);
		return (ISignature.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
