// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ISlider}.
 */
/*package*/ class ISliderUpdater implements SmartUpdater {
	private final ISlider.Builder builder = new ISlider.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ISlider#withId(java.lang.String)
	 */
	public ISlider.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ISlider#withVisible(boolean)
	 */
	public ISlider.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ISlider#withMold(java.lang.String)
	 */
	public ISlider.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ISlider#withLeft(java.lang.String)
	 */
	public ISlider.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ISlider#withTop(java.lang.String)
	 */
	public ISlider.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ISlider#withZIndex(int)
	 */
	public ISlider.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ISlider#withHeight(java.lang.String)
	 */
	public ISlider.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see ISlider#withWidth(java.lang.String)
	 */
	public ISlider.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ISlider#withTooltiptext(java.lang.String)
	 */
	public ISlider.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ISlider#withZclass(java.lang.String)
	 */
	public ISlider.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ISlider#withSclass(java.lang.String)
	 */
	public ISlider.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ISlider#withStyle(java.lang.String)
	 */
	public ISlider.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ISlider#withDraggable(java.lang.String)
	 */
	public ISlider.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ISlider#withFocus(boolean)
	 */
	public ISlider.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ISlider#withDroppable(java.lang.String)
	 */
	public ISlider.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ISlider#withVflex(java.lang.String)
	 */
	public ISlider.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see ISlider#withHflex(java.lang.String)
	 */
	public ISlider.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ISlider#withRenderdefer(int)
	 */
	public ISlider.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ISlider#withClientAction(java.lang.String)
	 */
	public ISlider.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ISlider#withTabindex(java.lang.Integer)
	 */
	public ISlider.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see ISlider#withCtrlKeys(java.lang.String)
	 */
	public ISlider.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see ISlider#withContext(java.lang.String)
	 */
	public ISlider.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see ISlider#withPopup(java.lang.String)
	 */
	public ISlider.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see ISlider#withTooltip(java.lang.String)
	 */
	public ISlider.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ISlider#withWidgetClass(java.lang.String)
	 */
	public ISlider.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code name} to update to client widget
	 *
	 * @param name The new value for {@code name}
	 * @see ISlider#withName(java.lang.String)
	 */
	public ISlider.Updater name(java.lang.String name) {
		keys.add("name");
		builder.setName(name);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code orient} to update to client widget
	 *
	 * @param orient The new value for {@code orient}
	 * @see ISlider#withOrient(java.lang.String)
	 */
	public ISlider.Updater orient(java.lang.String orient) {
		keys.add("orient");
		builder.setOrient(orient);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code slidingtext} to update to client widget
	 *
	 * @param slidingtext The new value for {@code slidingtext}
	 * @see ISlider#withSlidingtext(java.lang.String)
	 */
	public ISlider.Updater slidingtext(java.lang.String slidingtext) {
		keys.add("slidingtext");
		builder.setSlidingtext(slidingtext);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code curposInDouble} to update to client widget
	 *
	 * @param curposInDouble The new value for {@code curposInDouble}
	 * @see ISlider#withCurposInDouble(double)
	 */
	public ISlider.Updater curposInDouble(double curposInDouble) {
		keys.add("curposInDouble");
		builder.setCurposInDouble(curposInDouble);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code minposInDouble} to update to client widget
	 *
	 * @param minposInDouble The new value for {@code minposInDouble}
	 * @see ISlider#withMinposInDouble(double)
	 */
	public ISlider.Updater minposInDouble(double minposInDouble) {
		keys.add("minposInDouble");
		builder.setMinposInDouble(minposInDouble);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code maxposInDouble} to update to client widget
	 *
	 * @param maxposInDouble The new value for {@code maxposInDouble}
	 * @see ISlider#withMaxposInDouble(double)
	 */
	public ISlider.Updater maxposInDouble(double maxposInDouble) {
		keys.add("maxposInDouble");
		builder.setMaxposInDouble(maxposInDouble);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code stepInDouble} to update to client widget
	 *
	 * @param stepInDouble The new value for {@code stepInDouble}
	 * @see ISlider#withStepInDouble(double)
	 */
	public ISlider.Updater stepInDouble(double stepInDouble) {
		keys.add("stepInDouble");
		builder.setStepInDouble(stepInDouble);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code pageIncrementInDouble} to update to client widget
	 *
	 * @param pageIncrementInDouble The new value for {@code pageIncrementInDouble}
	 * @see ISlider#withPageIncrementInDouble(double)
	 */
	public ISlider.Updater pageIncrementInDouble(double pageIncrementInDouble) {
		keys.add("pageIncrementInDouble");
		builder.setPageIncrementInDouble(pageIncrementInDouble);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code strokeWidth} to update to client widget
	 *
	 * @param strokeWidth The new value for {@code strokeWidth}
	 * @see ISlider#withStrokeWidth(double)
	 */
	public ISlider.Updater strokeWidth(double strokeWidth) {
		keys.add("strokeWidth");
		builder.setStrokeWidth(strokeWidth);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code angleArc} to update to client widget
	 *
	 * @param angleArc The new value for {@code angleArc}
	 * @see ISlider#withAngleArc(double)
	 */
	public ISlider.Updater angleArc(double angleArc) {
		keys.add("angleArc");
		builder.setAngleArc(angleArc);
		return (ISlider.Updater) this;
	}

	/**
	 * Sets the given value of {@code scaleInput} to update to client widget
	 *
	 * @param scaleInput The new value for {@code scaleInput}
	 * @see ISlider#withScaleInput(double)
	 */
	public ISlider.Updater scaleInput(double scaleInput) {
		keys.add("scaleInput");
		builder.setScaleInput(scaleInput);
		return (ISlider.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
