// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ISplitlayout}.
 */
/*package*/ class ISplitlayoutUpdater implements SmartUpdater {
	private final ISplitlayout.Builder builder = new ISplitlayout.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ISplitlayout#withId(java.lang.String)
	 */
	public ISplitlayout.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ISplitlayout#withVisible(boolean)
	 */
	public ISplitlayout.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ISplitlayout#withMold(java.lang.String)
	 */
	public ISplitlayout.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ISplitlayout#withLeft(java.lang.String)
	 */
	public ISplitlayout.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ISplitlayout#withTop(java.lang.String)
	 */
	public ISplitlayout.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ISplitlayout#withZIndex(int)
	 */
	public ISplitlayout.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ISplitlayout#withHeight(java.lang.String)
	 */
	public ISplitlayout.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see ISplitlayout#withWidth(java.lang.String)
	 */
	public ISplitlayout.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ISplitlayout#withTooltiptext(java.lang.String)
	 */
	public ISplitlayout.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ISplitlayout#withZclass(java.lang.String)
	 */
	public ISplitlayout.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ISplitlayout#withSclass(java.lang.String)
	 */
	public ISplitlayout.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ISplitlayout#withStyle(java.lang.String)
	 */
	public ISplitlayout.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ISplitlayout#withDraggable(java.lang.String)
	 */
	public ISplitlayout.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ISplitlayout#withFocus(boolean)
	 */
	public ISplitlayout.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ISplitlayout#withDroppable(java.lang.String)
	 */
	public ISplitlayout.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ISplitlayout#withVflex(java.lang.String)
	 */
	public ISplitlayout.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see ISplitlayout#withHflex(java.lang.String)
	 */
	public ISplitlayout.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ISplitlayout#withRenderdefer(int)
	 */
	public ISplitlayout.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ISplitlayout#withClientAction(java.lang.String)
	 */
	public ISplitlayout.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ISplitlayout#withTabindex(java.lang.Integer)
	 */
	public ISplitlayout.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see ISplitlayout#withCtrlKeys(java.lang.String)
	 */
	public ISplitlayout.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see ISplitlayout#withContext(java.lang.String)
	 */
	public ISplitlayout.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see ISplitlayout#withPopup(java.lang.String)
	 */
	public ISplitlayout.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see ISplitlayout#withTooltip(java.lang.String)
	 */
	public ISplitlayout.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ISplitlayout#withWidgetClass(java.lang.String)
	 */
	public ISplitlayout.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code widths} to update to client widget
	 *
	 * @param widths The new value for {@code widths}
	 * @see ISplitlayout#withWidths(java.lang.String)
	 */
	public ISplitlayout.Updater widths(java.lang.String widths) {
		keys.add("widths");
		builder.setWidths(widths);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code heights} to update to client widget
	 *
	 * @param heights The new value for {@code heights}
	 * @see ISplitlayout#withHeights(java.lang.String)
	 */
	public ISplitlayout.Updater heights(java.lang.String heights) {
		keys.add("heights");
		builder.setHeights(heights);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code minWidths} to update to client widget
	 *
	 * @param minWidths The new value for {@code minWidths}
	 * @see ISplitlayout#withMinWidths(java.lang.String)
	 */
	public ISplitlayout.Updater minWidths(java.lang.String minWidths) {
		keys.add("minWidths");
		builder.setMinWidths(minWidths);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code minHeights} to update to client widget
	 *
	 * @param minHeights The new value for {@code minHeights}
	 * @see ISplitlayout#withMinHeights(java.lang.String)
	 */
	public ISplitlayout.Updater minHeights(java.lang.String minHeights) {
		keys.add("minHeights");
		builder.setMinHeights(minHeights);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code orient} to update to client widget
	 *
	 * @param orient The new value for {@code orient}
	 * @see ISplitlayout#withOrient(java.lang.String)
	 */
	public ISplitlayout.Updater orient(java.lang.String orient) {
		keys.add("orient");
		builder.setOrient(orient);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code collapse} to update to client widget
	 *
	 * @param collapse The new value for {@code collapse}
	 * @see ISplitlayout#withCollapse(java.lang.String)
	 */
	public ISplitlayout.Updater collapse(java.lang.String collapse) {
		keys.add("collapse");
		builder.setCollapse(collapse);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code open} to update to client widget
	 *
	 * @param open The new value for {@code open}
	 * @see ISplitlayout#withOpen(boolean)
	 */
	public ISplitlayout.Updater open(boolean open) {
		keys.add("open");
		builder.setOpen(open);
		return (ISplitlayout.Updater) this;
	}

	/**
	 * Sets the given value of {@code resizable} to update to client widget
	 *
	 * @param resizable The new value for {@code resizable}
	 * @see ISplitlayout#withResizable(boolean)
	 */
	public ISplitlayout.Updater resizable(boolean resizable) {
		keys.add("resizable");
		builder.setResizable(resizable);
		return (ISplitlayout.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
