// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IStep}.
 */
/*package*/ class IStepUpdater implements SmartUpdater {
	private final IStep.Builder builder = new IStep.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IStep#withId(java.lang.String)
	 */
	public IStep.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IStep#withVisible(boolean)
	 */
	public IStep.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IStep#withMold(java.lang.String)
	 */
	public IStep.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IStep#withLeft(java.lang.String)
	 */
	public IStep.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IStep#withTop(java.lang.String)
	 */
	public IStep.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IStep#withZIndex(int)
	 */
	public IStep.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IStep#withHeight(java.lang.String)
	 */
	public IStep.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IStep#withWidth(java.lang.String)
	 */
	public IStep.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IStep#withTooltiptext(java.lang.String)
	 */
	public IStep.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IStep#withZclass(java.lang.String)
	 */
	public IStep.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IStep#withSclass(java.lang.String)
	 */
	public IStep.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IStep#withStyle(java.lang.String)
	 */
	public IStep.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IStep#withDraggable(java.lang.String)
	 */
	public IStep.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IStep#withFocus(boolean)
	 */
	public IStep.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IStep#withDroppable(java.lang.String)
	 */
	public IStep.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IStep#withVflex(java.lang.String)
	 */
	public IStep.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IStep#withHflex(java.lang.String)
	 */
	public IStep.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IStep#withRenderdefer(int)
	 */
	public IStep.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IStep#withClientAction(java.lang.String)
	 */
	public IStep.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IStep#withTabindex(java.lang.Integer)
	 */
	public IStep.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IStep#withCtrlKeys(java.lang.String)
	 */
	public IStep.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IStep#withContext(java.lang.String)
	 */
	public IStep.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IStep#withPopup(java.lang.String)
	 */
	public IStep.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IStep#withTooltip(java.lang.String)
	 */
	public IStep.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IStep#withWidgetClass(java.lang.String)
	 */
	public IStep.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code title} to update to client widget
	 *
	 * @param title The new value for {@code title}
	 * @see IStep#withTitle(java.lang.String)
	 */
	public IStep.Updater title(java.lang.String title) {
		keys.add("title");
		builder.setTitle(title);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code iconSclass} to update to client widget
	 *
	 * @param iconSclass The new value for {@code iconSclass}
	 * @see IStep#withIconSclass(java.lang.String)
	 */
	public IStep.Updater iconSclass(java.lang.String iconSclass) {
		keys.add("iconSclass");
		builder.setIconSclass(iconSclass);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code complete} to update to client widget
	 *
	 * @param complete The new value for {@code complete}
	 * @see IStep#withComplete(boolean)
	 */
	public IStep.Updater complete(boolean complete) {
		keys.add("complete");
		builder.setComplete(complete);
		return (IStep.Updater) this;
	}

	/**
	 * Sets the given value of {@code error} to update to client widget
	 *
	 * @param error The new value for {@code error}
	 * @see IStep#withError(boolean)
	 */
	public IStep.Updater error(boolean error) {
		keys.add("error");
		builder.setError(error);
		return (IStep.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
