// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ITabbox}.
 */
/*package*/ class ITabboxUpdater implements SmartUpdater {
	private final ITabbox.Builder builder = new ITabbox.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ITabbox#withId(java.lang.String)
	 */
	public ITabbox.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ITabbox#withVisible(boolean)
	 */
	public ITabbox.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ITabbox#withMold(java.lang.String)
	 */
	public ITabbox.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ITabbox#withLeft(java.lang.String)
	 */
	public ITabbox.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ITabbox#withTop(java.lang.String)
	 */
	public ITabbox.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ITabbox#withZIndex(int)
	 */
	public ITabbox.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ITabbox#withHeight(java.lang.String)
	 */
	public ITabbox.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see ITabbox#withWidth(java.lang.String)
	 */
	public ITabbox.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ITabbox#withTooltiptext(java.lang.String)
	 */
	public ITabbox.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ITabbox#withZclass(java.lang.String)
	 */
	public ITabbox.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ITabbox#withSclass(java.lang.String)
	 */
	public ITabbox.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ITabbox#withStyle(java.lang.String)
	 */
	public ITabbox.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ITabbox#withDraggable(java.lang.String)
	 */
	public ITabbox.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ITabbox#withFocus(boolean)
	 */
	public ITabbox.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ITabbox#withDroppable(java.lang.String)
	 */
	public ITabbox.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ITabbox#withVflex(java.lang.String)
	 */
	public ITabbox.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see ITabbox#withHflex(java.lang.String)
	 */
	public ITabbox.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ITabbox#withRenderdefer(int)
	 */
	public ITabbox.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ITabbox#withClientAction(java.lang.String)
	 */
	public ITabbox.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ITabbox#withTabindex(java.lang.Integer)
	 */
	public ITabbox.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see ITabbox#withCtrlKeys(java.lang.String)
	 */
	public ITabbox.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see ITabbox#withContext(java.lang.String)
	 */
	public ITabbox.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see ITabbox#withPopup(java.lang.String)
	 */
	public ITabbox.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see ITabbox#withTooltip(java.lang.String)
	 */
	public ITabbox.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ITabbox#withWidgetClass(java.lang.String)
	 */
	public ITabbox.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code panelSpacing} to update to client widget
	 *
	 * @param panelSpacing The new value for {@code panelSpacing}
	 * @see ITabbox#withPanelSpacing(java.lang.String)
	 */
	public ITabbox.Updater panelSpacing(java.lang.String panelSpacing) {
		keys.add("panelSpacing");
		builder.setPanelSpacing(panelSpacing);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code orient} to update to client widget
	 *
	 * @param orient The new value for {@code orient}
	 * @see ITabbox#withOrient(java.lang.String)
	 */
	public ITabbox.Updater orient(java.lang.String orient) {
		keys.add("orient");
		builder.setOrient(orient);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabscroll} to update to client widget
	 *
	 * @param tabscroll The new value for {@code tabscroll}
	 * @see ITabbox#withTabscroll(boolean)
	 */
	public ITabbox.Updater tabscroll(boolean tabscroll) {
		keys.add("tabscroll");
		builder.setTabscroll(tabscroll);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code maximalHeight} to update to client widget
	 *
	 * @param maximalHeight The new value for {@code maximalHeight}
	 * @see ITabbox#withMaximalHeight(boolean)
	 */
	public ITabbox.Updater maximalHeight(boolean maximalHeight) {
		keys.add("maximalHeight");
		builder.setMaximalHeight(maximalHeight);
		return (ITabbox.Updater) this;
	}

	/**
	 * Sets the given value of {@code nativeScrollbar} to update to client widget
	 *
	 * @param nativeScrollbar The new value for {@code nativeScrollbar}
	 * @see ITabbox#withNativeScrollbar(boolean)
	 */
	public ITabbox.Updater nativeScrollbar(boolean nativeScrollbar) {
		keys.add("nativeScrollbar");
		builder.setNativeScrollbar(nativeScrollbar);
		return (ITabbox.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
