// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.ZonedDateTime;
import java.util.Date;
import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Locale;
import java.util.Map;
import java.util.Set;
import java.util.TimeZone;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ITimepicker}.
 */
/*package*/ class ITimepickerUpdater implements SmartUpdater {
	private final ITimepicker.Builder builder = new ITimepicker.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ITimepicker#withId(java.lang.String)
	 */
	public ITimepicker.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ITimepicker#withVisible(boolean)
	 */
	public ITimepicker.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ITimepicker#withMold(java.lang.String)
	 */
	public ITimepicker.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ITimepicker#withLeft(java.lang.String)
	 */
	public ITimepicker.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ITimepicker#withTop(java.lang.String)
	 */
	public ITimepicker.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ITimepicker#withZIndex(int)
	 */
	public ITimepicker.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ITimepicker#withHeight(java.lang.String)
	 */
	public ITimepicker.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see ITimepicker#withWidth(java.lang.String)
	 */
	public ITimepicker.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ITimepicker#withTooltiptext(java.lang.String)
	 */
	public ITimepicker.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ITimepicker#withZclass(java.lang.String)
	 */
	public ITimepicker.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ITimepicker#withSclass(java.lang.String)
	 */
	public ITimepicker.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ITimepicker#withStyle(java.lang.String)
	 */
	public ITimepicker.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ITimepicker#withDraggable(java.lang.String)
	 */
	public ITimepicker.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ITimepicker#withFocus(boolean)
	 */
	public ITimepicker.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ITimepicker#withDroppable(java.lang.String)
	 */
	public ITimepicker.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ITimepicker#withVflex(java.lang.String)
	 */
	public ITimepicker.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see ITimepicker#withHflex(java.lang.String)
	 */
	public ITimepicker.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ITimepicker#withRenderdefer(int)
	 */
	public ITimepicker.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ITimepicker#withClientAction(java.lang.String)
	 */
	public ITimepicker.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ITimepicker#withTabindex(java.lang.Integer)
	 */
	public ITimepicker.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see ITimepicker#withCtrlKeys(java.lang.String)
	 */
	public ITimepicker.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see ITimepicker#withContext(java.lang.String)
	 */
	public ITimepicker.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see ITimepicker#withPopup(java.lang.String)
	 */
	public ITimepicker.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see ITimepicker#withTooltip(java.lang.String)
	 */
	public ITimepicker.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code name} to update to client widget
	 *
	 * @param name The new value for {@code name}
	 * @see ITimepicker#withName(java.lang.String)
	 */
	public ITimepicker.Updater name(java.lang.String name) {
		keys.add("name");
		builder.setName(name);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code placeholder} to update to client widget
	 *
	 * @param placeholder The new value for {@code placeholder}
	 * @see ITimepicker#withPlaceholder(java.lang.String)
	 */
	public ITimepicker.Updater placeholder(java.lang.String placeholder) {
		keys.add("placeholder");
		builder.setPlaceholder(placeholder);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code value} to update to client widget
	 *
	 * @param value The new value for {@code value}
	 * @see ITimepicker#withValue(java.util.Date)
	 */
	public ITimepicker.Updater value(Date value) {
		keys.add("value");
		builder.setValue(value);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code constraint} to update to client widget
	 *
	 * @param constraint The new value for {@code constraint}
	 * @see ITimepicker#withConstraint(java.lang.String)
	 */
	public ITimepicker.Updater constraint(java.lang.String constraint) {
		keys.add("constraint");
		builder.setConstraint(constraint);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorboxSclass} to update to client widget
	 *
	 * @param errorboxSclass The new value for {@code errorboxSclass}
	 * @see ITimepicker#withErrorboxSclass(java.lang.String)
	 */
	public ITimepicker.Updater errorboxSclass(java.lang.String errorboxSclass) {
		keys.add("errorboxSclass");
		builder.setErrorboxSclass(errorboxSclass);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorboxIconSclass} to update to client widget
	 *
	 * @param errorboxIconSclass The new value for {@code errorboxIconSclass}
	 * @see ITimepicker#withErrorboxIconSclass(java.lang.String)
	 */
	public ITimepicker.Updater errorboxIconSclass(java.lang.String errorboxIconSclass) {
		keys.add("errorboxIconSclass");
		builder.setErrorboxIconSclass(errorboxIconSclass);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see ITimepicker#withDisabled(boolean)
	 */
	public ITimepicker.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code inplace} to update to client widget
	 *
	 * @param inplace The new value for {@code inplace}
	 * @see ITimepicker#withInplace(boolean)
	 */
	public ITimepicker.Updater inplace(boolean inplace) {
		keys.add("inplace");
		builder.setInplace(inplace);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code maxlength} to update to client widget
	 *
	 * @param maxlength The new value for {@code maxlength}
	 * @see ITimepicker#withMaxlength(int)
	 */
	public ITimepicker.Updater maxlength(int maxlength) {
		keys.add("maxlength");
		builder.setMaxlength(maxlength);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code instant} to update to client widget
	 *
	 * @param instant The new value for {@code instant}
	 * @see ITimepicker#withInstant(boolean)
	 */
	public ITimepicker.Updater instant(boolean instant) {
		keys.add("instant");
		builder.setInstant(instant);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code errorMessage} to update to client widget
	 *
	 * @param errorMessage The new value for {@code errorMessage}
	 * @see ITimepicker#withErrorMessage(java.lang.String)
	 */
	public ITimepicker.Updater errorMessage(java.lang.String errorMessage) {
		keys.add("errorMessage");
		builder.setErrorMessage(errorMessage);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code format} to update to client widget
	 *
	 * @param format The new value for {@code format}
	 * @see ITimepicker#withFormat(java.lang.String)
	 */
	public ITimepicker.Updater format(java.lang.String format) {
		keys.add("format");
		builder.setFormat(format);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code locale} to update to client widget
	 *
	 * @param locale The new value for {@code locale}
	 * @see ITimepicker#withLocale(java.util.Locale)
	 */
	public ITimepicker.Updater locale(Locale locale) {
		keys.add("locale");
		builder.setLocale(locale);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code timeZone} to update to client widget
	 *
	 * @param timeZone The new value for {@code timeZone}
	 * @see ITimepicker#withTimeZone(java.util.TimeZone)
	 */
	public ITimepicker.Updater timeZone(TimeZone timeZone) {
		keys.add("timeZone");
		builder.setTimeZone(timeZone);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code valueInZonedDateTime} to update to client widget
	 *
	 * @param valueInZonedDateTime The new value for {@code valueInZonedDateTime}
	 * @see ITimepicker#withValueInZonedDateTime(java.time.ZonedDateTime)
	 */
	public ITimepicker.Updater valueInZonedDateTime(ZonedDateTime valueInZonedDateTime) {
		keys.add("valueInZonedDateTime");
		builder.setValueInZonedDateTime(valueInZonedDateTime);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code valueInLocalDateTime} to update to client widget
	 *
	 * @param valueInLocalDateTime The new value for {@code valueInLocalDateTime}
	 * @see ITimepicker#withValueInLocalDateTime(java.time.LocalDateTime)
	 */
	public ITimepicker.Updater valueInLocalDateTime(LocalDateTime valueInLocalDateTime) {
		keys.add("valueInLocalDateTime");
		builder.setValueInLocalDateTime(valueInLocalDateTime);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code valueInLocalDate} to update to client widget
	 *
	 * @param valueInLocalDate The new value for {@code valueInLocalDate}
	 * @see ITimepicker#withValueInLocalDate(java.time.LocalDate)
	 */
	public ITimepicker.Updater valueInLocalDate(LocalDate valueInLocalDate) {
		keys.add("valueInLocalDate");
		builder.setValueInLocalDate(valueInLocalDate);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code valueInLocalTime} to update to client widget
	 *
	 * @param valueInLocalTime The new value for {@code valueInLocalTime}
	 * @see ITimepicker#withValueInLocalTime(java.time.LocalTime)
	 */
	public ITimepicker.Updater valueInLocalTime(LocalTime valueInLocalTime) {
		keys.add("valueInLocalTime");
		builder.setValueInLocalTime(valueInLocalTime);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ITimepicker#withWidgetClass(java.lang.String)
	 */
	public ITimepicker.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code min} to update to client widget
	 *
	 * @param min The new value for {@code min}
	 * @see ITimepicker#withMin(java.util.Date)
	 */
	public ITimepicker.Updater min(Date min) {
		keys.add("min");
		builder.setMin(min);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code max} to update to client widget
	 *
	 * @param max The new value for {@code max}
	 * @see ITimepicker#withMax(java.util.Date)
	 */
	public ITimepicker.Updater max(Date max) {
		keys.add("max");
		builder.setMax(max);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code cols} to update to client widget
	 *
	 * @param cols The new value for {@code cols}
	 * @see ITimepicker#withCols(int)
	 */
	public ITimepicker.Updater cols(int cols) {
		keys.add("cols");
		builder.setCols(cols);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code interval} to update to client widget
	 *
	 * @param interval The new value for {@code interval}
	 * @see ITimepicker#withInterval(int)
	 */
	public ITimepicker.Updater interval(int interval) {
		keys.add("interval");
		builder.setInterval(interval);
		return (ITimepicker.Updater) this;
	}

	/**
	 * Sets the given value of {@code readonly} to update to client widget
	 *
	 * @param readonly The new value for {@code readonly}
	 * @see ITimepicker#withReadonly(boolean)
	 */
	public ITimepicker.Updater readonly(boolean readonly) {
		keys.add("readonly");
		builder.setReadonly(readonly);
		return (ITimepicker.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
