// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ITimer}.
 */
/*package*/ class ITimerUpdater implements SmartUpdater {
	private final ITimer.Builder builder = new ITimer.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ITimer#withId(java.lang.String)
	 */
	public ITimer.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ITimer#withVisible(boolean)
	 */
	public ITimer.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ITimer#withMold(java.lang.String)
	 */
	public ITimer.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ITimer#withLeft(java.lang.String)
	 */
	public ITimer.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ITimer#withTop(java.lang.String)
	 */
	public ITimer.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ITimer#withZIndex(int)
	 */
	public ITimer.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ITimer#withHeight(java.lang.String)
	 */
	public ITimer.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see ITimer#withWidth(java.lang.String)
	 */
	public ITimer.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ITimer#withTooltiptext(java.lang.String)
	 */
	public ITimer.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ITimer#withZclass(java.lang.String)
	 */
	public ITimer.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ITimer#withSclass(java.lang.String)
	 */
	public ITimer.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ITimer#withStyle(java.lang.String)
	 */
	public ITimer.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ITimer#withDraggable(java.lang.String)
	 */
	public ITimer.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ITimer#withFocus(boolean)
	 */
	public ITimer.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ITimer#withDroppable(java.lang.String)
	 */
	public ITimer.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ITimer#withVflex(java.lang.String)
	 */
	public ITimer.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see ITimer#withHflex(java.lang.String)
	 */
	public ITimer.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ITimer#withRenderdefer(int)
	 */
	public ITimer.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ITimer#withClientAction(java.lang.String)
	 */
	public ITimer.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ITimer#withTabindex(java.lang.Integer)
	 */
	public ITimer.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ITimer#withWidgetClass(java.lang.String)
	 */
	public ITimer.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code repeats} to update to client widget
	 *
	 * @param repeats The new value for {@code repeats}
	 * @see ITimer#withRepeats(boolean)
	 */
	public ITimer.Updater repeats(boolean repeats) {
		keys.add("repeats");
		builder.setRepeats(repeats);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code running} to update to client widget
	 *
	 * @param running The new value for {@code running}
	 * @see ITimer#withRunning(boolean)
	 */
	public ITimer.Updater running(boolean running) {
		keys.add("running");
		builder.setRunning(running);
		return (ITimer.Updater) this;
	}

	/**
	 * Sets the given value of {@code delay} to update to client widget
	 *
	 * @param delay The new value for {@code delay}
	 * @see ITimer#withDelay(int)
	 */
	public ITimer.Updater delay(int delay) {
		keys.add("delay");
		builder.setDelay(delay);
		return (ITimer.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
