// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IToolbar}.
 */
/*package*/ class IToolbarUpdater implements SmartUpdater {
	private final IToolbar.Builder builder = new IToolbar.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IToolbar#withId(java.lang.String)
	 */
	public IToolbar.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IToolbar#withVisible(boolean)
	 */
	public IToolbar.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IToolbar#withMold(java.lang.String)
	 */
	public IToolbar.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IToolbar#withLeft(java.lang.String)
	 */
	public IToolbar.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IToolbar#withTop(java.lang.String)
	 */
	public IToolbar.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IToolbar#withZIndex(int)
	 */
	public IToolbar.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IToolbar#withHeight(java.lang.String)
	 */
	public IToolbar.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IToolbar#withWidth(java.lang.String)
	 */
	public IToolbar.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IToolbar#withTooltiptext(java.lang.String)
	 */
	public IToolbar.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IToolbar#withZclass(java.lang.String)
	 */
	public IToolbar.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IToolbar#withSclass(java.lang.String)
	 */
	public IToolbar.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IToolbar#withStyle(java.lang.String)
	 */
	public IToolbar.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IToolbar#withDraggable(java.lang.String)
	 */
	public IToolbar.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IToolbar#withFocus(boolean)
	 */
	public IToolbar.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IToolbar#withDroppable(java.lang.String)
	 */
	public IToolbar.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IToolbar#withVflex(java.lang.String)
	 */
	public IToolbar.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IToolbar#withHflex(java.lang.String)
	 */
	public IToolbar.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IToolbar#withRenderdefer(int)
	 */
	public IToolbar.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IToolbar#withClientAction(java.lang.String)
	 */
	public IToolbar.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IToolbar#withTabindex(java.lang.Integer)
	 */
	public IToolbar.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IToolbar#withCtrlKeys(java.lang.String)
	 */
	public IToolbar.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IToolbar#withContext(java.lang.String)
	 */
	public IToolbar.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IToolbar#withPopup(java.lang.String)
	 */
	public IToolbar.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IToolbar#withTooltip(java.lang.String)
	 */
	public IToolbar.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IToolbar#withWidgetClass(java.lang.String)
	 */
	public IToolbar.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code orient} to update to client widget
	 *
	 * @param orient The new value for {@code orient}
	 * @see IToolbar#withOrient(java.lang.String)
	 */
	public IToolbar.Updater orient(java.lang.String orient) {
		keys.add("orient");
		builder.setOrient(orient);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code align} to update to client widget
	 *
	 * @param align The new value for {@code align}
	 * @see IToolbar#withAlign(java.lang.String)
	 */
	public IToolbar.Updater align(java.lang.String align) {
		keys.add("align");
		builder.setAlign(align);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code overflowPopup} to update to client widget
	 *
	 * @param overflowPopup The new value for {@code overflowPopup}
	 * @see IToolbar#withOverflowPopup(boolean)
	 */
	public IToolbar.Updater overflowPopup(boolean overflowPopup) {
		keys.add("overflowPopup");
		builder.setOverflowPopup(overflowPopup);
		return (IToolbar.Updater) this;
	}

	/**
	 * Sets the given value of {@code overflowPopupIconSclass} to update to client widget
	 *
	 * @param overflowPopupIconSclass The new value for {@code overflowPopupIconSclass}
	 * @see IToolbar#withOverflowPopupIconSclass(java.lang.String)
	 */
	public IToolbar.Updater overflowPopupIconSclass(java.lang.String overflowPopupIconSclass) {
		keys.add("overflowPopupIconSclass");
		builder.setOverflowPopupIconSclass(overflowPopupIconSclass);
		return (IToolbar.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
