// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ITrack}.
 */
/*package*/ class ITrackUpdater implements SmartUpdater {
	private final ITrack.Builder builder = new ITrack.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ITrack#withId(java.lang.String)
	 */
	public ITrack.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ITrack#withVisible(boolean)
	 */
	public ITrack.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ITrack#withMold(java.lang.String)
	 */
	public ITrack.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ITrack#withLeft(java.lang.String)
	 */
	public ITrack.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ITrack#withTop(java.lang.String)
	 */
	public ITrack.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ITrack#withZIndex(int)
	 */
	public ITrack.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ITrack#withHeight(java.lang.String)
	 */
	public ITrack.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see ITrack#withWidth(java.lang.String)
	 */
	public ITrack.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ITrack#withTooltiptext(java.lang.String)
	 */
	public ITrack.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ITrack#withZclass(java.lang.String)
	 */
	public ITrack.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ITrack#withSclass(java.lang.String)
	 */
	public ITrack.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ITrack#withStyle(java.lang.String)
	 */
	public ITrack.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ITrack#withDraggable(java.lang.String)
	 */
	public ITrack.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ITrack#withFocus(boolean)
	 */
	public ITrack.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ITrack#withDroppable(java.lang.String)
	 */
	public ITrack.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ITrack#withVflex(java.lang.String)
	 */
	public ITrack.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see ITrack#withHflex(java.lang.String)
	 */
	public ITrack.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ITrack#withRenderdefer(int)
	 */
	public ITrack.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ITrack#withClientAction(java.lang.String)
	 */
	public ITrack.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ITrack#withTabindex(java.lang.Integer)
	 */
	public ITrack.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see ITrack#withCtrlKeys(java.lang.String)
	 */
	public ITrack.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see ITrack#withContext(java.lang.String)
	 */
	public ITrack.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see ITrack#withPopup(java.lang.String)
	 */
	public ITrack.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see ITrack#withTooltip(java.lang.String)
	 */
	public ITrack.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ITrack#withWidgetClass(java.lang.String)
	 */
	public ITrack.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code asDefault} to update to client widget
	 *
	 * @param asDefault The new value for {@code asDefault}
	 * @see ITrack#withAsDefault(boolean)
	 */
	public ITrack.Updater asDefault(boolean asDefault) {
		keys.add("asDefault");
		builder.setAsDefault(asDefault);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code kind} to update to client widget
	 *
	 * @param kind The new value for {@code kind}
	 * @see ITrack#withKind(java.lang.String)
	 */
	public ITrack.Updater kind(java.lang.String kind) {
		keys.add("kind");
		builder.setKind(kind);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code label} to update to client widget
	 *
	 * @param label The new value for {@code label}
	 * @see ITrack#withLabel(java.lang.String)
	 */
	public ITrack.Updater label(java.lang.String label) {
		keys.add("label");
		builder.setLabel(label);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code src} to update to client widget
	 *
	 * @param src The new value for {@code src}
	 * @see ITrack#withSrc(java.lang.String)
	 */
	public ITrack.Updater src(java.lang.String src) {
		keys.add("src");
		builder.setSrc(src);
		return (ITrack.Updater) this;
	}

	/**
	 * Sets the given value of {@code srclang} to update to client widget
	 *
	 * @param srclang The new value for {@code srclang}
	 * @see ITrack#withSrclang(java.lang.String)
	 */
	public ITrack.Updater srclang(java.lang.String srclang) {
		keys.add("srclang");
		builder.setSrclang(srclang);
		return (ITrack.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
