// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ITree}.
 */
/*package*/ class ITreeUpdater implements SmartUpdater {
	private final ITree.Builder builder = new ITree.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ITree#withId(java.lang.String)
	 */
	public ITree.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ITree#withVisible(boolean)
	 */
	public ITree.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ITree#withMold(java.lang.String)
	 */
	public ITree.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ITree#withLeft(java.lang.String)
	 */
	public ITree.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ITree#withTop(java.lang.String)
	 */
	public ITree.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ITree#withZIndex(int)
	 */
	public ITree.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ITree#withHeight(java.lang.String)
	 */
	public ITree.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see ITree#withWidth(java.lang.String)
	 */
	public ITree.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ITree#withTooltiptext(java.lang.String)
	 */
	public ITree.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ITree#withZclass(java.lang.String)
	 */
	public ITree.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ITree#withSclass(java.lang.String)
	 */
	public ITree.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ITree#withStyle(java.lang.String)
	 */
	public ITree.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ITree#withDraggable(java.lang.String)
	 */
	public ITree.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ITree#withFocus(boolean)
	 */
	public ITree.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ITree#withDroppable(java.lang.String)
	 */
	public ITree.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ITree#withVflex(java.lang.String)
	 */
	public ITree.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see ITree#withHflex(java.lang.String)
	 */
	public ITree.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ITree#withRenderdefer(int)
	 */
	public ITree.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ITree#withClientAction(java.lang.String)
	 */
	public ITree.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ITree#withTabindex(java.lang.Integer)
	 */
	public ITree.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see ITree#withCtrlKeys(java.lang.String)
	 */
	public ITree.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see ITree#withContext(java.lang.String)
	 */
	public ITree.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see ITree#withPopup(java.lang.String)
	 */
	public ITree.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see ITree#withTooltip(java.lang.String)
	 */
	public ITree.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code span} to update to client widget
	 *
	 * @param span The new value for {@code span}
	 * @see ITree#withSpan(java.lang.String)
	 */
	public ITree.Updater span(java.lang.String span) {
		keys.add("span");
		builder.setSpan(span);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code sizedByContent} to update to client widget
	 *
	 * @param sizedByContent The new value for {@code sizedByContent}
	 * @see ITree#withSizedByContent(boolean)
	 */
	public ITree.Updater sizedByContent(boolean sizedByContent) {
		keys.add("sizedByContent");
		builder.setSizedByContent(sizedByContent);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code autopaging} to update to client widget
	 *
	 * @param autopaging The new value for {@code autopaging}
	 * @see ITree#withAutopaging(boolean)
	 */
	public ITree.Updater autopaging(boolean autopaging) {
		keys.add("autopaging");
		builder.setAutopaging(autopaging);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code pagingPosition} to update to client widget
	 *
	 * @param pagingPosition The new value for {@code pagingPosition}
	 * @see ITree#withPagingPosition(java.lang.String)
	 */
	public ITree.Updater pagingPosition(java.lang.String pagingPosition) {
		keys.add("pagingPosition");
		builder.setPagingPosition(pagingPosition);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code nativeScrollbar} to update to client widget
	 *
	 * @param nativeScrollbar The new value for {@code nativeScrollbar}
	 * @see ITree#withNativeScrollbar(boolean)
	 */
	public ITree.Updater nativeScrollbar(boolean nativeScrollbar) {
		keys.add("nativeScrollbar");
		builder.setNativeScrollbar(nativeScrollbar);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ITree#withWidgetClass(java.lang.String)
	 */
	public ITree.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code rows} to update to client widget
	 *
	 * @param rows The new value for {@code rows}
	 * @see ITree#withRows(int)
	 */
	public ITree.Updater rows(int rows) {
		keys.add("rows");
		builder.setRows(rows);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code autosort} to update to client widget
	 *
	 * @param autosort The new value for {@code autosort}
	 * @see ITree#withAutosort(java.lang.String)
	 */
	public ITree.Updater autosort(java.lang.String autosort) {
		keys.add("autosort");
		builder.setAutosort(autosort);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code multiple} to update to client widget
	 *
	 * @param multiple The new value for {@code multiple}
	 * @see ITree#withMultiple(boolean)
	 */
	public ITree.Updater multiple(boolean multiple) {
		keys.add("multiple");
		builder.setMultiple(multiple);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code checkmark} to update to client widget
	 *
	 * @param checkmark The new value for {@code checkmark}
	 * @see ITree#withCheckmark(boolean)
	 */
	public ITree.Updater checkmark(boolean checkmark) {
		keys.add("checkmark");
		builder.setCheckmark(checkmark);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code nonselectableTags} to update to client widget
	 *
	 * @param nonselectableTags The new value for {@code nonselectableTags}
	 * @see ITree#withNonselectableTags(java.lang.String)
	 */
	public ITree.Updater nonselectableTags(java.lang.String nonselectableTags) {
		keys.add("nonselectableTags");
		builder.setNonselectableTags(nonselectableTags);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code checkmarkDeselectOther} to update to client widget
	 *
	 * @param checkmarkDeselectOther The new value for {@code checkmarkDeselectOther}
	 * @see ITree#withCheckmarkDeselectOther(boolean)
	 */
	public ITree.Updater checkmarkDeselectOther(boolean checkmarkDeselectOther) {
		keys.add("checkmarkDeselectOther");
		builder.setCheckmarkDeselectOther(checkmarkDeselectOther);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code selectOnHighlightDisabled} to update to client widget
	 *
	 * @param selectOnHighlightDisabled The new value for {@code selectOnHighlightDisabled}
	 * @see ITree#withSelectOnHighlightDisabled(boolean)
	 */
	public ITree.Updater selectOnHighlightDisabled(boolean selectOnHighlightDisabled) {
		keys.add("selectOnHighlightDisabled");
		builder.setSelectOnHighlightDisabled(selectOnHighlightDisabled);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code rightSelect} to update to client widget
	 *
	 * @param rightSelect The new value for {@code rightSelect}
	 * @see ITree#withRightSelect(boolean)
	 */
	public ITree.Updater rightSelect(boolean rightSelect) {
		keys.add("rightSelect");
		builder.setRightSelect(rightSelect);
		return (ITree.Updater) this;
	}

	/**
	 * Sets the given value of {@code throttleMillis} to update to client widget
	 *
	 * @param throttleMillis The new value for {@code throttleMillis}
	 * @see ITree#withThrottleMillis(int)
	 */
	public ITree.Updater throttleMillis(int throttleMillis) {
		keys.add("throttleMillis");
		builder.setThrottleMillis(throttleMillis);
		return (ITree.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
