// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link ITreeitem}.
 */
/*package*/ class ITreeitemUpdater implements SmartUpdater {
	private final ITreeitem.Builder builder = new ITreeitem.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see ITreeitem#withId(java.lang.String)
	 */
	public ITreeitem.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see ITreeitem#withVisible(boolean)
	 */
	public ITreeitem.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see ITreeitem#withMold(java.lang.String)
	 */
	public ITreeitem.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see ITreeitem#withLeft(java.lang.String)
	 */
	public ITreeitem.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see ITreeitem#withTop(java.lang.String)
	 */
	public ITreeitem.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see ITreeitem#withZIndex(int)
	 */
	public ITreeitem.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see ITreeitem#withHeight(java.lang.String)
	 */
	public ITreeitem.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see ITreeitem#withTooltiptext(java.lang.String)
	 */
	public ITreeitem.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see ITreeitem#withZclass(java.lang.String)
	 */
	public ITreeitem.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see ITreeitem#withSclass(java.lang.String)
	 */
	public ITreeitem.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see ITreeitem#withStyle(java.lang.String)
	 */
	public ITreeitem.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see ITreeitem#withDraggable(java.lang.String)
	 */
	public ITreeitem.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see ITreeitem#withFocus(boolean)
	 */
	public ITreeitem.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see ITreeitem#withDroppable(java.lang.String)
	 */
	public ITreeitem.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see ITreeitem#withVflex(java.lang.String)
	 */
	public ITreeitem.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see ITreeitem#withRenderdefer(int)
	 */
	public ITreeitem.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see ITreeitem#withClientAction(java.lang.String)
	 */
	public ITreeitem.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see ITreeitem#withTabindex(java.lang.Integer)
	 */
	public ITreeitem.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see ITreeitem#withCtrlKeys(java.lang.String)
	 */
	public ITreeitem.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see ITreeitem#withContext(java.lang.String)
	 */
	public ITreeitem.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see ITreeitem#withPopup(java.lang.String)
	 */
	public ITreeitem.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see ITreeitem#withTooltip(java.lang.String)
	 */
	public ITreeitem.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code disabled} to update to client widget
	 *
	 * @param disabled The new value for {@code disabled}
	 * @see ITreeitem#withDisabled(boolean)
	 */
	public ITreeitem.Updater disabled(boolean disabled) {
		keys.add("disabled");
		builder.setDisabled(disabled);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see ITreeitem#withWidgetClass(java.lang.String)
	 */
	public ITreeitem.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code index} to update to client widget
	 *
	 * @param index The new value for {@code index}
	 * @see ITreeitem#withIndex(int)
	 */
	public ITreeitem.Updater index(int index) {
		keys.add("index");
		builder.setIndex(index);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code image} to update to client widget
	 *
	 * @param image The new value for {@code image}
	 * @see ITreeitem#withImage(java.lang.String)
	 */
	public ITreeitem.Updater image(java.lang.String image) {
		keys.add("image");
		builder.setImage(image);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code label} to update to client widget
	 *
	 * @param label The new value for {@code label}
	 * @see ITreeitem#withLabel(java.lang.String)
	 */
	public ITreeitem.Updater label(java.lang.String label) {
		keys.add("label");
		builder.setLabel(label);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code open} to update to client widget
	 *
	 * @param open The new value for {@code open}
	 * @see ITreeitem#withOpen(boolean)
	 */
	public ITreeitem.Updater open(boolean open) {
		keys.add("open");
		builder.setOpen(open);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code selected} to update to client widget
	 *
	 * @param selected The new value for {@code selected}
	 * @see ITreeitem#withSelected(boolean)
	 */
	public ITreeitem.Updater selected(boolean selected) {
		keys.add("selected");
		builder.setSelected(selected);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code loaded} to update to client widget
	 *
	 * @param loaded The new value for {@code loaded}
	 * @see ITreeitem#withLoaded(boolean)
	 */
	public ITreeitem.Updater loaded(boolean loaded) {
		keys.add("loaded");
		builder.setLoaded(loaded);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code selectable} to update to client widget
	 *
	 * @param selectable The new value for {@code selectable}
	 * @see ITreeitem#withSelectable(boolean)
	 */
	public ITreeitem.Updater selectable(boolean selectable) {
		keys.add("selectable");
		builder.setSelectable(selectable);
		return (ITreeitem.Updater) this;
	}

	/**
	 * Sets the given value of {@code rendered} to update to client widget
	 *
	 * @param rendered The new value for {@code rendered}
	 * @see ITreeitem#withRendered(boolean)
	 */
	public ITreeitem.Updater rendered(boolean rendered) {
		keys.add("rendered");
		builder.setRendered(rendered);
		return (ITreeitem.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
