// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.video.Video;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IVideo}.
 */
/*package*/ class IVideoUpdater implements SmartUpdater {
	private final IVideo.Builder builder = new IVideo.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IVideo#withId(java.lang.String)
	 */
	public IVideo.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IVideo#withVisible(boolean)
	 */
	public IVideo.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IVideo#withMold(java.lang.String)
	 */
	public IVideo.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IVideo#withLeft(java.lang.String)
	 */
	public IVideo.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IVideo#withTop(java.lang.String)
	 */
	public IVideo.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IVideo#withZIndex(int)
	 */
	public IVideo.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IVideo#withHeight(java.lang.String)
	 */
	public IVideo.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IVideo#withWidth(java.lang.String)
	 */
	public IVideo.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IVideo#withTooltiptext(java.lang.String)
	 */
	public IVideo.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IVideo#withZclass(java.lang.String)
	 */
	public IVideo.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IVideo#withSclass(java.lang.String)
	 */
	public IVideo.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IVideo#withStyle(java.lang.String)
	 */
	public IVideo.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IVideo#withDraggable(java.lang.String)
	 */
	public IVideo.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IVideo#withFocus(boolean)
	 */
	public IVideo.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IVideo#withDroppable(java.lang.String)
	 */
	public IVideo.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IVideo#withVflex(java.lang.String)
	 */
	public IVideo.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IVideo#withHflex(java.lang.String)
	 */
	public IVideo.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IVideo#withRenderdefer(int)
	 */
	public IVideo.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IVideo#withClientAction(java.lang.String)
	 */
	public IVideo.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IVideo#withTabindex(java.lang.Integer)
	 */
	public IVideo.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IVideo#withCtrlKeys(java.lang.String)
	 */
	public IVideo.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IVideo#withContext(java.lang.String)
	 */
	public IVideo.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IVideo#withPopup(java.lang.String)
	 */
	public IVideo.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IVideo#withTooltip(java.lang.String)
	 */
	public IVideo.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IVideo#withWidgetClass(java.lang.String)
	 */
	public IVideo.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code preload} to update to client widget
	 *
	 * @param preload The new value for {@code preload}
	 * @see IVideo#withPreload(java.lang.String)
	 */
	public IVideo.Updater preload(java.lang.String preload) {
		keys.add("preload");
		builder.setPreload(preload);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code poster} to update to client widget
	 *
	 * @param poster The new value for {@code poster}
	 * @see IVideo#withPoster(java.lang.String)
	 */
	public IVideo.Updater poster(java.lang.String poster) {
		keys.add("poster");
		builder.setPoster(poster);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code crossorigin} to update to client widget
	 *
	 * @param crossorigin The new value for {@code crossorigin}
	 * @see IVideo#withCrossorigin(java.lang.String)
	 */
	public IVideo.Updater crossorigin(java.lang.String crossorigin) {
		keys.add("crossorigin");
		builder.setCrossorigin(crossorigin);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code content} to update to client widget
	 *
	 * @param content The new value for {@code content}
	 * @see IVideo#withContent(org.zkoss.video.Video)
	 */
	public IVideo.Updater content(Video content) {
		keys.add("content");
		builder.setContent(content);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code autoplay} to update to client widget
	 *
	 * @param autoplay The new value for {@code autoplay}
	 * @see IVideo#withAutoplay(boolean)
	 */
	public IVideo.Updater autoplay(boolean autoplay) {
		keys.add("autoplay");
		builder.setAutoplay(autoplay);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code controls} to update to client widget
	 *
	 * @param controls The new value for {@code controls}
	 * @see IVideo#withControls(boolean)
	 */
	public IVideo.Updater controls(boolean controls) {
		keys.add("controls");
		builder.setControls(controls);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code loop} to update to client widget
	 *
	 * @param loop The new value for {@code loop}
	 * @see IVideo#withLoop(boolean)
	 */
	public IVideo.Updater loop(boolean loop) {
		keys.add("loop");
		builder.setLoop(loop);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code dimBackground} to update to client widget
	 *
	 * @param dimBackground The new value for {@code dimBackground}
	 * @see IVideo#withDimBackground(boolean)
	 */
	public IVideo.Updater dimBackground(boolean dimBackground) {
		keys.add("dimBackground");
		builder.setDimBackground(dimBackground);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code playsinline} to update to client widget
	 *
	 * @param playsinline The new value for {@code playsinline}
	 * @see IVideo#withPlaysinline(boolean)
	 */
	public IVideo.Updater playsinline(boolean playsinline) {
		keys.add("playsinline");
		builder.setPlaysinline(playsinline);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code clipToFit} to update to client widget
	 *
	 * @param clipToFit The new value for {@code clipToFit}
	 * @see IVideo#withClipToFit(boolean)
	 */
	public IVideo.Updater clipToFit(boolean clipToFit) {
		keys.add("clipToFit");
		builder.setClipToFit(clipToFit);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code playbackRate} to update to client widget
	 *
	 * @param playbackRate The new value for {@code playbackRate}
	 * @see IVideo#withPlaybackRate(double)
	 */
	public IVideo.Updater playbackRate(double playbackRate) {
		keys.add("playbackRate");
		builder.setPlaybackRate(playbackRate);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code volume} to update to client widget
	 *
	 * @param volume The new value for {@code volume}
	 * @see IVideo#withVolume(double)
	 */
	public IVideo.Updater volume(double volume) {
		keys.add("volume");
		builder.setVolume(volume);
		return (IVideo.Updater) this;
	}

	/**
	 * Sets the given value of {@code muted} to update to client widget
	 *
	 * @param muted The new value for {@code muted}
	 * @see IVideo#withMuted(boolean)
	 */
	public IVideo.Updater muted(boolean muted) {
		keys.add("muted");
		builder.setMuted(muted);
		return (IVideo.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
