// **************************************************************************
// Code Generator: DO NOT modify the content directly
// **************************************************************************

package org.zkoss.stateless.sul;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import org.zkoss.lang.reflect.Fields;
import org.zkoss.stateless.ui.SmartUpdater;
import org.zkoss.zk.ui.UiException;

/**
 * A smart updater for {@link IWindow}.
 */
/*package*/ class IWindowUpdater implements SmartUpdater {
	private final IWindow.Builder builder = new IWindow.Builder();
	private final Set<String> keys = new LinkedHashSet<>();

	/**
	 * Sets the given value of {@code id} to update to client widget
	 *
	 * @param id The new value for {@code id}
	 * @see IWindow#withId(java.lang.String)
	 */
	public IWindow.Updater id(java.lang.String id) {
		keys.add("id");
		builder.setId(id);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code visible} to update to client widget
	 *
	 * @param visible The new value for {@code visible}
	 * @see IWindow#withVisible(boolean)
	 */
	public IWindow.Updater visible(boolean visible) {
		keys.add("visible");
		builder.setVisible(visible);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code mold} to update to client widget
	 *
	 * @param mold The new value for {@code mold}
	 * @see IWindow#withMold(java.lang.String)
	 */
	public IWindow.Updater mold(java.lang.String mold) {
		keys.add("mold");
		builder.setMold(mold);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code left} to update to client widget
	 *
	 * @param left The new value for {@code left}
	 * @see IWindow#withLeft(java.lang.String)
	 */
	public IWindow.Updater left(java.lang.String left) {
		keys.add("left");
		builder.setLeft(left);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code top} to update to client widget
	 *
	 * @param top The new value for {@code top}
	 * @see IWindow#withTop(java.lang.String)
	 */
	public IWindow.Updater top(java.lang.String top) {
		keys.add("top");
		builder.setTop(top);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code zIndex} to update to client widget
	 *
	 * @param zIndex The new value for {@code zIndex}
	 * @see IWindow#withZIndex(int)
	 */
	public IWindow.Updater zIndex(int zIndex) {
		keys.add("zIndex");
		builder.setZIndex(zIndex);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code height} to update to client widget
	 *
	 * @param height The new value for {@code height}
	 * @see IWindow#withHeight(java.lang.String)
	 */
	public IWindow.Updater height(java.lang.String height) {
		keys.add("height");
		builder.setHeight(height);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code width} to update to client widget
	 *
	 * @param width The new value for {@code width}
	 * @see IWindow#withWidth(java.lang.String)
	 */
	public IWindow.Updater width(java.lang.String width) {
		keys.add("width");
		builder.setWidth(width);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltiptext} to update to client widget
	 *
	 * @param tooltiptext The new value for {@code tooltiptext}
	 * @see IWindow#withTooltiptext(java.lang.String)
	 */
	public IWindow.Updater tooltiptext(java.lang.String tooltiptext) {
		keys.add("tooltiptext");
		builder.setTooltiptext(tooltiptext);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code zclass} to update to client widget
	 *
	 * @param zclass The new value for {@code zclass}
	 * @see IWindow#withZclass(java.lang.String)
	 */
	public IWindow.Updater zclass(java.lang.String zclass) {
		keys.add("zclass");
		builder.setZclass(zclass);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code sclass} to update to client widget
	 *
	 * @param sclass The new value for {@code sclass}
	 * @see IWindow#withSclass(java.lang.String)
	 */
	public IWindow.Updater sclass(java.lang.String sclass) {
		keys.add("sclass");
		builder.setSclass(sclass);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code style} to update to client widget
	 *
	 * @param style The new value for {@code style}
	 * @see IWindow#withStyle(java.lang.String)
	 */
	public IWindow.Updater style(java.lang.String style) {
		keys.add("style");
		builder.setStyle(style);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code draggable} to update to client widget
	 *
	 * @param draggable The new value for {@code draggable}
	 * @see IWindow#withDraggable(java.lang.String)
	 */
	public IWindow.Updater draggable(java.lang.String draggable) {
		keys.add("draggable");
		builder.setDraggable(draggable);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code focus} to update to client widget
	 *
	 * @param focus The new value for {@code focus}
	 * @see IWindow#withFocus(boolean)
	 */
	public IWindow.Updater focus(boolean focus) {
		keys.add("focus");
		builder.setFocus(focus);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code droppable} to update to client widget
	 *
	 * @param droppable The new value for {@code droppable}
	 * @see IWindow#withDroppable(java.lang.String)
	 */
	public IWindow.Updater droppable(java.lang.String droppable) {
		keys.add("droppable");
		builder.setDroppable(droppable);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code vflex} to update to client widget
	 *
	 * @param vflex The new value for {@code vflex}
	 * @see IWindow#withVflex(java.lang.String)
	 */
	public IWindow.Updater vflex(java.lang.String vflex) {
		keys.add("vflex");
		builder.setVflex(vflex);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code hflex} to update to client widget
	 *
	 * @param hflex The new value for {@code hflex}
	 * @see IWindow#withHflex(java.lang.String)
	 */
	public IWindow.Updater hflex(java.lang.String hflex) {
		keys.add("hflex");
		builder.setHflex(hflex);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code renderdefer} to update to client widget
	 *
	 * @param renderdefer The new value for {@code renderdefer}
	 * @see IWindow#withRenderdefer(int)
	 */
	public IWindow.Updater renderdefer(int renderdefer) {
		keys.add("renderdefer");
		builder.setRenderdefer(renderdefer);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code clientAction} to update to client widget
	 *
	 * @param clientAction The new value for {@code clientAction}
	 * @see IWindow#withClientAction(java.lang.String)
	 */
	public IWindow.Updater clientAction(java.lang.String clientAction) {
		keys.add("clientAction");
		builder.setClientAction(clientAction);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code tabindex} to update to client widget
	 *
	 * @param tabindex The new value for {@code tabindex}
	 * @see IWindow#withTabindex(java.lang.Integer)
	 */
	public IWindow.Updater tabindex(Integer tabindex) {
		keys.add("tabindex");
		builder.setTabindex(tabindex);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code ctrlKeys} to update to client widget
	 *
	 * @param ctrlKeys The new value for {@code ctrlKeys}
	 * @see IWindow#withCtrlKeys(java.lang.String)
	 */
	public IWindow.Updater ctrlKeys(java.lang.String ctrlKeys) {
		keys.add("ctrlKeys");
		builder.setCtrlKeys(ctrlKeys);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code context} to update to client widget
	 *
	 * @param context The new value for {@code context}
	 * @see IWindow#withContext(java.lang.String)
	 */
	public IWindow.Updater context(java.lang.String context) {
		keys.add("context");
		builder.setContext(context);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code popup} to update to client widget
	 *
	 * @param popup The new value for {@code popup}
	 * @see IWindow#withPopup(java.lang.String)
	 */
	public IWindow.Updater popup(java.lang.String popup) {
		keys.add("popup");
		builder.setPopup(popup);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code tooltip} to update to client widget
	 *
	 * @param tooltip The new value for {@code tooltip}
	 * @see IWindow#withTooltip(java.lang.String)
	 */
	public IWindow.Updater tooltip(java.lang.String tooltip) {
		keys.add("tooltip");
		builder.setTooltip(tooltip);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code widgetClass} to update to client widget
	 *
	 * @param widgetClass The new value for {@code widgetClass}
	 * @see IWindow#withWidgetClass(java.lang.String)
	 */
	public IWindow.Updater widgetClass(java.lang.String widgetClass) {
		keys.add("widgetClass");
		builder.setWidgetClass(widgetClass);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code title} to update to client widget
	 *
	 * @param title The new value for {@code title}
	 * @see IWindow#withTitle(java.lang.String)
	 */
	public IWindow.Updater title(java.lang.String title) {
		keys.add("title");
		builder.setTitle(title);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code mode} to update to client widget
	 *
	 * @param mode The new value for {@code mode}
	 * @see IWindow#withMode(java.lang.String)
	 */
	public IWindow.Updater mode(java.lang.String mode) {
		keys.add("mode");
		builder.setMode(mode);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code position} to update to client widget
	 *
	 * @param position The new value for {@code position}
	 * @see IWindow#withPosition(java.lang.String)
	 */
	public IWindow.Updater position(java.lang.String position) {
		keys.add("position");
		builder.setPosition(position);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code contentStyle} to update to client widget
	 *
	 * @param contentStyle The new value for {@code contentStyle}
	 * @see IWindow#withContentStyle(java.lang.String)
	 */
	public IWindow.Updater contentStyle(java.lang.String contentStyle) {
		keys.add("contentStyle");
		builder.setContentStyle(contentStyle);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code contentSclass} to update to client widget
	 *
	 * @param contentSclass The new value for {@code contentSclass}
	 * @see IWindow#withContentSclass(java.lang.String)
	 */
	public IWindow.Updater contentSclass(java.lang.String contentSclass) {
		keys.add("contentSclass");
		builder.setContentSclass(contentSclass);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code closable} to update to client widget
	 *
	 * @param closable The new value for {@code closable}
	 * @see IWindow#withClosable(boolean)
	 */
	public IWindow.Updater closable(boolean closable) {
		keys.add("closable");
		builder.setClosable(closable);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code maximizable} to update to client widget
	 *
	 * @param maximizable The new value for {@code maximizable}
	 * @see IWindow#withMaximizable(boolean)
	 */
	public IWindow.Updater maximizable(boolean maximizable) {
		keys.add("maximizable");
		builder.setMaximizable(maximizable);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code minimizable} to update to client widget
	 *
	 * @param minimizable The new value for {@code minimizable}
	 * @see IWindow#withMinimizable(boolean)
	 */
	public IWindow.Updater minimizable(boolean minimizable) {
		keys.add("minimizable");
		builder.setMinimizable(minimizable);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code maximized} to update to client widget
	 *
	 * @param maximized The new value for {@code maximized}
	 * @see IWindow#withMaximized(boolean)
	 */
	public IWindow.Updater maximized(boolean maximized) {
		keys.add("maximized");
		builder.setMaximized(maximized);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code minimized} to update to client widget
	 *
	 * @param minimized The new value for {@code minimized}
	 * @see IWindow#withMinimized(boolean)
	 */
	public IWindow.Updater minimized(boolean minimized) {
		keys.add("minimized");
		builder.setMinimized(minimized);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code sizable} to update to client widget
	 *
	 * @param sizable The new value for {@code sizable}
	 * @see IWindow#withSizable(boolean)
	 */
	public IWindow.Updater sizable(boolean sizable) {
		keys.add("sizable");
		builder.setSizable(sizable);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code minheight} to update to client widget
	 *
	 * @param minheight The new value for {@code minheight}
	 * @see IWindow#withMinheight(int)
	 */
	public IWindow.Updater minheight(int minheight) {
		keys.add("minheight");
		builder.setMinheight(minheight);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code minwidth} to update to client widget
	 *
	 * @param minwidth The new value for {@code minwidth}
	 * @see IWindow#withMinwidth(int)
	 */
	public IWindow.Updater minwidth(int minwidth) {
		keys.add("minwidth");
		builder.setMinwidth(minwidth);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code border} to update to client widget
	 *
	 * @param border The new value for {@code border}
	 * @see IWindow#withBorder(java.lang.String)
	 */
	public IWindow.Updater border(java.lang.String border) {
		keys.add("border");
		builder.setBorder(border);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code shadow} to update to client widget
	 *
	 * @param shadow The new value for {@code shadow}
	 * @see IWindow#withShadow(boolean)
	 */
	public IWindow.Updater shadow(boolean shadow) {
		keys.add("shadow");
		builder.setShadow(shadow);
		return (IWindow.Updater) this;
	}

	/**
	 * Sets the given value of {@code nativeScrollbar} to update to client widget
	 *
	 * @param nativeScrollbar The new value for {@code nativeScrollbar}
	 * @see IWindow#withNativeScrollbar(boolean)
	 */
	public IWindow.Updater nativeScrollbar(boolean nativeScrollbar) {
		keys.add("nativeScrollbar");
		builder.setNativeScrollbar(nativeScrollbar);
		return (IWindow.Updater) this;
	}

	@Override
	public Map<String, Object> marshal() {
		IComponent icmp = builder.build();
		Map<String, Object> map = new LinkedHashMap<>(keys.size());
		try {
			for (String key : keys) {
				map.put(key, Fields.get(icmp, key));
			}
		} catch (NoSuchMethodException e) {
			 throw UiException.Aide.wrap(e);
		}
		return map;
	}
}
