package org.zkoss.stateless.sul;

import com.google.common.base.MoreObjects;
import com.google.common.collect.ImmutableList;
import com.google.common.collect.ImmutableMap;
import com.google.common.primitives.Booleans;
import com.google.common.primitives.Doubles;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import javax.annotation.Nullable;
import javax.annotation.ParametersAreNonnullByDefault;
import javax.annotation.concurrent.Immutable;
import javax.annotation.concurrent.NotThreadSafe;
import org.immutables.value.Generated;
import org.zkoss.stateless.immutable.StatelessOnly;
import org.zkoss.stateless.util.ActionHandler;
import org.zkoss.video.Video;
import org.zkoss.zk.ui.sys.EventListenerMap;

/**
 * Immutable implementation of {@link IVideo}.
 * <p>
 * Use the builder to create immutable instances:
 * {@code new IVideo.Builder()}.
 */
@Generated(from = "IVideo", generator = "Immutables")
@SuppressWarnings({"all"})
@ParametersAreNonnullByDefault
@javax.annotation.processing.Generated("org.immutables.processor.ProxyProcessor")
@Immutable
final class ImmutableIVideo implements IVideo {
  private final String id;
  private final @Nullable ActionHandler action;
  private final @Nullable ImmutableList<ActionHandler> actions;
  private final boolean visible;
  private final String mold;
  private final @Nullable EventListenerMap eventListenerMap;
  private final @Nullable ImmutableMap<String, String> widgetListeners;
  private final @Nullable ImmutableMap<String, String> widgetOverrides;
  private final @Nullable ImmutableMap<String, String> clientAttributes;
  private final @Nullable String left;
  private final @Nullable String top;
  private final int zIndex;
  private final @Nullable String height;
  private final @Nullable String width;
  private final @Nullable String tooltiptext;
  private final @Nullable String zclass;
  private final @Nullable String sclass;
  private final @Nullable String style;
  private final String draggable;
  private final boolean focus;
  private final String droppable;
  private final @Nullable String vflex;
  private final @Nullable String hflex;
  private final int renderdefer;
  private final @Nullable String clientAction;
  private final @Nullable Integer tabindex;
  private final @Nullable String ctrlKeys;
  private final @Nullable String context;
  private final @Nullable String popup;
  private final @Nullable String tooltip;
  private final ImmutableList<ITrack> children;
  private final String widgetClass;
  private final @Nullable String preload;
  private final @Nullable String poster;
  private final @Nullable String crossorigin;
  private final @Nullable Video content;
  private final ImmutableList<String> src;
  private final boolean autoplay;
  private final boolean controls;
  private final boolean loop;
  private final boolean dimBackground;
  private final boolean playsinline;
  private final boolean clipToFit;
  private final double playbackRate;
  private final double volume;
  private final boolean muted;

  private ImmutableIVideo(ImmutableIVideo.Builder builder) {
    this.action = builder.action;
    this.actions = builder.actions == null ? null : builder.actions.build();
    this.eventListenerMap = builder.eventListenerMap;
    this.widgetListeners = builder.widgetListeners == null ? null : builder.widgetListeners.build();
    this.widgetOverrides = builder.widgetOverrides == null ? null : builder.widgetOverrides.build();
    this.clientAttributes = builder.clientAttributes == null ? null : builder.clientAttributes.build();
    this.left = builder.left;
    this.top = builder.top;
    this.height = builder.height;
    this.width = builder.width;
    this.tooltiptext = builder.tooltiptext;
    this.zclass = builder.zclass;
    this.sclass = builder.sclass;
    this.style = builder.style;
    this.vflex = builder.vflex;
    this.hflex = builder.hflex;
    this.clientAction = builder.clientAction;
    this.tabindex = builder.tabindex;
    this.ctrlKeys = builder.ctrlKeys;
    this.context = builder.context;
    this.popup = builder.popup;
    this.tooltip = builder.tooltip;
    this.children = builder.children.build();
    this.preload = builder.preload;
    this.poster = builder.poster;
    this.crossorigin = builder.crossorigin;
    this.content = builder.content;
    if (builder.id != null) {
      initShim.setId(builder.id);
    }
    if (builder.visibleIsSet()) {
      initShim.setVisible(builder.visible);
    }
    if (builder.mold != null) {
      initShim.setMold(builder.mold);
    }
    if (builder.zIndexIsSet()) {
      initShim.setZIndex(builder.zIndex);
    }
    if (builder.draggable != null) {
      initShim.setDraggable(builder.draggable);
    }
    if (builder.focusIsSet()) {
      initShim.setFocus(builder.focus);
    }
    if (builder.droppable != null) {
      initShim.setDroppable(builder.droppable);
    }
    if (builder.renderdeferIsSet()) {
      initShim.setRenderdefer(builder.renderdefer);
    }
    if (builder.widgetClass != null) {
      initShim.setWidgetClass(builder.widgetClass);
    }
    if (builder.srcIsSet()) {
      initShim.setSrc(builder.src.build());
    }
    if (builder.autoplayIsSet()) {
      initShim.setAutoplay(builder.autoplay);
    }
    if (builder.controlsIsSet()) {
      initShim.setControls(builder.controls);
    }
    if (builder.loopIsSet()) {
      initShim.setLoop(builder.loop);
    }
    if (builder.dimBackgroundIsSet()) {
      initShim.setDimBackground(builder.dimBackground);
    }
    if (builder.playsinlineIsSet()) {
      initShim.setPlaysinline(builder.playsinline);
    }
    if (builder.clipToFitIsSet()) {
      initShim.setClipToFit(builder.clipToFit);
    }
    if (builder.playbackRateIsSet()) {
      initShim.setPlaybackRate(builder.playbackRate);
    }
    if (builder.volumeIsSet()) {
      initShim.setVolume(builder.volume);
    }
    if (builder.mutedIsSet()) {
      initShim.setMuted(builder.muted);
    }
    this.id = initShim.getId();
    this.visible = initShim.isVisible();
    this.mold = initShim.getMold();
    this.zIndex = initShim.getZIndex();
    this.draggable = initShim.getDraggable();
    this.focus = initShim.isFocus();
    this.droppable = initShim.getDroppable();
    this.renderdefer = initShim.getRenderdefer();
    this.widgetClass = initShim.getWidgetClass();
    this.src = initShim.getSrc();
    this.autoplay = initShim.isAutoplay();
    this.controls = initShim.isControls();
    this.loop = initShim.isLoop();
    this.dimBackground = initShim.isDimBackground();
    this.playsinline = initShim.isPlaysinline();
    this.clipToFit = initShim.isClipToFit();
    this.playbackRate = initShim.getPlaybackRate();
    this.volume = initShim.getVolume();
    this.muted = initShim.isMuted();
    this.initShim = null;
  }

  private ImmutableIVideo(
      String id,
      @Nullable ActionHandler action,
      @Nullable ImmutableList<ActionHandler> actions,
      boolean visible,
      String mold,
      @Nullable EventListenerMap eventListenerMap,
      @Nullable ImmutableMap<String, String> widgetListeners,
      @Nullable ImmutableMap<String, String> widgetOverrides,
      @Nullable ImmutableMap<String, String> clientAttributes,
      @Nullable String left,
      @Nullable String top,
      int zIndex,
      @Nullable String height,
      @Nullable String width,
      @Nullable String tooltiptext,
      @Nullable String zclass,
      @Nullable String sclass,
      @Nullable String style,
      String draggable,
      boolean focus,
      String droppable,
      @Nullable String vflex,
      @Nullable String hflex,
      int renderdefer,
      @Nullable String clientAction,
      @Nullable Integer tabindex,
      @Nullable String ctrlKeys,
      @Nullable String context,
      @Nullable String popup,
      @Nullable String tooltip,
      ImmutableList<ITrack> children,
      String widgetClass,
      @Nullable String preload,
      @Nullable String poster,
      @Nullable String crossorigin,
      @Nullable Video content,
      ImmutableList<String> src,
      boolean autoplay,
      boolean controls,
      boolean loop,
      boolean dimBackground,
      boolean playsinline,
      boolean clipToFit,
      double playbackRate,
      double volume,
      boolean muted) {
    this.id = id;
    this.action = action;
    this.actions = actions;
    this.visible = visible;
    this.mold = mold;
    this.eventListenerMap = eventListenerMap;
    this.widgetListeners = widgetListeners;
    this.widgetOverrides = widgetOverrides;
    this.clientAttributes = clientAttributes;
    this.left = left;
    this.top = top;
    this.zIndex = zIndex;
    this.height = height;
    this.width = width;
    this.tooltiptext = tooltiptext;
    this.zclass = zclass;
    this.sclass = sclass;
    this.style = style;
    this.draggable = draggable;
    this.focus = focus;
    this.droppable = droppable;
    this.vflex = vflex;
    this.hflex = hflex;
    this.renderdefer = renderdefer;
    this.clientAction = clientAction;
    this.tabindex = tabindex;
    this.ctrlKeys = ctrlKeys;
    this.context = context;
    this.popup = popup;
    this.tooltip = tooltip;
    this.children = children;
    this.widgetClass = widgetClass;
    this.preload = preload;
    this.poster = poster;
    this.crossorigin = crossorigin;
    this.content = content;
    this.src = src;
    this.autoplay = autoplay;
    this.controls = controls;
    this.loop = loop;
    this.dimBackground = dimBackground;
    this.playsinline = playsinline;
    this.clipToFit = clipToFit;
    this.playbackRate = playbackRate;
    this.volume = volume;
    this.muted = muted;
    this.initShim = null;
  }

  private static final byte STAGE_INITIALIZING = -1;
  private static final byte STAGE_UNINITIALIZED = 0;
  private static final byte STAGE_INITIALIZED = 1;
  private transient volatile InitShim initShim = new InitShim();

  @Generated(from = "IVideo", generator = "Immutables")
  private final class InitShim {
    private byte idBuildStage = STAGE_UNINITIALIZED;
    private String id;

    String getId() {
      if (idBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (idBuildStage == STAGE_UNINITIALIZED) {
        idBuildStage = STAGE_INITIALIZING;
        this.id = Objects.requireNonNull(getIdInitialize(), "id");
        idBuildStage = STAGE_INITIALIZED;
      }
      return this.id;
    }

    void setId(String id) {
      this.id = id;
      idBuildStage = STAGE_INITIALIZED;
    }

    private byte visibleBuildStage = STAGE_UNINITIALIZED;
    private boolean visible;

    boolean isVisible() {
      if (visibleBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (visibleBuildStage == STAGE_UNINITIALIZED) {
        visibleBuildStage = STAGE_INITIALIZING;
        this.visible = isVisibleInitialize();
        visibleBuildStage = STAGE_INITIALIZED;
      }
      return this.visible;
    }

    void setVisible(boolean visible) {
      this.visible = visible;
      visibleBuildStage = STAGE_INITIALIZED;
    }

    private byte moldBuildStage = STAGE_UNINITIALIZED;
    private String mold;

    String getMold() {
      if (moldBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (moldBuildStage == STAGE_UNINITIALIZED) {
        moldBuildStage = STAGE_INITIALIZING;
        this.mold = Objects.requireNonNull(getMoldInitialize(), "mold");
        moldBuildStage = STAGE_INITIALIZED;
      }
      return this.mold;
    }

    void setMold(String mold) {
      this.mold = mold;
      moldBuildStage = STAGE_INITIALIZED;
    }

    private byte zIndexBuildStage = STAGE_UNINITIALIZED;
    private int zIndex;

    int getZIndex() {
      if (zIndexBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (zIndexBuildStage == STAGE_UNINITIALIZED) {
        zIndexBuildStage = STAGE_INITIALIZING;
        this.zIndex = getZIndexInitialize();
        zIndexBuildStage = STAGE_INITIALIZED;
      }
      return this.zIndex;
    }

    void setZIndex(int zIndex) {
      this.zIndex = zIndex;
      zIndexBuildStage = STAGE_INITIALIZED;
    }

    private byte draggableBuildStage = STAGE_UNINITIALIZED;
    private String draggable;

    String getDraggable() {
      if (draggableBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (draggableBuildStage == STAGE_UNINITIALIZED) {
        draggableBuildStage = STAGE_INITIALIZING;
        this.draggable = Objects.requireNonNull(getDraggableInitialize(), "draggable");
        draggableBuildStage = STAGE_INITIALIZED;
      }
      return this.draggable;
    }

    void setDraggable(String draggable) {
      this.draggable = draggable;
      draggableBuildStage = STAGE_INITIALIZED;
    }

    private byte focusBuildStage = STAGE_UNINITIALIZED;
    private boolean focus;

    boolean isFocus() {
      if (focusBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (focusBuildStage == STAGE_UNINITIALIZED) {
        focusBuildStage = STAGE_INITIALIZING;
        this.focus = isFocusInitialize();
        focusBuildStage = STAGE_INITIALIZED;
      }
      return this.focus;
    }

    void setFocus(boolean focus) {
      this.focus = focus;
      focusBuildStage = STAGE_INITIALIZED;
    }

    private byte droppableBuildStage = STAGE_UNINITIALIZED;
    private String droppable;

    String getDroppable() {
      if (droppableBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (droppableBuildStage == STAGE_UNINITIALIZED) {
        droppableBuildStage = STAGE_INITIALIZING;
        this.droppable = Objects.requireNonNull(getDroppableInitialize(), "droppable");
        droppableBuildStage = STAGE_INITIALIZED;
      }
      return this.droppable;
    }

    void setDroppable(String droppable) {
      this.droppable = droppable;
      droppableBuildStage = STAGE_INITIALIZED;
    }

    private byte renderdeferBuildStage = STAGE_UNINITIALIZED;
    private int renderdefer;

    int getRenderdefer() {
      if (renderdeferBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (renderdeferBuildStage == STAGE_UNINITIALIZED) {
        renderdeferBuildStage = STAGE_INITIALIZING;
        this.renderdefer = getRenderdeferInitialize();
        renderdeferBuildStage = STAGE_INITIALIZED;
      }
      return this.renderdefer;
    }

    void setRenderdefer(int renderdefer) {
      this.renderdefer = renderdefer;
      renderdeferBuildStage = STAGE_INITIALIZED;
    }

    private byte widgetClassBuildStage = STAGE_UNINITIALIZED;
    private String widgetClass;

    String getWidgetClass() {
      if (widgetClassBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (widgetClassBuildStage == STAGE_UNINITIALIZED) {
        widgetClassBuildStage = STAGE_INITIALIZING;
        this.widgetClass = Objects.requireNonNull(getWidgetClassInitialize(), "widgetClass");
        widgetClassBuildStage = STAGE_INITIALIZED;
      }
      return this.widgetClass;
    }

    void setWidgetClass(String widgetClass) {
      this.widgetClass = widgetClass;
      widgetClassBuildStage = STAGE_INITIALIZED;
    }

    private byte srcBuildStage = STAGE_UNINITIALIZED;
    private ImmutableList<String> src;

    ImmutableList<String> getSrc() {
      if (srcBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (srcBuildStage == STAGE_UNINITIALIZED) {
        srcBuildStage = STAGE_INITIALIZING;
        this.src = ImmutableList.copyOf(getSrcInitialize());
        srcBuildStage = STAGE_INITIALIZED;
      }
      return this.src;
    }

    void setSrc(ImmutableList<String> src) {
      this.src = src;
      srcBuildStage = STAGE_INITIALIZED;
    }

    private byte autoplayBuildStage = STAGE_UNINITIALIZED;
    private boolean autoplay;

    boolean isAutoplay() {
      if (autoplayBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (autoplayBuildStage == STAGE_UNINITIALIZED) {
        autoplayBuildStage = STAGE_INITIALIZING;
        this.autoplay = isAutoplayInitialize();
        autoplayBuildStage = STAGE_INITIALIZED;
      }
      return this.autoplay;
    }

    void setAutoplay(boolean autoplay) {
      this.autoplay = autoplay;
      autoplayBuildStage = STAGE_INITIALIZED;
    }

    private byte controlsBuildStage = STAGE_UNINITIALIZED;
    private boolean controls;

    boolean isControls() {
      if (controlsBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (controlsBuildStage == STAGE_UNINITIALIZED) {
        controlsBuildStage = STAGE_INITIALIZING;
        this.controls = isControlsInitialize();
        controlsBuildStage = STAGE_INITIALIZED;
      }
      return this.controls;
    }

    void setControls(boolean controls) {
      this.controls = controls;
      controlsBuildStage = STAGE_INITIALIZED;
    }

    private byte loopBuildStage = STAGE_UNINITIALIZED;
    private boolean loop;

    boolean isLoop() {
      if (loopBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (loopBuildStage == STAGE_UNINITIALIZED) {
        loopBuildStage = STAGE_INITIALIZING;
        this.loop = isLoopInitialize();
        loopBuildStage = STAGE_INITIALIZED;
      }
      return this.loop;
    }

    void setLoop(boolean loop) {
      this.loop = loop;
      loopBuildStage = STAGE_INITIALIZED;
    }

    private byte dimBackgroundBuildStage = STAGE_UNINITIALIZED;
    private boolean dimBackground;

    boolean isDimBackground() {
      if (dimBackgroundBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (dimBackgroundBuildStage == STAGE_UNINITIALIZED) {
        dimBackgroundBuildStage = STAGE_INITIALIZING;
        this.dimBackground = isDimBackgroundInitialize();
        dimBackgroundBuildStage = STAGE_INITIALIZED;
      }
      return this.dimBackground;
    }

    void setDimBackground(boolean dimBackground) {
      this.dimBackground = dimBackground;
      dimBackgroundBuildStage = STAGE_INITIALIZED;
    }

    private byte playsinlineBuildStage = STAGE_UNINITIALIZED;
    private boolean playsinline;

    boolean isPlaysinline() {
      if (playsinlineBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (playsinlineBuildStage == STAGE_UNINITIALIZED) {
        playsinlineBuildStage = STAGE_INITIALIZING;
        this.playsinline = isPlaysinlineInitialize();
        playsinlineBuildStage = STAGE_INITIALIZED;
      }
      return this.playsinline;
    }

    void setPlaysinline(boolean playsinline) {
      this.playsinline = playsinline;
      playsinlineBuildStage = STAGE_INITIALIZED;
    }

    private byte clipToFitBuildStage = STAGE_UNINITIALIZED;
    private boolean clipToFit;

    boolean isClipToFit() {
      if (clipToFitBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (clipToFitBuildStage == STAGE_UNINITIALIZED) {
        clipToFitBuildStage = STAGE_INITIALIZING;
        this.clipToFit = isClipToFitInitialize();
        clipToFitBuildStage = STAGE_INITIALIZED;
      }
      return this.clipToFit;
    }

    void setClipToFit(boolean clipToFit) {
      this.clipToFit = clipToFit;
      clipToFitBuildStage = STAGE_INITIALIZED;
    }

    private byte playbackRateBuildStage = STAGE_UNINITIALIZED;
    private double playbackRate;

    double getPlaybackRate() {
      if (playbackRateBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (playbackRateBuildStage == STAGE_UNINITIALIZED) {
        playbackRateBuildStage = STAGE_INITIALIZING;
        this.playbackRate = getPlaybackRateInitialize();
        playbackRateBuildStage = STAGE_INITIALIZED;
      }
      return this.playbackRate;
    }

    void setPlaybackRate(double playbackRate) {
      this.playbackRate = playbackRate;
      playbackRateBuildStage = STAGE_INITIALIZED;
    }

    private byte volumeBuildStage = STAGE_UNINITIALIZED;
    private double volume;

    double getVolume() {
      if (volumeBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (volumeBuildStage == STAGE_UNINITIALIZED) {
        volumeBuildStage = STAGE_INITIALIZING;
        this.volume = getVolumeInitialize();
        volumeBuildStage = STAGE_INITIALIZED;
      }
      return this.volume;
    }

    void setVolume(double volume) {
      this.volume = volume;
      volumeBuildStage = STAGE_INITIALIZED;
    }

    private byte mutedBuildStage = STAGE_UNINITIALIZED;
    private boolean muted;

    boolean isMuted() {
      if (mutedBuildStage == STAGE_INITIALIZING) throw new IllegalStateException(formatInitCycleMessage());
      if (mutedBuildStage == STAGE_UNINITIALIZED) {
        mutedBuildStage = STAGE_INITIALIZING;
        this.muted = isMutedInitialize();
        mutedBuildStage = STAGE_INITIALIZED;
      }
      return this.muted;
    }

    void setMuted(boolean muted) {
      this.muted = muted;
      mutedBuildStage = STAGE_INITIALIZED;
    }

    private String formatInitCycleMessage() {
      List<String> attributes = new ArrayList<>();
      if (idBuildStage == STAGE_INITIALIZING) attributes.add("id");
      if (visibleBuildStage == STAGE_INITIALIZING) attributes.add("visible");
      if (moldBuildStage == STAGE_INITIALIZING) attributes.add("mold");
      if (zIndexBuildStage == STAGE_INITIALIZING) attributes.add("zIndex");
      if (draggableBuildStage == STAGE_INITIALIZING) attributes.add("draggable");
      if (focusBuildStage == STAGE_INITIALIZING) attributes.add("focus");
      if (droppableBuildStage == STAGE_INITIALIZING) attributes.add("droppable");
      if (renderdeferBuildStage == STAGE_INITIALIZING) attributes.add("renderdefer");
      if (widgetClassBuildStage == STAGE_INITIALIZING) attributes.add("widgetClass");
      if (srcBuildStage == STAGE_INITIALIZING) attributes.add("src");
      if (autoplayBuildStage == STAGE_INITIALIZING) attributes.add("autoplay");
      if (controlsBuildStage == STAGE_INITIALIZING) attributes.add("controls");
      if (loopBuildStage == STAGE_INITIALIZING) attributes.add("loop");
      if (dimBackgroundBuildStage == STAGE_INITIALIZING) attributes.add("dimBackground");
      if (playsinlineBuildStage == STAGE_INITIALIZING) attributes.add("playsinline");
      if (clipToFitBuildStage == STAGE_INITIALIZING) attributes.add("clipToFit");
      if (playbackRateBuildStage == STAGE_INITIALIZING) attributes.add("playbackRate");
      if (volumeBuildStage == STAGE_INITIALIZING) attributes.add("volume");
      if (mutedBuildStage == STAGE_INITIALIZING) attributes.add("muted");
      return "Cannot build IVideo, attribute initializers form cycle " + attributes;
    }
  }

  private String getIdInitialize() {
    return IVideo.super.getId();
  }

  private boolean isVisibleInitialize() {
    return IVideo.super.isVisible();
  }

  private String getMoldInitialize() {
    return IVideo.super.getMold();
  }

  private int getZIndexInitialize() {
    return IVideo.super.getZIndex();
  }

  private String getDraggableInitialize() {
    return IVideo.super.getDraggable();
  }

  private boolean isFocusInitialize() {
    return IVideo.super.isFocus();
  }

  private String getDroppableInitialize() {
    return IVideo.super.getDroppable();
  }

  private int getRenderdeferInitialize() {
    return IVideo.super.getRenderdefer();
  }

  private String getWidgetClassInitialize() {
    return IVideo.super.getWidgetClass();
  }

  private List<String> getSrcInitialize() {
    return IVideo.super.getSrc();
  }

  private boolean isAutoplayInitialize() {
    return IVideo.super.isAutoplay();
  }

  private boolean isControlsInitialize() {
    return IVideo.super.isControls();
  }

  private boolean isLoopInitialize() {
    return IVideo.super.isLoop();
  }

  private boolean isDimBackgroundInitialize() {
    return IVideo.super.isDimBackground();
  }

  private boolean isPlaysinlineInitialize() {
    return IVideo.super.isPlaysinline();
  }

  private boolean isClipToFitInitialize() {
    return IVideo.super.isClipToFit();
  }

  private double getPlaybackRateInitialize() {
    return IVideo.super.getPlaybackRate();
  }

  private double getVolumeInitialize() {
    return IVideo.super.getVolume();
  }

  private boolean isMutedInitialize() {
    return IVideo.super.isMuted();
  }

  /**
   * @return The value of the {@code id} attribute
   */
  @Override
  public String getId() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.getId()
        : this.id;
  }

  /**
   * @return The value of the {@code action} attribute
   */
  @StatelessOnly
  @Override
  public @Nullable ActionHandler getAction() {
    return action;
  }

  /**
   * @return The value of the {@code actions} attribute
   */
  @StatelessOnly
  @Override
  public @Nullable ImmutableList<ActionHandler> getActions() {
    return actions;
  }

  /**
   * @return The value of the {@code visible} attribute
   */
  @Override
  public boolean isVisible() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.isVisible()
        : this.visible;
  }

  /**
   * @return The value of the {@code mold} attribute
   */
  @Override
  public String getMold() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.getMold()
        : this.mold;
  }

  /**
   * @return The value of the {@code eventListenerMap} attribute
   */
  @Override
  public @Nullable EventListenerMap getEventListenerMap() {
    return eventListenerMap;
  }

  /**
   * @return The value of the {@code widgetListeners} attribute
   */
  @Override
  public @Nullable ImmutableMap<String, String> getWidgetListeners() {
    return widgetListeners;
  }

  /**
   * @return The value of the {@code widgetOverrides} attribute
   */
  @Override
  public @Nullable ImmutableMap<String, String> getWidgetOverrides() {
    return widgetOverrides;
  }

  /**
   * @return The value of the {@code clientAttributes} attribute
   */
  @Override
  public @Nullable ImmutableMap<String, String> getClientAttributes() {
    return clientAttributes;
  }

  /**
   * @return The value of the {@code left} attribute
   */
  @Override
  public @Nullable String getLeft() {
    return left;
  }

  /**
   * @return The value of the {@code top} attribute
   */
  @Override
  public @Nullable String getTop() {
    return top;
  }

  /**
   * @return The value of the {@code zIndex} attribute
   */
  @Override
  public int getZIndex() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.getZIndex()
        : this.zIndex;
  }

  /**
   * @return The value of the {@code height} attribute
   */
  @Override
  public @Nullable String getHeight() {
    return height;
  }

  /**
   * @return The value of the {@code width} attribute
   */
  @Override
  public @Nullable String getWidth() {
    return width;
  }

  /**
   * @return The value of the {@code tooltiptext} attribute
   */
  @Override
  public @Nullable String getTooltiptext() {
    return tooltiptext;
  }

  /**
   * @return The value of the {@code zclass} attribute
   */
  @Override
  public @Nullable String getZclass() {
    return zclass;
  }

  /**
   * @return The value of the {@code sclass} attribute
   */
  @Override
  public @Nullable String getSclass() {
    return sclass;
  }

  /**
   * @return The value of the {@code style} attribute
   */
  @Override
  public @Nullable String getStyle() {
    return style;
  }

  /**
   * @return The value of the {@code draggable} attribute
   */
  @Override
  public String getDraggable() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.getDraggable()
        : this.draggable;
  }

  /**
   * @return The value of the {@code focus} attribute
   */
  @Override
  public boolean isFocus() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.isFocus()
        : this.focus;
  }

  /**
   * @return The value of the {@code droppable} attribute
   */
  @Override
  public String getDroppable() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.getDroppable()
        : this.droppable;
  }

  /**
   * @return The value of the {@code vflex} attribute
   */
  @Override
  public @Nullable String getVflex() {
    return vflex;
  }

  /**
   * @return The value of the {@code hflex} attribute
   */
  @Override
  public @Nullable String getHflex() {
    return hflex;
  }

  /**
   * @return The value of the {@code renderdefer} attribute
   */
  @Override
  public int getRenderdefer() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.getRenderdefer()
        : this.renderdefer;
  }

  /**
   * @return The value of the {@code clientAction} attribute
   */
  @Override
  public @Nullable String getClientAction() {
    return clientAction;
  }

  /**
   * @return The value of the {@code tabindex} attribute
   */
  @Override
  public @Nullable Integer getTabindex() {
    return tabindex;
  }

  /**
   * @return The value of the {@code ctrlKeys} attribute
   */
  @Override
  public @Nullable String getCtrlKeys() {
    return ctrlKeys;
  }

  /**
   * @return The value of the {@code context} attribute
   */
  @Override
  public @Nullable String getContext() {
    return context;
  }

  /**
   * @return The value of the {@code popup} attribute
   */
  @Override
  public @Nullable String getPopup() {
    return popup;
  }

  /**
   * @return The value of the {@code tooltip} attribute
   */
  @Override
  public @Nullable String getTooltip() {
    return tooltip;
  }

  /**
   * @return The value of the {@code children} attribute
   */
  @StatelessOnly
  @Override
  public ImmutableList<ITrack> getChildren() {
    return children;
  }

  /**
   * @return The value of the {@code widgetClass} attribute
   */
  @Override
  public String getWidgetClass() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.getWidgetClass()
        : this.widgetClass;
  }

  /**
   * @return The value of the {@code preload} attribute
   */
  @Override
  public @Nullable String getPreload() {
    return preload;
  }

  /**
   * @return The value of the {@code poster} attribute
   */
  @Override
  public @Nullable String getPoster() {
    return poster;
  }

  /**
   * @return The value of the {@code crossorigin} attribute
   */
  @Override
  public @Nullable String getCrossorigin() {
    return crossorigin;
  }

  /**
   * @return The value of the {@code content} attribute
   */
  @Override
  public @Nullable Video getContent() {
    return content;
  }

  /**
   * @return The value of the {@code src} attribute
   */
  @Override
  public ImmutableList<String> getSrc() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.getSrc()
        : this.src;
  }

  /**
   * @return The value of the {@code autoplay} attribute
   */
  @Override
  public boolean isAutoplay() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.isAutoplay()
        : this.autoplay;
  }

  /**
   * @return The value of the {@code controls} attribute
   */
  @Override
  public boolean isControls() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.isControls()
        : this.controls;
  }

  /**
   * @return The value of the {@code loop} attribute
   */
  @Override
  public boolean isLoop() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.isLoop()
        : this.loop;
  }

  /**
   * @return The value of the {@code dimBackground} attribute
   */
  @Override
  public boolean isDimBackground() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.isDimBackground()
        : this.dimBackground;
  }

  /**
   * @return The value of the {@code playsinline} attribute
   */
  @Override
  public boolean isPlaysinline() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.isPlaysinline()
        : this.playsinline;
  }

  /**
   * @return The value of the {@code clipToFit} attribute
   */
  @Override
  public boolean isClipToFit() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.isClipToFit()
        : this.clipToFit;
  }

  /**
   * @return The value of the {@code playbackRate} attribute
   */
  @Override
  public double getPlaybackRate() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.getPlaybackRate()
        : this.playbackRate;
  }

  /**
   * @return The value of the {@code volume} attribute
   */
  @Override
  public double getVolume() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.getVolume()
        : this.volume;
  }

  /**
   * @return The value of the {@code muted} attribute
   */
  @Override
  public boolean isMuted() {
    InitShim shim = this.initShim;
    return shim != null
        ? shim.isMuted()
        : this.muted;
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getId() id} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for id
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withId(String value) {
    String newValue = Objects.requireNonNull(value, "id");
    if (this.id.equals(newValue)) return this;
    return validate(new ImmutableIVideo(
        newValue,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getAction() action} attribute.
   * A shallow reference equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for action (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withAction(@Nullable ActionHandler value) {
    if (this.action == value) return this;
    return validate(new ImmutableIVideo(
        this.id,
        value,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object with elements that replace the content of {@link IVideo#getActions() actions}.
   * @param elements The elements to set
   * @return A modified copy of {@code this} object
   */
  public final ImmutableIVideo withActions(@Nullable ActionHandler... elements) {
    if (elements == null) {
      return validate(new ImmutableIVideo(
          this.id,
          this.action,
          null,
          this.visible,
          this.mold,
          this.eventListenerMap,
          this.widgetListeners,
          this.widgetOverrides,
          this.clientAttributes,
          this.left,
          this.top,
          this.zIndex,
          this.height,
          this.width,
          this.tooltiptext,
          this.zclass,
          this.sclass,
          this.style,
          this.draggable,
          this.focus,
          this.droppable,
          this.vflex,
          this.hflex,
          this.renderdefer,
          this.clientAction,
          this.tabindex,
          this.ctrlKeys,
          this.context,
          this.popup,
          this.tooltip,
          this.children,
          this.widgetClass,
          this.preload,
          this.poster,
          this.crossorigin,
          this.content,
          this.src,
          this.autoplay,
          this.controls,
          this.loop,
          this.dimBackground,
          this.playsinline,
          this.clipToFit,
          this.playbackRate,
          this.volume,
          this.muted));
    }
    @Nullable ImmutableList<ActionHandler> newValue = elements == null ? null : ImmutableList.copyOf(elements);
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        newValue,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object with elements that replace the content of {@link IVideo#getActions() actions}.
   * A shallow reference equality check is used to prevent copying of the same value by returning {@code this}.
   * @param elements An iterable of actions elements to set
   * @return A modified copy of {@code this} object
   */
  public final ImmutableIVideo withActions(@Nullable Iterable<? extends ActionHandler> elements) {
    if (this.actions == elements) return this;
    @Nullable ImmutableList<ActionHandler> newValue = elements == null ? null : ImmutableList.copyOf(elements);
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        newValue,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#isVisible() visible} attribute.
   * A value equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for visible
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withVisible(boolean value) {
    if (this.visible == value) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        value,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getMold() mold} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for mold
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withMold(String value) {
    String newValue = Objects.requireNonNull(value, "mold");
    if (this.mold.equals(newValue)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        newValue,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getEventListenerMap() eventListenerMap} attribute.
   * A shallow reference equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for eventListenerMap (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withEventListenerMap(@Nullable EventListenerMap value) {
    if (this.eventListenerMap == value) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        value,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by replacing the {@link IVideo#getWidgetListeners() widgetListeners} map with the specified map.
   * Nulls are not permitted as keys or values.
   * A shallow reference equality check is used to prevent copying of the same value by returning {@code this}.
   * @param entries The entries to be added to the widgetListeners map
   * @return A modified copy of {@code this} object
   */
  public final ImmutableIVideo withWidgetListeners(@Nullable Map<String, ? extends String> entries) {
    if (this.widgetListeners == entries) return this;
    @Nullable ImmutableMap<String, String> newValue = entries == null ? null : ImmutableMap.copyOf(entries);
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        newValue,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by replacing the {@link IVideo#getWidgetOverrides() widgetOverrides} map with the specified map.
   * Nulls are not permitted as keys or values.
   * A shallow reference equality check is used to prevent copying of the same value by returning {@code this}.
   * @param entries The entries to be added to the widgetOverrides map
   * @return A modified copy of {@code this} object
   */
  public final ImmutableIVideo withWidgetOverrides(@Nullable Map<String, ? extends String> entries) {
    if (this.widgetOverrides == entries) return this;
    @Nullable ImmutableMap<String, String> newValue = entries == null ? null : ImmutableMap.copyOf(entries);
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        newValue,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by replacing the {@link IVideo#getClientAttributes() clientAttributes} map with the specified map.
   * Nulls are not permitted as keys or values.
   * A shallow reference equality check is used to prevent copying of the same value by returning {@code this}.
   * @param entries The entries to be added to the clientAttributes map
   * @return A modified copy of {@code this} object
   */
  public final ImmutableIVideo withClientAttributes(@Nullable Map<String, ? extends String> entries) {
    if (this.clientAttributes == entries) return this;
    @Nullable ImmutableMap<String, String> newValue = entries == null ? null : ImmutableMap.copyOf(entries);
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        newValue,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getLeft() left} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for left (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withLeft(@Nullable String value) {
    if (Objects.equals(this.left, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        value,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getTop() top} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for top (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withTop(@Nullable String value) {
    if (Objects.equals(this.top, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        value,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getZIndex() zIndex} attribute.
   * A value equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for zIndex
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withZIndex(int value) {
    if (this.zIndex == value) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        value,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getHeight() height} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for height (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withHeight(@Nullable String value) {
    if (Objects.equals(this.height, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        value,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getWidth() width} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for width (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withWidth(@Nullable String value) {
    if (Objects.equals(this.width, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        value,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getTooltiptext() tooltiptext} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for tooltiptext (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withTooltiptext(@Nullable String value) {
    if (Objects.equals(this.tooltiptext, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        value,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getZclass() zclass} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for zclass (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withZclass(@Nullable String value) {
    if (Objects.equals(this.zclass, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        value,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getSclass() sclass} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for sclass (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withSclass(@Nullable String value) {
    if (Objects.equals(this.sclass, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        value,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getStyle() style} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for style (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withStyle(@Nullable String value) {
    if (Objects.equals(this.style, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        value,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getDraggable() draggable} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for draggable
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withDraggable(String value) {
    String newValue = Objects.requireNonNull(value, "draggable");
    if (this.draggable.equals(newValue)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        newValue,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#isFocus() focus} attribute.
   * A value equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for focus
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withFocus(boolean value) {
    if (this.focus == value) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        value,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getDroppable() droppable} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for droppable
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withDroppable(String value) {
    String newValue = Objects.requireNonNull(value, "droppable");
    if (this.droppable.equals(newValue)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        newValue,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getVflex() vflex} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for vflex (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withVflex(@Nullable String value) {
    if (Objects.equals(this.vflex, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        value,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getHflex() hflex} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for hflex (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withHflex(@Nullable String value) {
    if (Objects.equals(this.hflex, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        value,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getRenderdefer() renderdefer} attribute.
   * A value equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for renderdefer
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withRenderdefer(int value) {
    if (this.renderdefer == value) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        value,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getClientAction() clientAction} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for clientAction (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withClientAction(@Nullable String value) {
    if (Objects.equals(this.clientAction, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        value,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getTabindex() tabindex} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for tabindex (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withTabindex(@Nullable Integer value) {
    if (Objects.equals(this.tabindex, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        value,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getCtrlKeys() ctrlKeys} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for ctrlKeys (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withCtrlKeys(@Nullable String value) {
    if (Objects.equals(this.ctrlKeys, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        value,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getContext() context} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for context (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withContext(@Nullable String value) {
    if (Objects.equals(this.context, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        value,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getPopup() popup} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for popup (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withPopup(@Nullable String value) {
    if (Objects.equals(this.popup, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        value,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getTooltip() tooltip} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for tooltip (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withTooltip(@Nullable String value) {
    if (Objects.equals(this.tooltip, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        value,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object with elements that replace the content of {@link IVideo#getChildren() children}.
   * @param elements The elements to set
   * @return A modified copy of {@code this} object
   */
  public final ImmutableIVideo withChildren(ITrack... elements) {
    ImmutableList<ITrack> newValue = ImmutableList.copyOf(elements);
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        newValue,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object with elements that replace the content of {@link IVideo#getChildren() children}.
   * A shallow reference equality check is used to prevent copying of the same value by returning {@code this}.
   * @param elements An iterable of children elements to set
   * @return A modified copy of {@code this} object
   */
  public final ImmutableIVideo withChildren(Iterable<? extends ITrack> elements) {
    if (this.children == elements) return this;
    ImmutableList<ITrack> newValue = ImmutableList.copyOf(elements);
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        newValue,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getWidgetClass() widgetClass} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for widgetClass
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withWidgetClass(String value) {
    String newValue = Objects.requireNonNull(value, "widgetClass");
    if (this.widgetClass.equals(newValue)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        newValue,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getPreload() preload} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for preload (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withPreload(@Nullable String value) {
    if (Objects.equals(this.preload, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        value,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getPoster() poster} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for poster (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withPoster(@Nullable String value) {
    if (Objects.equals(this.poster, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        value,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getCrossorigin() crossorigin} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for crossorigin (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withCrossorigin(@Nullable String value) {
    if (Objects.equals(this.crossorigin, value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        value,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getContent() content} attribute.
   * A shallow reference equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for content (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withContent(@Nullable Video value) {
    if (this.content == value) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        value,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object with elements that replace the content of {@link IVideo#getSrc() src}.
   * @param elements The elements to set
   * @return A modified copy of {@code this} object
   */
  public final ImmutableIVideo withSrc(String... elements) {
    ImmutableList<String> newValue = ImmutableList.copyOf(elements);
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        newValue,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object with elements that replace the content of {@link IVideo#getSrc() src}.
   * A shallow reference equality check is used to prevent copying of the same value by returning {@code this}.
   * @param elements An iterable of src elements to set
   * @return A modified copy of {@code this} object
   */
  public final ImmutableIVideo withSrc(Iterable<String> elements) {
    if (this.src == elements) return this;
    ImmutableList<String> newValue = ImmutableList.copyOf(elements);
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        newValue,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#isAutoplay() autoplay} attribute.
   * A value equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for autoplay
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withAutoplay(boolean value) {
    if (this.autoplay == value) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        value,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#isControls() controls} attribute.
   * A value equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for controls
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withControls(boolean value) {
    if (this.controls == value) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        value,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#isLoop() loop} attribute.
   * A value equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for loop
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withLoop(boolean value) {
    if (this.loop == value) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        value,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#isDimBackground() dimBackground} attribute.
   * A value equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for dimBackground
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withDimBackground(boolean value) {
    if (this.dimBackground == value) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        value,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#isPlaysinline() playsinline} attribute.
   * A value equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for playsinline
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withPlaysinline(boolean value) {
    if (this.playsinline == value) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        value,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#isClipToFit() clipToFit} attribute.
   * A value equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for clipToFit
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withClipToFit(boolean value) {
    if (this.clipToFit == value) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        value,
        this.playbackRate,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getPlaybackRate() playbackRate} attribute.
   * A value strict bits equality used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for playbackRate
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withPlaybackRate(double value) {
    if (Double.doubleToLongBits(this.playbackRate) == Double.doubleToLongBits(value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        value,
        this.volume,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#getVolume() volume} attribute.
   * A value strict bits equality used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for volume
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withVolume(double value) {
    if (Double.doubleToLongBits(this.volume) == Double.doubleToLongBits(value)) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        value,
        this.muted));
  }

  /**
   * Copy the current immutable object by setting a value for the {@link IVideo#isMuted() muted} attribute.
   * A value equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for muted
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableIVideo withMuted(boolean value) {
    if (this.muted == value) return this;
    return validate(new ImmutableIVideo(
        this.id,
        this.action,
        this.actions,
        this.visible,
        this.mold,
        this.eventListenerMap,
        this.widgetListeners,
        this.widgetOverrides,
        this.clientAttributes,
        this.left,
        this.top,
        this.zIndex,
        this.height,
        this.width,
        this.tooltiptext,
        this.zclass,
        this.sclass,
        this.style,
        this.draggable,
        this.focus,
        this.droppable,
        this.vflex,
        this.hflex,
        this.renderdefer,
        this.clientAction,
        this.tabindex,
        this.ctrlKeys,
        this.context,
        this.popup,
        this.tooltip,
        this.children,
        this.widgetClass,
        this.preload,
        this.poster,
        this.crossorigin,
        this.content,
        this.src,
        this.autoplay,
        this.controls,
        this.loop,
        this.dimBackground,
        this.playsinline,
        this.clipToFit,
        this.playbackRate,
        this.volume,
        value));
  }

  /**
   * This instance is equal to all instances of {@code ImmutableIVideo} that have equal attribute values.
   * @return {@code true} if {@code this} is equal to {@code another} instance
   */
  @Override
  public boolean equals(@Nullable Object another) {
    if (this == another) return true;
    return another instanceof ImmutableIVideo
        && equalTo((ImmutableIVideo) another);
  }

  private boolean equalTo(ImmutableIVideo another) {
    return id.equals(another.id)
        && Objects.equals(action, another.action)
        && Objects.equals(actions, another.actions)
        && visible == another.visible
        && mold.equals(another.mold)
        && Objects.equals(eventListenerMap, another.eventListenerMap)
        && Objects.equals(widgetListeners, another.widgetListeners)
        && Objects.equals(widgetOverrides, another.widgetOverrides)
        && Objects.equals(clientAttributes, another.clientAttributes)
        && Objects.equals(left, another.left)
        && Objects.equals(top, another.top)
        && zIndex == another.zIndex
        && Objects.equals(height, another.height)
        && Objects.equals(width, another.width)
        && Objects.equals(tooltiptext, another.tooltiptext)
        && Objects.equals(zclass, another.zclass)
        && Objects.equals(sclass, another.sclass)
        && Objects.equals(style, another.style)
        && draggable.equals(another.draggable)
        && focus == another.focus
        && droppable.equals(another.droppable)
        && Objects.equals(vflex, another.vflex)
        && Objects.equals(hflex, another.hflex)
        && renderdefer == another.renderdefer
        && Objects.equals(clientAction, another.clientAction)
        && Objects.equals(tabindex, another.tabindex)
        && Objects.equals(ctrlKeys, another.ctrlKeys)
        && Objects.equals(context, another.context)
        && Objects.equals(popup, another.popup)
        && Objects.equals(tooltip, another.tooltip)
        && children.equals(another.children)
        && widgetClass.equals(another.widgetClass)
        && Objects.equals(preload, another.preload)
        && Objects.equals(poster, another.poster)
        && Objects.equals(crossorigin, another.crossorigin)
        && Objects.equals(content, another.content)
        && src.equals(another.src)
        && autoplay == another.autoplay
        && controls == another.controls
        && loop == another.loop
        && dimBackground == another.dimBackground
        && playsinline == another.playsinline
        && clipToFit == another.clipToFit
        && Double.doubleToLongBits(playbackRate) == Double.doubleToLongBits(another.playbackRate)
        && Double.doubleToLongBits(volume) == Double.doubleToLongBits(another.volume)
        && muted == another.muted;
  }

  /**
   * Computes a hash code from attributes: {@code id}, {@code action}, {@code actions}, {@code visible}, {@code mold}, {@code eventListenerMap}, {@code widgetListeners}, {@code widgetOverrides}, {@code clientAttributes}, {@code left}, {@code top}, {@code zIndex}, {@code height}, {@code width}, {@code tooltiptext}, {@code zclass}, {@code sclass}, {@code style}, {@code draggable}, {@code focus}, {@code droppable}, {@code vflex}, {@code hflex}, {@code renderdefer}, {@code clientAction}, {@code tabindex}, {@code ctrlKeys}, {@code context}, {@code popup}, {@code tooltip}, {@code children}, {@code widgetClass}, {@code preload}, {@code poster}, {@code crossorigin}, {@code content}, {@code src}, {@code autoplay}, {@code controls}, {@code loop}, {@code dimBackground}, {@code playsinline}, {@code clipToFit}, {@code playbackRate}, {@code volume}, {@code muted}.
   * @return hashCode value
   */
  @Override
  public int hashCode() {
    int h = 5381;
    h += (h << 5) + id.hashCode();
    h += (h << 5) + Objects.hashCode(action);
    h += (h << 5) + Objects.hashCode(actions);
    h += (h << 5) + Booleans.hashCode(visible);
    h += (h << 5) + mold.hashCode();
    h += (h << 5) + Objects.hashCode(eventListenerMap);
    h += (h << 5) + Objects.hashCode(widgetListeners);
    h += (h << 5) + Objects.hashCode(widgetOverrides);
    h += (h << 5) + Objects.hashCode(clientAttributes);
    h += (h << 5) + Objects.hashCode(left);
    h += (h << 5) + Objects.hashCode(top);
    h += (h << 5) + zIndex;
    h += (h << 5) + Objects.hashCode(height);
    h += (h << 5) + Objects.hashCode(width);
    h += (h << 5) + Objects.hashCode(tooltiptext);
    h += (h << 5) + Objects.hashCode(zclass);
    h += (h << 5) + Objects.hashCode(sclass);
    h += (h << 5) + Objects.hashCode(style);
    h += (h << 5) + draggable.hashCode();
    h += (h << 5) + Booleans.hashCode(focus);
    h += (h << 5) + droppable.hashCode();
    h += (h << 5) + Objects.hashCode(vflex);
    h += (h << 5) + Objects.hashCode(hflex);
    h += (h << 5) + renderdefer;
    h += (h << 5) + Objects.hashCode(clientAction);
    h += (h << 5) + Objects.hashCode(tabindex);
    h += (h << 5) + Objects.hashCode(ctrlKeys);
    h += (h << 5) + Objects.hashCode(context);
    h += (h << 5) + Objects.hashCode(popup);
    h += (h << 5) + Objects.hashCode(tooltip);
    h += (h << 5) + children.hashCode();
    h += (h << 5) + widgetClass.hashCode();
    h += (h << 5) + Objects.hashCode(preload);
    h += (h << 5) + Objects.hashCode(poster);
    h += (h << 5) + Objects.hashCode(crossorigin);
    h += (h << 5) + Objects.hashCode(content);
    h += (h << 5) + src.hashCode();
    h += (h << 5) + Booleans.hashCode(autoplay);
    h += (h << 5) + Booleans.hashCode(controls);
    h += (h << 5) + Booleans.hashCode(loop);
    h += (h << 5) + Booleans.hashCode(dimBackground);
    h += (h << 5) + Booleans.hashCode(playsinline);
    h += (h << 5) + Booleans.hashCode(clipToFit);
    h += (h << 5) + Doubles.hashCode(playbackRate);
    h += (h << 5) + Doubles.hashCode(volume);
    h += (h << 5) + Booleans.hashCode(muted);
    return h;
  }

  /**
   * Prints the immutable value {@code IVideo} with attribute values.
   * @return A string representation of the value
   */
  @Override
  public String toString() {
    return MoreObjects.toStringHelper("IVideo")
        .omitNullValues()
        .add("id", id)
        .add("action", action)
        .add("actions", actions)
        .add("visible", visible)
        .add("mold", mold)
        .add("eventListenerMap", eventListenerMap)
        .add("widgetListeners", widgetListeners)
        .add("widgetOverrides", widgetOverrides)
        .add("clientAttributes", clientAttributes)
        .add("left", left)
        .add("top", top)
        .add("zIndex", zIndex)
        .add("height", height)
        .add("width", width)
        .add("tooltiptext", tooltiptext)
        .add("zclass", zclass)
        .add("sclass", sclass)
        .add("style", style)
        .add("draggable", draggable)
        .add("focus", focus)
        .add("droppable", droppable)
        .add("vflex", vflex)
        .add("hflex", hflex)
        .add("renderdefer", renderdefer)
        .add("clientAction", clientAction)
        .add("tabindex", tabindex)
        .add("ctrlKeys", ctrlKeys)
        .add("context", context)
        .add("popup", popup)
        .add("tooltip", tooltip)
        .add("children", children)
        .add("widgetClass", widgetClass)
        .add("preload", preload)
        .add("poster", poster)
        .add("crossorigin", crossorigin)
        .add("content", content)
        .add("src", src)
        .add("autoplay", autoplay)
        .add("controls", controls)
        .add("loop", loop)
        .add("dimBackground", dimBackground)
        .add("playsinline", playsinline)
        .add("clipToFit", clipToFit)
        .add("playbackRate", playbackRate)
        .add("volume", volume)
        .add("muted", muted)
        .toString();
  }

  private transient volatile long lazyInitBitmap;

  private static final long Z_K_TYPE_LAZY_INIT_BIT = 0x1L;

  private transient Class<org.zkoss.zkmax.zul.Video> zKType;

  /**
   * {@inheritDoc}
   * <p>
   * Returns a lazily initialized value of the {@link IVideo#getZKType() zKType} attribute.
   * Initialized once and only once and stored for subsequent access with proper synchronization.
   * In case of any exception or error thrown by the lazy value initializer,
   * the result will not be memoised (i.e. remembered) and on next call computation
   * will be attempted again.
   * @return A lazily initialized value of the {@code zKType} attribute
   */
  @Override
  public Class<org.zkoss.zkmax.zul.Video> getZKType() {
    if ((lazyInitBitmap & Z_K_TYPE_LAZY_INIT_BIT) == 0) {
      synchronized (this) {
        if ((lazyInitBitmap & Z_K_TYPE_LAZY_INIT_BIT) == 0) {
          this.zKType = Objects.requireNonNull(IVideo.super.getZKType(), "zKType");
          lazyInitBitmap |= Z_K_TYPE_LAZY_INIT_BIT;
        }
      }
    }
    return zKType;
  }

  private static ImmutableIVideo validate(ImmutableIVideo instance) {
    instance.checkVolume();
    instance.checkHflexAndWidth();
    instance.checkVflexAndHeight();
    instance = (ImmutableIVideo) instance.checkDroppable();
    instance = (ImmutableIVideo) instance.checkDraggable();
    instance.checkActions();
    return instance;
  }

  /**
   * Creates an immutable copy of a {@link IVideo} value.
   * Uses accessors to get values to initialize the new immutable instance.
   * If an instance is already immutable, it is returned as is.
   * @param instance The instance to copy
   * @return A copied immutable IVideo instance
   */
  public static IVideo copyOf(IVideo instance) {
    if (instance instanceof ImmutableIVideo) {
      return (ImmutableIVideo) instance;
    }
    return new IVideo.Builder()
        .from(instance)
        .build();
  }

  /**
   * Builds instances of type {@link IVideo IVideo}.
   * Initialize attributes and then invoke the {@link #build()} method to create an
   * immutable instance.
   * <p><em>{@code Builder} is not thread-safe and generally should not be stored in a field or collection,
   * but instead used immediately to create instances.</em>
   */
  @Generated(from = "IVideo", generator = "Immutables")
  @NotThreadSafe
  public static class Builder {
    private static final long OPT_BIT_VISIBLE = 0x1L;
    private static final long OPT_BIT_Z_INDEX = 0x2L;
    private static final long OPT_BIT_FOCUS = 0x4L;
    private static final long OPT_BIT_RENDERDEFER = 0x8L;
    private static final long OPT_BIT_SRC = 0x10L;
    private static final long OPT_BIT_AUTOPLAY = 0x20L;
    private static final long OPT_BIT_CONTROLS = 0x40L;
    private static final long OPT_BIT_LOOP = 0x80L;
    private static final long OPT_BIT_DIM_BACKGROUND = 0x100L;
    private static final long OPT_BIT_PLAYSINLINE = 0x200L;
    private static final long OPT_BIT_CLIP_TO_FIT = 0x400L;
    private static final long OPT_BIT_PLAYBACK_RATE = 0x800L;
    private static final long OPT_BIT_VOLUME = 0x1000L;
    private static final long OPT_BIT_MUTED = 0x2000L;
    private long optBits;

    private @Nullable String id;
    private @Nullable ActionHandler action;
    private ImmutableList.Builder<ActionHandler> actions = null;
    private boolean visible;
    private @Nullable String mold;
    private @Nullable EventListenerMap eventListenerMap;
    private ImmutableMap.Builder<String, String> widgetListeners = null;
    private ImmutableMap.Builder<String, String> widgetOverrides = null;
    private ImmutableMap.Builder<String, String> clientAttributes = null;
    private @Nullable String left;
    private @Nullable String top;
    private int zIndex;
    private @Nullable String height;
    private @Nullable String width;
    private @Nullable String tooltiptext;
    private @Nullable String zclass;
    private @Nullable String sclass;
    private @Nullable String style;
    private @Nullable String draggable;
    private boolean focus;
    private @Nullable String droppable;
    private @Nullable String vflex;
    private @Nullable String hflex;
    private int renderdefer;
    private @Nullable String clientAction;
    private @Nullable Integer tabindex;
    private @Nullable String ctrlKeys;
    private @Nullable String context;
    private @Nullable String popup;
    private @Nullable String tooltip;
    private ImmutableList.Builder<ITrack> children = ImmutableList.builder();
    private @Nullable String widgetClass;
    private @Nullable String preload;
    private @Nullable String poster;
    private @Nullable String crossorigin;
    private @Nullable Video content;
    private ImmutableList.Builder<String> src = ImmutableList.builder();
    private boolean autoplay;
    private boolean controls;
    private boolean loop;
    private boolean dimBackground;
    private boolean playsinline;
    private boolean clipToFit;
    private double playbackRate;
    private double volume;
    private boolean muted;

    /**
     * Creates a builder for {@link IVideo IVideo} instances.
     * <pre>
     * new IVideo.Builder()
     *    .setId(String) // optional {@link IVideo#getId() id}
     *    .setAction(org.zkoss.stateless.util.ActionHandler | null) // nullable {@link IVideo#getAction() action}
     *    .setActions(List&amp;lt;org.zkoss.stateless.util.ActionHandler&amp;gt; | null) // nullable {@link IVideo#getActions() actions}
     *    .setVisible(boolean) // optional {@link IVideo#isVisible() visible}
     *    .setMold(String) // optional {@link IVideo#getMold() mold}
     *    .setEventListenerMap(org.zkoss.zk.ui.sys.EventListenerMap | null) // nullable {@link IVideo#getEventListenerMap() eventListenerMap}
     *    .setWidgetListeners(Map&amp;lt;String, String&amp;gt; | null) // nullable {@link IVideo#getWidgetListeners() widgetListeners}
     *    .setWidgetOverrides(Map&amp;lt;String, String&amp;gt; | null) // nullable {@link IVideo#getWidgetOverrides() widgetOverrides}
     *    .setClientAttributes(Map&amp;lt;String, String&amp;gt; | null) // nullable {@link IVideo#getClientAttributes() clientAttributes}
     *    .setLeft(String | null) // nullable {@link IVideo#getLeft() left}
     *    .setTop(String | null) // nullable {@link IVideo#getTop() top}
     *    .setZIndex(int) // optional {@link IVideo#getZIndex() zIndex}
     *    .setHeight(String | null) // nullable {@link IVideo#getHeight() height}
     *    .setWidth(String | null) // nullable {@link IVideo#getWidth() width}
     *    .setTooltiptext(String | null) // nullable {@link IVideo#getTooltiptext() tooltiptext}
     *    .setZclass(String | null) // nullable {@link IVideo#getZclass() zclass}
     *    .setSclass(String | null) // nullable {@link IVideo#getSclass() sclass}
     *    .setStyle(String | null) // nullable {@link IVideo#getStyle() style}
     *    .setDraggable(String) // optional {@link IVideo#getDraggable() draggable}
     *    .setFocus(boolean) // optional {@link IVideo#isFocus() focus}
     *    .setDroppable(String) // optional {@link IVideo#getDroppable() droppable}
     *    .setVflex(String | null) // nullable {@link IVideo#getVflex() vflex}
     *    .setHflex(String | null) // nullable {@link IVideo#getHflex() hflex}
     *    .setRenderdefer(int) // optional {@link IVideo#getRenderdefer() renderdefer}
     *    .setClientAction(String | null) // nullable {@link IVideo#getClientAction() clientAction}
     *    .setTabindex(Integer | null) // nullable {@link IVideo#getTabindex() tabindex}
     *    .setCtrlKeys(String | null) // nullable {@link IVideo#getCtrlKeys() ctrlKeys}
     *    .setContext(String | null) // nullable {@link IVideo#getContext() context}
     *    .setPopup(String | null) // nullable {@link IVideo#getPopup() popup}
     *    .setTooltip(String | null) // nullable {@link IVideo#getTooltip() tooltip}
     *    .addChildren|addAllChildren(org.zkoss.stateless.sul.ITrack) // {@link IVideo#getChildren() children} elements
     *    .setWidgetClass(String) // optional {@link IVideo#getWidgetClass() widgetClass}
     *    .setPreload(String | null) // nullable {@link IVideo#getPreload() preload}
     *    .setPoster(String | null) // nullable {@link IVideo#getPoster() poster}
     *    .setCrossorigin(String | null) // nullable {@link IVideo#getCrossorigin() crossorigin}
     *    .setContent(org.zkoss.video.Video | null) // nullable {@link IVideo#getContent() content}
     *    .addSrc|addAllSrc(String) // {@link IVideo#getSrc() src} elements
     *    .setAutoplay(boolean) // optional {@link IVideo#isAutoplay() autoplay}
     *    .setControls(boolean) // optional {@link IVideo#isControls() controls}
     *    .setLoop(boolean) // optional {@link IVideo#isLoop() loop}
     *    .setDimBackground(boolean) // optional {@link IVideo#isDimBackground() dimBackground}
     *    .setPlaysinline(boolean) // optional {@link IVideo#isPlaysinline() playsinline}
     *    .setClipToFit(boolean) // optional {@link IVideo#isClipToFit() clipToFit}
     *    .setPlaybackRate(double) // optional {@link IVideo#getPlaybackRate() playbackRate}
     *    .setVolume(double) // optional {@link IVideo#getVolume() volume}
     *    .setMuted(boolean) // optional {@link IVideo#isMuted() muted}
     *    .build();
     * </pre>
     */
    public Builder() {
      if (!(this instanceof IVideo.Builder)) {
        throw new UnsupportedOperationException("Use: new IVideo.Builder()");
      }
    }

    /**
     * Fill a builder with attribute values from the provided {@code IVideo} instance.
     * Regular attribute values will be replaced with those from the given instance.
     * Absent optional values will not replace present values.
     * Collection elements and entries will be added, not replaced.
     * @param instance The instance from which to copy values
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder from(IVideo instance) {
      Objects.requireNonNull(instance, "instance");
      setId(instance.getId());
      @Nullable ActionHandler actionValue = instance.getAction();
      if (actionValue != null) {
        setAction(actionValue);
      }
      @Nullable List<ActionHandler> actionsValue = instance.getActions();
      if (actionsValue != null) {
        addAllActions(actionsValue);
      }
      setVisible(instance.isVisible());
      setMold(instance.getMold());
      @Nullable EventListenerMap eventListenerMapValue = instance.getEventListenerMap();
      if (eventListenerMapValue != null) {
        setEventListenerMap(eventListenerMapValue);
      }
      @Nullable Map<String, String> widgetListenersValue = instance.getWidgetListeners();
      if (widgetListenersValue != null) {
        putAllWidgetListeners(widgetListenersValue);
      }
      @Nullable Map<String, String> widgetOverridesValue = instance.getWidgetOverrides();
      if (widgetOverridesValue != null) {
        putAllWidgetOverrides(widgetOverridesValue);
      }
      @Nullable Map<String, String> clientAttributesValue = instance.getClientAttributes();
      if (clientAttributesValue != null) {
        putAllClientAttributes(clientAttributesValue);
      }
      @Nullable String leftValue = instance.getLeft();
      if (leftValue != null) {
        setLeft(leftValue);
      }
      @Nullable String topValue = instance.getTop();
      if (topValue != null) {
        setTop(topValue);
      }
      setZIndex(instance.getZIndex());
      @Nullable String heightValue = instance.getHeight();
      if (heightValue != null) {
        setHeight(heightValue);
      }
      @Nullable String widthValue = instance.getWidth();
      if (widthValue != null) {
        setWidth(widthValue);
      }
      @Nullable String tooltiptextValue = instance.getTooltiptext();
      if (tooltiptextValue != null) {
        setTooltiptext(tooltiptextValue);
      }
      @Nullable String zclassValue = instance.getZclass();
      if (zclassValue != null) {
        setZclass(zclassValue);
      }
      @Nullable String sclassValue = instance.getSclass();
      if (sclassValue != null) {
        setSclass(sclassValue);
      }
      @Nullable String styleValue = instance.getStyle();
      if (styleValue != null) {
        setStyle(styleValue);
      }
      setDraggable(instance.getDraggable());
      setFocus(instance.isFocus());
      setDroppable(instance.getDroppable());
      @Nullable String vflexValue = instance.getVflex();
      if (vflexValue != null) {
        setVflex(vflexValue);
      }
      @Nullable String hflexValue = instance.getHflex();
      if (hflexValue != null) {
        setHflex(hflexValue);
      }
      setRenderdefer(instance.getRenderdefer());
      @Nullable String clientActionValue = instance.getClientAction();
      if (clientActionValue != null) {
        setClientAction(clientActionValue);
      }
      @Nullable Integer tabindexValue = instance.getTabindex();
      if (tabindexValue != null) {
        setTabindex(tabindexValue);
      }
      @Nullable String ctrlKeysValue = instance.getCtrlKeys();
      if (ctrlKeysValue != null) {
        setCtrlKeys(ctrlKeysValue);
      }
      @Nullable String contextValue = instance.getContext();
      if (contextValue != null) {
        setContext(contextValue);
      }
      @Nullable String popupValue = instance.getPopup();
      if (popupValue != null) {
        setPopup(popupValue);
      }
      @Nullable String tooltipValue = instance.getTooltip();
      if (tooltipValue != null) {
        setTooltip(tooltipValue);
      }
      addAllChildren(instance.getChildren());
      setWidgetClass(instance.getWidgetClass());
      @Nullable String preloadValue = instance.getPreload();
      if (preloadValue != null) {
        setPreload(preloadValue);
      }
      @Nullable String posterValue = instance.getPoster();
      if (posterValue != null) {
        setPoster(posterValue);
      }
      @Nullable String crossoriginValue = instance.getCrossorigin();
      if (crossoriginValue != null) {
        setCrossorigin(crossoriginValue);
      }
      @Nullable Video contentValue = instance.getContent();
      if (contentValue != null) {
        setContent(contentValue);
      }
      addAllSrc(instance.getSrc());
      setAutoplay(instance.isAutoplay());
      setControls(instance.isControls());
      setLoop(instance.isLoop());
      setDimBackground(instance.isDimBackground());
      setPlaysinline(instance.isPlaysinline());
      setClipToFit(instance.isClipToFit());
      setPlaybackRate(instance.getPlaybackRate());
      setVolume(instance.getVolume());
      setMuted(instance.isMuted());
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getId() id} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#getId() id}.</em>
     * @param id The value for id 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setId(String id) {
      this.id = Objects.requireNonNull(id, "id");
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getAction() action} attribute.
     * @param action The value for action (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setAction(@Nullable ActionHandler action) {
      this.action = action;
      return (IVideo.Builder) this;
    }

    /**
     * Adds one element to {@link IVideo#getActions() actions} list.
     * @param element A actions element
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder addActions(ActionHandler element) {
      if (this.actions == null) {
        this.actions = ImmutableList.builder();
      }
      this.actions.add(element);
      return (IVideo.Builder) this;
    }

    /**
     * Adds elements to {@link IVideo#getActions() actions} list.
     * @param elements An array of actions elements
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder addActions(ActionHandler... elements) {
      if (this.actions == null) {
        this.actions = ImmutableList.builder();
      }
      this.actions.add(elements);
      return (IVideo.Builder) this;
    }


    /**
     * Sets or replaces all elements for {@link IVideo#getActions() actions} list.
     * @param elements An iterable of actions elements
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setActions(@Nullable Iterable<? extends ActionHandler> elements) {
      if (elements == null) {
        this.actions = null;
        return (IVideo.Builder) this;
      }
      this.actions = ImmutableList.builder();
      return addAllActions(elements);
    }

    /**
     * Adds elements to {@link IVideo#getActions() actions} list.
     * @param elements An iterable of actions elements
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder addAllActions(Iterable<? extends ActionHandler> elements) {
      Objects.requireNonNull(elements, "actions element");
      if (this.actions == null) {
        this.actions = ImmutableList.builder();
      }
      this.actions.addAll(elements);
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#isVisible() visible} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#isVisible() visible}.</em>
     * @param visible The value for visible 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setVisible(boolean visible) {
      this.visible = visible;
      optBits |= OPT_BIT_VISIBLE;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getMold() mold} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#getMold() mold}.</em>
     * @param mold The value for mold 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setMold(String mold) {
      this.mold = Objects.requireNonNull(mold, "mold");
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getEventListenerMap() eventListenerMap} attribute.
     * @param eventListenerMap The value for eventListenerMap (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setEventListenerMap(@Nullable EventListenerMap eventListenerMap) {
      this.eventListenerMap = eventListenerMap;
      return (IVideo.Builder) this;
    }

    /**
     * Put one entry to the {@link IVideo#getWidgetListeners() widgetListeners} map.
     * @param key The key in the widgetListeners map
     * @param value The associated value in the widgetListeners map
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder putWidgetListeners(String key, String value) {
      if (this.widgetListeners == null) {
        this.widgetListeners = ImmutableMap.builder();
      }
      this.widgetListeners.put(key, value);
      return (IVideo.Builder) this;
    }

    /**
     * Put one entry to the {@link IVideo#getWidgetListeners() widgetListeners} map. Nulls are not permitted
     * @param entry The key and value entry
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder putWidgetListeners(Map.Entry<String, ? extends String> entry) {
      if (this.widgetListeners == null) {
        this.widgetListeners = ImmutableMap.builder();
      }
      this.widgetListeners.put(entry);
      return (IVideo.Builder) this;
    }

    /**
     * Sets or replaces all mappings from the specified map as entries for the {@link IVideo#getWidgetListeners() widgetListeners} map. Nulls are not permitted as keys or values, but parameter itself can be null
     * @param entries The entries that will be added to the widgetListeners map
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setWidgetListeners(@Nullable Map<String, ? extends String> entries) {
      if (entries == null) {
        this.widgetListeners = null;
        return (IVideo.Builder) this;
      }
      this.widgetListeners = ImmutableMap.builder();
      return putAllWidgetListeners(entries);
    }

    /**
     * Put all mappings from the specified map as entries to {@link IVideo#getWidgetListeners() widgetListeners} map. Nulls are not permitted
     * @param entries The entries that will be added to the widgetListeners map
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder putAllWidgetListeners(Map<String, ? extends String> entries) {
      if (this.widgetListeners == null) {
        this.widgetListeners = ImmutableMap.builder();
      }
      this.widgetListeners.putAll(entries);
      return (IVideo.Builder) this;
    }

    /**
     * Put one entry to the {@link IVideo#getWidgetOverrides() widgetOverrides} map.
     * @param key The key in the widgetOverrides map
     * @param value The associated value in the widgetOverrides map
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder putWidgetOverrides(String key, String value) {
      if (this.widgetOverrides == null) {
        this.widgetOverrides = ImmutableMap.builder();
      }
      this.widgetOverrides.put(key, value);
      return (IVideo.Builder) this;
    }

    /**
     * Put one entry to the {@link IVideo#getWidgetOverrides() widgetOverrides} map. Nulls are not permitted
     * @param entry The key and value entry
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder putWidgetOverrides(Map.Entry<String, ? extends String> entry) {
      if (this.widgetOverrides == null) {
        this.widgetOverrides = ImmutableMap.builder();
      }
      this.widgetOverrides.put(entry);
      return (IVideo.Builder) this;
    }

    /**
     * Sets or replaces all mappings from the specified map as entries for the {@link IVideo#getWidgetOverrides() widgetOverrides} map. Nulls are not permitted as keys or values, but parameter itself can be null
     * @param entries The entries that will be added to the widgetOverrides map
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setWidgetOverrides(@Nullable Map<String, ? extends String> entries) {
      if (entries == null) {
        this.widgetOverrides = null;
        return (IVideo.Builder) this;
      }
      this.widgetOverrides = ImmutableMap.builder();
      return putAllWidgetOverrides(entries);
    }

    /**
     * Put all mappings from the specified map as entries to {@link IVideo#getWidgetOverrides() widgetOverrides} map. Nulls are not permitted
     * @param entries The entries that will be added to the widgetOverrides map
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder putAllWidgetOverrides(Map<String, ? extends String> entries) {
      if (this.widgetOverrides == null) {
        this.widgetOverrides = ImmutableMap.builder();
      }
      this.widgetOverrides.putAll(entries);
      return (IVideo.Builder) this;
    }

    /**
     * Put one entry to the {@link IVideo#getClientAttributes() clientAttributes} map.
     * @param key The key in the clientAttributes map
     * @param value The associated value in the clientAttributes map
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder putClientAttributes(String key, String value) {
      if (this.clientAttributes == null) {
        this.clientAttributes = ImmutableMap.builder();
      }
      this.clientAttributes.put(key, value);
      return (IVideo.Builder) this;
    }

    /**
     * Put one entry to the {@link IVideo#getClientAttributes() clientAttributes} map. Nulls are not permitted
     * @param entry The key and value entry
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder putClientAttributes(Map.Entry<String, ? extends String> entry) {
      if (this.clientAttributes == null) {
        this.clientAttributes = ImmutableMap.builder();
      }
      this.clientAttributes.put(entry);
      return (IVideo.Builder) this;
    }

    /**
     * Sets or replaces all mappings from the specified map as entries for the {@link IVideo#getClientAttributes() clientAttributes} map. Nulls are not permitted as keys or values, but parameter itself can be null
     * @param entries The entries that will be added to the clientAttributes map
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setClientAttributes(@Nullable Map<String, ? extends String> entries) {
      if (entries == null) {
        this.clientAttributes = null;
        return (IVideo.Builder) this;
      }
      this.clientAttributes = ImmutableMap.builder();
      return putAllClientAttributes(entries);
    }

    /**
     * Put all mappings from the specified map as entries to {@link IVideo#getClientAttributes() clientAttributes} map. Nulls are not permitted
     * @param entries The entries that will be added to the clientAttributes map
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder putAllClientAttributes(Map<String, ? extends String> entries) {
      if (this.clientAttributes == null) {
        this.clientAttributes = ImmutableMap.builder();
      }
      this.clientAttributes.putAll(entries);
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getLeft() left} attribute.
     * @param left The value for left (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setLeft(@Nullable String left) {
      this.left = left;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getTop() top} attribute.
     * @param top The value for top (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setTop(@Nullable String top) {
      this.top = top;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getZIndex() zIndex} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#getZIndex() zIndex}.</em>
     * @param zIndex The value for zIndex 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setZIndex(int zIndex) {
      this.zIndex = zIndex;
      optBits |= OPT_BIT_Z_INDEX;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getHeight() height} attribute.
     * @param height The value for height (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setHeight(@Nullable String height) {
      this.height = height;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getWidth() width} attribute.
     * @param width The value for width (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setWidth(@Nullable String width) {
      this.width = width;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getTooltiptext() tooltiptext} attribute.
     * @param tooltiptext The value for tooltiptext (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setTooltiptext(@Nullable String tooltiptext) {
      this.tooltiptext = tooltiptext;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getZclass() zclass} attribute.
     * @param zclass The value for zclass (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setZclass(@Nullable String zclass) {
      this.zclass = zclass;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getSclass() sclass} attribute.
     * @param sclass The value for sclass (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setSclass(@Nullable String sclass) {
      this.sclass = sclass;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getStyle() style} attribute.
     * @param style The value for style (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setStyle(@Nullable String style) {
      this.style = style;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getDraggable() draggable} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#getDraggable() draggable}.</em>
     * @param draggable The value for draggable 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setDraggable(String draggable) {
      this.draggable = Objects.requireNonNull(draggable, "draggable");
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#isFocus() focus} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#isFocus() focus}.</em>
     * @param focus The value for focus 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setFocus(boolean focus) {
      this.focus = focus;
      optBits |= OPT_BIT_FOCUS;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getDroppable() droppable} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#getDroppable() droppable}.</em>
     * @param droppable The value for droppable 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setDroppable(String droppable) {
      this.droppable = Objects.requireNonNull(droppable, "droppable");
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getVflex() vflex} attribute.
     * @param vflex The value for vflex (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setVflex(@Nullable String vflex) {
      this.vflex = vflex;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getHflex() hflex} attribute.
     * @param hflex The value for hflex (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setHflex(@Nullable String hflex) {
      this.hflex = hflex;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getRenderdefer() renderdefer} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#getRenderdefer() renderdefer}.</em>
     * @param renderdefer The value for renderdefer 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setRenderdefer(int renderdefer) {
      this.renderdefer = renderdefer;
      optBits |= OPT_BIT_RENDERDEFER;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getClientAction() clientAction} attribute.
     * @param clientAction The value for clientAction (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setClientAction(@Nullable String clientAction) {
      this.clientAction = clientAction;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getTabindex() tabindex} attribute.
     * @param tabindex The value for tabindex (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setTabindex(@Nullable Integer tabindex) {
      this.tabindex = tabindex;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getCtrlKeys() ctrlKeys} attribute.
     * @param ctrlKeys The value for ctrlKeys (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setCtrlKeys(@Nullable String ctrlKeys) {
      this.ctrlKeys = ctrlKeys;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getContext() context} attribute.
     * @param context The value for context (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setContext(@Nullable String context) {
      this.context = context;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getPopup() popup} attribute.
     * @param popup The value for popup (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setPopup(@Nullable String popup) {
      this.popup = popup;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getTooltip() tooltip} attribute.
     * @param tooltip The value for tooltip (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setTooltip(@Nullable String tooltip) {
      this.tooltip = tooltip;
      return (IVideo.Builder) this;
    }

    /**
     * Adds one element to {@link IVideo#getChildren() children} list.
     * @param element A children element
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder addChildren(ITrack element) {
      this.children.add(element);
      return (IVideo.Builder) this;
    }

    /**
     * Adds elements to {@link IVideo#getChildren() children} list.
     * @param elements An array of children elements
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder addChildren(ITrack... elements) {
      this.children.add(elements);
      return (IVideo.Builder) this;
    }


    /**
     * Sets or replaces all elements for {@link IVideo#getChildren() children} list.
     * @param elements An iterable of children elements
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setChildren(Iterable<? extends ITrack> elements) {
      this.children = ImmutableList.builder();
      return addAllChildren(elements);
    }

    /**
     * Adds elements to {@link IVideo#getChildren() children} list.
     * @param elements An iterable of children elements
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder addAllChildren(Iterable<? extends ITrack> elements) {
      this.children.addAll(elements);
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getWidgetClass() widgetClass} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#getWidgetClass() widgetClass}.</em>
     * @param widgetClass The value for widgetClass 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setWidgetClass(String widgetClass) {
      this.widgetClass = Objects.requireNonNull(widgetClass, "widgetClass");
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getPreload() preload} attribute.
     * @param preload The value for preload (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setPreload(@Nullable String preload) {
      this.preload = preload;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getPoster() poster} attribute.
     * @param poster The value for poster (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setPoster(@Nullable String poster) {
      this.poster = poster;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getCrossorigin() crossorigin} attribute.
     * @param crossorigin The value for crossorigin (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setCrossorigin(@Nullable String crossorigin) {
      this.crossorigin = crossorigin;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getContent() content} attribute.
     * @param content The value for content (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setContent(@Nullable Video content) {
      this.content = content;
      return (IVideo.Builder) this;
    }

    /**
     * Adds one element to {@link IVideo#getSrc() src} list.
     * @param element A src element
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder addSrc(String element) {
      this.src.add(element);
      optBits |= OPT_BIT_SRC;
      return (IVideo.Builder) this;
    }

    /**
     * Adds elements to {@link IVideo#getSrc() src} list.
     * @param elements An array of src elements
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder addSrc(String... elements) {
      this.src.add(elements);
      optBits |= OPT_BIT_SRC;
      return (IVideo.Builder) this;
    }


    /**
     * Sets or replaces all elements for {@link IVideo#getSrc() src} list.
     * @param elements An iterable of src elements
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setSrc(Iterable<String> elements) {
      this.src = ImmutableList.builder();
      return addAllSrc(elements);
    }

    /**
     * Adds elements to {@link IVideo#getSrc() src} list.
     * @param elements An iterable of src elements
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder addAllSrc(Iterable<String> elements) {
      this.src.addAll(elements);
      optBits |= OPT_BIT_SRC;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#isAutoplay() autoplay} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#isAutoplay() autoplay}.</em>
     * @param autoplay The value for autoplay 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setAutoplay(boolean autoplay) {
      this.autoplay = autoplay;
      optBits |= OPT_BIT_AUTOPLAY;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#isControls() controls} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#isControls() controls}.</em>
     * @param controls The value for controls 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setControls(boolean controls) {
      this.controls = controls;
      optBits |= OPT_BIT_CONTROLS;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#isLoop() loop} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#isLoop() loop}.</em>
     * @param loop The value for loop 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setLoop(boolean loop) {
      this.loop = loop;
      optBits |= OPT_BIT_LOOP;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#isDimBackground() dimBackground} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#isDimBackground() dimBackground}.</em>
     * @param dimBackground The value for dimBackground 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setDimBackground(boolean dimBackground) {
      this.dimBackground = dimBackground;
      optBits |= OPT_BIT_DIM_BACKGROUND;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#isPlaysinline() playsinline} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#isPlaysinline() playsinline}.</em>
     * @param playsinline The value for playsinline 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setPlaysinline(boolean playsinline) {
      this.playsinline = playsinline;
      optBits |= OPT_BIT_PLAYSINLINE;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#isClipToFit() clipToFit} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#isClipToFit() clipToFit}.</em>
     * @param clipToFit The value for clipToFit 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setClipToFit(boolean clipToFit) {
      this.clipToFit = clipToFit;
      optBits |= OPT_BIT_CLIP_TO_FIT;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getPlaybackRate() playbackRate} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#getPlaybackRate() playbackRate}.</em>
     * @param playbackRate The value for playbackRate 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setPlaybackRate(double playbackRate) {
      this.playbackRate = playbackRate;
      optBits |= OPT_BIT_PLAYBACK_RATE;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#getVolume() volume} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#getVolume() volume}.</em>
     * @param volume The value for volume 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setVolume(double volume) {
      this.volume = volume;
      optBits |= OPT_BIT_VOLUME;
      return (IVideo.Builder) this;
    }

    /**
     * Initializes the value for the {@link IVideo#isMuted() muted} attribute.
     * <p><em>If not set, this attribute will have a default value as returned by the initializer of {@link IVideo#isMuted() muted}.</em>
     * @param muted The value for muted 
     * @return {@code this} builder for use in a chained invocation
     */
    public final IVideo.Builder setMuted(boolean muted) {
      this.muted = muted;
      optBits |= OPT_BIT_MUTED;
      return (IVideo.Builder) this;
    }

    /**
     * Builds a new {@link IVideo IVideo}.
     * @return An immutable instance of IVideo
     * @throws java.lang.IllegalStateException if any required attributes are missing
     */
    public IVideo build() {
      return ImmutableIVideo.validate(new ImmutableIVideo(this));
    }

    private boolean visibleIsSet() {
      return (optBits & OPT_BIT_VISIBLE) != 0;
    }

    private boolean zIndexIsSet() {
      return (optBits & OPT_BIT_Z_INDEX) != 0;
    }

    private boolean focusIsSet() {
      return (optBits & OPT_BIT_FOCUS) != 0;
    }

    private boolean renderdeferIsSet() {
      return (optBits & OPT_BIT_RENDERDEFER) != 0;
    }

    private boolean srcIsSet() {
      return (optBits & OPT_BIT_SRC) != 0;
    }

    private boolean autoplayIsSet() {
      return (optBits & OPT_BIT_AUTOPLAY) != 0;
    }

    private boolean controlsIsSet() {
      return (optBits & OPT_BIT_CONTROLS) != 0;
    }

    private boolean loopIsSet() {
      return (optBits & OPT_BIT_LOOP) != 0;
    }

    private boolean dimBackgroundIsSet() {
      return (optBits & OPT_BIT_DIM_BACKGROUND) != 0;
    }

    private boolean playsinlineIsSet() {
      return (optBits & OPT_BIT_PLAYSINLINE) != 0;
    }

    private boolean clipToFitIsSet() {
      return (optBits & OPT_BIT_CLIP_TO_FIT) != 0;
    }

    private boolean playbackRateIsSet() {
      return (optBits & OPT_BIT_PLAYBACK_RATE) != 0;
    }

    private boolean volumeIsSet() {
      return (optBits & OPT_BIT_VOLUME) != 0;
    }

    private boolean mutedIsSet() {
      return (optBits & OPT_BIT_MUTED) != 0;
    }
  }
}
